   VTMOP for libEnsemble: Solving blackbox MOPs with libEnsemble

VTMOP is a Fortran 2008 package containing a robust, portable solver and
a flexible framework for solving MOPs. Designed for efficiency and
scalability to an arbitrary number of objectives, VTMOP attempts to generate
uniformly spaced points on a (possibly nonconvex) Pareto front with minimal
cost function evaluations.

This directory contains a minimal copy of VTMOP, containing only the
subroutines and dependencies that are used by the libEnsemble interface.

A Fortran interface for the VTMOP subroutines used by libEnsemble is given in
vtmop_libe.f90. It contains a module VTMOP_LIBE_MOD, which contains two
subroutines VTMOP_LIBE_INIT(...) and VTMOP_LIBE_GENERATE(...). See the headers
for those subroutines for the full interface and usage information.

The files fmodpy_simplified_vtmop_libe.f90 and vtmop_libe_c_wrapper.f90
are wrapper files generated by fmodpy, for calling vtmop_libe.f90 in C/C++.
The file __init__.py was also generated by fmodpy, and contains instructions
for building all the C and Fortran binaries, and an interface for calling
the C wrapper in Python.

To use the Python interface, first import the Python module:
 - from [this directory] import vtmop_libe_mod
Then call the wrapped subroutines
 - vtmop_libe_mod.vtmop_libe_init(...)
 - vtmop_libe_mod.vtmop_libe_generate(...)

The first time that vtmop_libe_mod is imported, the __init__.py file will
automatically attempt to compile the binaries using gfortran. gfortran
is no longer needed after the binaries have been generated. If you would
like to build with a different compiler, edit lines 16 and 20 of __init__.py,
as necessary.

In summary, the following files are contained in this directory:

 - The file depend_graph.txt contains a diagram of the dependency tree for the
   minimal copy of VTMOP.
 - The file __init__.py contains a Python wrapper for vtmop_libe.f90,
   containing a Python instance of the module vtmop_libe_mod.
 - The file vtmop_libe.f90 contains a Fortran interface for the VTMOP
   subroutines used by libEnsemble.
 - fmodpy_simplified_vtmop_libe.f90 and vtmop_libe_c_wrapper.f90 are wrappers
   for vtmop_libe.f90, automatically generated using fmodpy.
   vtmop_libe_c_wrapper.f90 provides a C/C++ interface for the module.
 - The file vtmop.f90 is the main Fortran 2008 file containing a minimal copy
   of VTMOP.
 - The file delsparse.f90 contains the module and driver subroutines
   for DELAUNAYSPARSE (ACM TOMS Algorithm 1012).
 - The file linear_shepard.f90 is a Fortran 95 module for computing the LSHEP
   surrogate model (ACM TOMS Algorithm 905).
 - The file qnstop.f90 contains the LATINDESIGN function from QNSTOP
   (ACM TOMS Algorithm 1007).
 - The file shared_modules.f90 contains the REAL_PRECISION module, which is
   used for approximately 64 bit arithmetic.
 - The file slatec.f contains the subroutine DWNNLS and its dependencies
   from the SLATEC library. This library has been slightly modified to
   comply with the modern Fortran standards. Additionally, legacy
   implementations of the BLAS subroutines DROTM and DTROMG have been
   included under different names to avoid dependency issues.
 - The files lapack.f and blas.f contain all LAPACK and BLAS
   subroutines that are referenced (both directly and indirectly) in
   VTMOP or its dependencies.
 - A sample GNU (or Intel, by uncommenting lines 3 and 4) Makefile is provided.
   However, this Makefile is not needed since Python builds the binaries on
   import. The Makefile only exists for debugging purposes.

--------------------------------------------------------------------------------

For further inquiries, contact
Tyler Chang, tchang@anl.gov

The Python and C wrappers for this project were automatically generated using
fmodpy. Consider supporting fmodpy on GitHub: https://github.com/tchlux/fmodpy.

For more information on fmodpy and Fortran -> Python wrappers, contact
Thomas Lux, tchlux@vt.edu

To cite this work:
Chang, T.H., Larson, J., Watson, L.T., and Lux, T.C.H. Managing
computationally expensive blackbox multiobjective optimization problems
with libEnsemble. In Proc. 2020 Spring Simulation Conference (SpringSim '20),
Article No. 31, pp. 1–12. DOI: 10.22360/springsim.2020.hpc.001

List of balsam test jobs for libEnsemble.

test_balsam_1__runjobs.py:
Launches parallel parent job. Each job iterates over a loop launching sub-jobs
and waiting for completion. Does 3 iterations by default.

test_balsam_2__workerkill.py:
As first test but each top-level jobs kills its middle job.

test_balsam_3__managerkill.py:
Process 0 sends out a kill for jobs which include sim_id_1 in their name. This
will kill any such jobs in the database at the time of the kill. Note that if a
job has not yet been added to database at the time of the kill, it will still
run.

Note that test3 exploits the fact that balsam is built on a Django database,
and all Django functionality for manipulating the database can easily be
exposed.

This is a temporary location for testing executor interface
Note: libEnsemble must be installed
Should work with Balsam and standalone

Install libEnsemble in project root directory (where setup.py is) with either:

pip install .

or for developer build (if you want to make changes):

pip install -e .


For running on laptop/cluster
-----------------------------

Launch job with python E.g:

> python test_jobexecutor.py


For running with Balsam
-----------------------

1. You must install Balsam (https://balsam.alcf.anl.gov/)

2. For each time you start a new session: In this directory (executor_tests)
initialise database and start the database server by sourcing script
set.balsam.database.sh. You can modify the database location in the script.

> . set.balsam.database.sh

3. Check in test script the USE_BALSAM = True

4. To reset jobs before each run. Create a test app/job by running create_balsam_job.py for desired test E.g:

> ./create_balsam_job.py test_jobexecutor.py

You can see the created app/job by running:

> balsam ls apps

and:

> balsam ls jobs

5. Run tasks using the balsam launcher E.g:

> balsam launcher --consume-all

Note: On systems like Theta only one job can be launched per node. You will
need at least 2 nodes. The first will run the parent script. The test
test_jobexecutor_multi.py launches 3 sub-jobs which Balsam will launch as
nodes become available. To run all 3 concurrently would require 4 nodes.

Comms test
==========

This is a simplified standalone comms tests which is a very basic model of the
communications in libEnsemble.

The current test, only models the communications from workers to manager.

The test is easily configurable for size of data, rounds of communication, and
can be run on any number of processors. The data is initialized on each worker
using the processor ID. The manager checks the correct values are received.

The data is a dictionary containing a scalar and NumPy array. The size of the
NumPy array is given by <array_size>. The default is one million values. The
variable <rounds> determines the number of messages sent from each worker. Two
lines can be uncommented in the manager loop which gives the message count and
size of the received message in bytes.

The test can also be used for benchmarking.

Running, for example:

mpirun -np 64 python commtest.py
srun --ntasks 128 python commtest.py
aprun -n 256 -N 64 python commtest.py

Kill tests
==========

This is to test the killing of MPI tasks. There are two tests and different kill
methods which can be selected on the command line. The aim is that kills in
libEnsemble will be automatically configured to work correctly based on system
detection. However, this test will show what type of kill works for a given
system, and this may be configurable in libEnsemble in the future.

Test: sleep_and_print

The default test (sleep_and_print), should automatically test if all processes
of an MPI job are correctly killed and also that a second job can be launched
and killed.

Launching MPI tasks which write from each MPI task, at regular intervals, to an
output file (see sleep_and_print.c).

This test launches a job, then kills after a few seconds, and then monitors
output file to see if output continues. If the first job is successfully killed,
a second is launched and the test repeated.

Instructions
------------

Build the C program:
    mpicc -g -o sleep_and_print.x sleep_and_print.c
    OR (e.g. on Theta/Cori):
    cc -g -o sleep_and_print.x sleep_and_print.c

Either run on local node - or create an allocation of nodes and run::

    python killtest.py <kill_type> <num_nodes> <num_procs_per_node>

where kill_type currently is 1 or 2. [1 is the original kill - 2 is using
group ID approach]

E.g Single node with 4 processes:
--------------------------------
kill 1: python killtest.py 1 1 4
kill 2: python killtest.py 2 1 4
--------------------------------

E.g Two nodes with 2 processes each:
--------------------------------
kill 1: python killtest.py 1 2 2
kill 2: python killtest.py 2 2 2
--------------------------------

If the test fails, an assertion error will occur.

Output files are produced out_0.txt and out_1.txt (one for each job). These can
be deleted between runs.

## Running test run_libe_forces.py

Naive Electostatics Code Test

This is designed only as an artificial, highly conifurable test
code for a libEnsemble sim func.

### Forces Mini-App

A system of charged particles is set up and simulated over a number of time-steps.

Particles position and charge are initiated by a random stream.
Particles are replicated on all ranks.
**Each rank** computes forces for a subset of particles (O(N^2))
Particle force arrays are allreduced across ranks.
Particles are moved (replicated on each rank)
Total energy is appended to file forces.stat

To run forces as a standalone executable on N procs:

    mpirun -np N ./forces.x <NUM_PARTICLES> <NUM_TIMESTEPS> <SEED>

### Running with libEnsemble.

A random sample of seeds is taken and used as input to the sim func (forces miniapp).

Modify build_forces.sh for target platform and run to build forces.x:

    ./build_forces.sh

Then to run with local comms (multiprocessing) with one manager and `N` workers:

    python run_libe_forces.py --comms local --nworkers N

To run with MPI comms using one manager and `N-1` workers:

    mpirun -np N python run_libe_forces.py

Application parameters can be adjusted in the file `run_libe_forces.py`.

To remove output before the next run:

    ./cleanup.sh

### Using YAML in calling script (optional)

An alternative calling script `run_libe_forces_from_yaml.py` can be run in the same
way as `run_libe_forces.py` above. This uses an alternative libEnsemble interface, where
an ensemble object is created and parameters can be read from the `forces.yaml` file.

### Running with Balsam

To run with balsam, set `USE_BALSAM = True` in `run_libe_forces.py`.
You need to have followed the instructions to install `balsam` and set-up/activate a database.
(See https://github.com/argonne-lcf/balsam).

Then to test locally, run the `balsam_local.sh` script. The default runs with 2 workers.

    ./balsam_local.sh

The running tasks can be seen inside the balsam database dir `<DIR>/data/libe_workflow/`.
While the key output files will be copied back to the run dir at completion. Also see
the log in `<DIR>/log` if there are any issues. To run on batch systems, see the example
scripts such as `theta_submit_balsam.sh`.

### Using batch scripts

The scripts are set up assuming a conda environment. To use script directly you will need to replace the following templated values:

  <projectID> in the COBALT -A directive with your project ID.

  <conda_env_name> is the name of your conda environment.

and in Balsam scripts:

  <dbase_name> The name of an initialized balsam database.
               (with max_connections enough for number of workers)

The included scripts are.

* theta_submit_mproc.sh:

  Example Theta submission script to run libEnsemble in central mode on the Theta launch (MOM) nodes with multiprocessing worker concurrency.

* summit_submit_mproc.sh:

  Example Summit submission script to run libEnsemble in central mode on the Summit launch nodes with multiprocessing worker concurrency.

* theta_submit_balsam.sh:

  Example Theta submission script to run libEnsemble in central mode with MPI worker concurrency using Balsam. In this case libEnsemble manager and workers run on compute nodes and submit jobs via Balsam.

#### Plotting Options

If either of the plotting options in the submission scripts are set to true, the scripts must be in the directory specified by PLOT_DIR. These scripts can be found in the libEnsemble project in the postproc_scripts/ directory.

        export LIBE_PLOTS=true
        export BALSAM_PLOTS=true

#### Note on theta_submit_balsam.sh

Adjusting the node/core/worker count.: The NUM_WORKERS variable is only
currently used if libEnsemble is running on one node, in which case it should
be one less than the number of nodes in the job allocation (leaving one
dedicated node to run libEnsemble). If more workers are used then the variables
NUM_NODES and RANKS_PER_NODE need to be explicitly set (these are for
libEnsemble which will require one task for the manager and the rest will be
workers). The total node allocation (in the COBALT -n directive) will need to
be the number of nodes for libEnsemble + number of nodes for each worker to
launch jobs to.

#####################################################
# This readme presents results of a convergence scan
# with the input file in sim/inputs on Summit.
#####################################################

A convergence study, starting from an input file similar to ./sim/inputs (with
a different set of physical parameters generated the APOSMM generator in a
LibEnsemble run) is presented below. The only parameter changed to go from one
resolution to the next is amr.n_cell.

resolution   amr.n_cell   duration    f
res0          16  1024      10s       2.6340181298685122e-05
res1          32  2948      20s       5.074892524831451e-07 <- the one we've been running so far
res2          64  4096      54s       4.557730935993e-06
res3         128  8192     214s       5.683672880520962e-06
res4         256 16384    1092s       5.667607648747023e-06

I ran the last run on 2 GPUs instead of 1, and it took 780s instead of 1092s,
meaning we can run it on either 1 GPU or 2. That way, we can explore it either
having all resolutions on the same number of GPUs, or on different number of
GPUs. In the end, we would probably be interested in the former, which can also
be further investigating my going to higher resolution.

The simulations can be run with the same input file, with the following changes:
- The timeout in the batch script should be larger for higher resolutions (see
  numbers above)
- The jsrun command should be modified as, e.g., "jsrun ... warpx.exe inputs
  amr.n_cell=128 8192" for resolution res3

Note that this test shows a nice converge for a case with relatively high emittance.
In the optimization process, some runs will have a lower emittance (potentially
10x), and they may require a higher resolution to reach the same level of
convergence. Let us keep this in mind, and maybe add a res5 to the list above.
This high-resolution one should also fit on 1 GPU, but it will be worth
testing.

This test creates an mpi4py job where each processor launches MPI tasks on a
node. This is an essential capability for libEnsemble with mpi4py.

You specify the size of the outer tasks and inner tasks as follows:

    mpirun -np 16 python create_mpi_tasks.py 4

runs a 16 way job, each launching a 4 processor python hello_world with a short
sleep.

This is a good test to run to ensure basic functioning on a system, including
nested launching.

The test should create an output file (job_N.out) for each outer rank. A
hello_world line is printed in these for each inner rank.

Additionally it will print the total number of processes being launched
(including outer and inner). This can help test, for example, if
oversubscription is supported.

# Running test run_libe_ddmd.py

This libEnsemble workflow coordinates components of DeepDriveMD (https://deepdrivemd.github.io/),
an adaptive machine-learning driven molecular dynamics loop. Through this test,
we hope to evaluate libEnsemble's effectiveness at coordinating workflows
involving GPUs, large amounts of data, dynamic resource sets, multiple applications,
and other critical workflow characteristics.

# Getting started on Swing

## Create a new python environment
```
$ module load anaconda3/2020.11
$ conda create -name new_env python=3.8
...
$ conda activate new_env
```

Note: Set ``export PYTHONNOUSERSITE=1`` as a preventative measure
for package conflicts in ``.local``.

## Install DeepDriveMD and other initial dependencies

We'll be running components of DeepDriveMD as tasks within libEnsemble. Each component
requires additional, separate dependency installations.

```
$ pip install git+https://github.com/DeepDriveMD/DeepDriveMD-pipeline.git
...
$ pip install git+https://github.com/braceal/MD-tools.git
...
$ pip install git+https://github.com/braceal/molecules.git
...
$ pip install requests pyyaml
...
$ conda install mpi4py scikit-learn pandas numpy==1.20.3 h5py=2.10.0
```

See https://github.com/DeepDriveMD/DeepDriveMD-pipeline for further instructions
on installing dependencies for DeepDriveMD.

Test that each DeepDriveMD component can be imported without errors:
```
from deepdrivemd.sim.openmm import run_openmm
from deepdrivemd.aggregation.basic import aggregate
from deepdrivemd.models.keras_cvae import train
from deepdrivemd.selection.latest import select_model
from deepdrivemd.agents.lof import lof
```

## Install OpenMM

The binaries of OpenMM available on conda-forge or other distribution sources
were compiled with an unsupported version of CUDA on Swing's GPUs. Therefore,
we need to build OpenMM from source with the expected CUDA version (11.0)

Helpful pointers for installing OpenMM on Swing (or other systems): https://gist.github.com/lee212/4bbfe520c8003fbb91929731b8ea8a1e

Load the following modules:
1) gcc/9.2.0-r4tyw54
2) cuda/11.0.2-4szlv2t
3) cmake/3.19.5-sfky2zq

Obtain the source code from: https://github.com/openmm/openmm/releases/tag/7.5.1

Follow the instructions from here: https://github.com/openmm/openmm/blob/master/docs-source/usersguide/library/02_compiling.rst

Notes:

1) In the event you receive an error regarding ``CUDA_CUDA_LIBRARY`` being set to ``NOTFOUND``,
set it (under Advanced Options) to ``/gpfs/fs1/soft/swing/spack-0.16.1/opt/spack/linux-ubuntu20.04-x86_64/gcc-9.2.0/cuda-11.0.2-4szlv2t/lib64/stubs``. If the option doesn't persist, append the above to your ``PATH``.
2) The first time running ``ccmake``, the initial set of options may not be very large, but configure anyway. A subsequent set of options will appear for configuration. Make sure that ``CMAKE_INSTALL_PREFIX``, ``DOXYGEN_EXECUTABLE``, ``PYTHON_EXECUTABLE``, ``SWIG_EXECUTABLE``, and others are accurate.
4) A configuration warning stating ``Could NOT find OPENCL (missing: OPENCL_LIBRARY)`` can be ignored.

## Install libEnsemble

```
$ git clone https://github.com/Libensemble/libensemble.git
...
$ cd libensemble; pip install -e .
```

## Executing the test

The test can be found in ``libensemble/libensemble/tests/scaling_tests/ddmd``,
wherever libEnsemble was installed.

Feel free to adjust ``MD_BATCH_SIZE``, ``'sim_max'`` or ``sim_specs['user']['sim_length_ns']`` to customize
the length of the routine, in terms of number of simulations.

Adjust the account, number of workers, number of nodes, and runtime within ``swing_submit_central.sh``,
then run ``sbatch`` on it to submit ``run_libe_ddmd.py`` to the scheduler.

## Submit multiple tasks to a single node.

Users who wish to submit multiple MD tasks to a single node must have a MPI configured for Swing.
Note that current iterations of the generator and simulator user functions set ``CUDA_VISIBLE_DEVICES``
by ``workerID``.

We've had the most success creating a cloned Python environment with a working ``mpi4py``,
then setting some environment variables:

```
$ conda create --name my_env --clone /home/jlow/.conda/envs/mpi4py-git
$ export PATH=/soft/openmpi/4.1.1/swing/bin:/soft/ucx/1.10.0/swing-defaults/bin:$PATH
$ export LD_LIBRARY_PATH=/soft/openmpi/4.1.1/swing/lib:/soft/ucx/1.10.0/swing-defaults/lib:$LD_LIBRARY_PATH
```

The previous installation steps will need to be performed in this new environment.

The ``mpirun`` used by libEnsemble's ``MPIExecutor`` should now be able to concurrently
submit multiple tasks to a node. Adjust and submit ``swing_submit_central_onenode.sh`` to
test submitting multiple tasks to a single node.

# Test Explanation

This libEnsemble workflow (along with most others) contains three primary Python files.
``run_libe_ddmd.py`` is the libEnsemble *calling script*, where we configure and parameterize
our libEnsemble routine then launch the workflow. ``openmm_md_simf.py`` contains the
*simulation function*, which in this case configures and submits ``run_openmm.py`` from
DeepDriveMD for execution, organizes output, and notifies libEnsemble on completion.
``keras_cvae_ml_genf.py`` contains the *generator function*, and is responsible for producing
an initial set of MD simulations for our simulator function, running each of DeepDriveMD's
ML and data processing tasks on the resulting output, then initiating subsequent MD tasks.

Notably, the ``keras_cvae_ml_genf`` generator function is configured as a *persistent*
function, which means that it continuously loops and waits for output from simulations, as
opposed to simulation function instances which are currently configured to return
on completion of their tasks. The generator function therefore maintains its state
and access to all data from prior runs, a necessary capability.

## Tutorial

This example is explained in the tutorial **Executor with Electrostatic Forces**.

https://libensemble.readthedocs.io/en/develop/tutorials/executor_forces_tutorial.html

## QuickStart

Build executable and run example. Go to `forces_app` directory and build `forces.x`:

    cd ../forces_app
    ./build_forces.sh

Then return here and run:

    python run_libe_forces.py --comms local --nworkers 4

## Running test run_libe_forces.py

Naive Electrostatics Code Test

This is a synthetic, highly configurable simulation function. Its primary use
is to test libEnsemble's capability to launch application instances via the `MPIExecutor`.

### Forces Mini-App

A system of charged particles is initialized and simulated over a number of time-steps.

See `forces_app` directory for details.

### Running with libEnsemble.

A random sample of seeds is taken and used as input to the sim func (forces miniapp).

In forces_app directory, modify build_forces.sh for target platform and run to
build forces.x:

    ./build_forces.sh

Then to run with local comms (multiprocessing) with one manager and `N` workers:

    python run_libe_forces.py --comms local --nworkers N

To run with MPI comms using one manager and `N-1` workers:

    mpirun -np N python run_libe_forces.py

Application parameters can be adjusted in the file `run_libe_forces.py`.

To remove output before the next run:

    ./cleanup.sh

## Running test run_libe_forces_balsam.py

Naive Electrostatics Code Test

This is a synthetic, highly configurable simulation function. Its primary use
is to test libEnsemble's capability to submit application instances via the Balsam service,
including to separate machines from libEnsemble's processes. This means that although
this is typically an HPC scaling test, this can be run on a laptop with the `forces.x`
simulation submitted to the remote machine, and the resulting data-files transferred
back to the machine that runs the libEnsemble calling script.

Note that this test currently requires active ALCF credentials to authenticate with
the Balsam service.

### Forces Mini-App

A system of charged particles is initialized and simulated over a number of time-steps.

See `forces_app` directory for details.

**This application will need to be compiled on the remote machine**

Choose or modify a build line from `build_forces.sh` for the target platform:

    cd libensemble/libensemble/tests/scaling_tests/forces/forces_app
    ./build_forces.sh

### Configuring Balsam

On the remote machine (in a conda or other virtual environment):

    pip install balsam
    balsam login
    balsam site init ./my-site

You may be asked to login and authenticate with the Balsam service. Do so with
your ALCF credentials. Now go into the site directory:

    cd my-site

To see if the site is active, run:

    balsam site ls

If the site is not active, run:

    balsam site start

On any machine you've installed and logged into Balsam, you can run `balsam site ls`
to list your sites and `balsam job rm --all` to remove extraneous jobs between runs.

### Configuring data-transfer via Balsam and Globus

Although the raw results of forces runs are available in Balsam sites,
this is understandably insufficient for the simulation function's capability
to evaluate results and determine the final status of an app run if it's running
on another machine.

Balsam can coordinate data transfers via Globus between Globus endpoints. Assuming
this test is being run on a personal device, do the following to configure Globus,
then Balsam to use Globus.

- Login to [Globus](https://www.globus.org/) using ALCF or other approved organization credentials.
- Download and run [Globus Connect Personal](https://app.globus.org/file-manager/gcp) to register your device as a Globus endpoint. Note the initialized collection name, e.g. ``test_collection``.
- Once a Globus collection has been initialized in Globus Connect Personal, login to Globus, click "Endpoints" on the left.
- Click the collection that was created on your personal device. Copy the string after "Endpoint UUID".
- Login to the remote machine, switch to your Balsam site directory, and run ``balsam site globus-login``.
- Modify ``settings.yml`` to contain a new transfer_location that matches your device, with the copied endpoint UUID. e.g. ``test_collection: globus://19036a15-570a-12f8-bef8-22060b9b458d``
- Run ``balsam site sync`` within the site directory to save these changes.
- Locally, in the calling script (``run_libe_forces_balsam.py``), set ``GLOBUS_ENDPOINT`` to the collection name for the previously-defined transfer_location.

This should be sufficient for ``forces.stat`` files from remote Balsam app runs
to be transferred back to your personal device after every app run. The
simulation function will wait for Balsam to transfer back a stat file, then determine
the calc status based on the received output.

*To transfer files to/from Theta*, you will need to login to Globus and activate
Theta's Managed Public Endpoint:

- Login to Globus, click "Endpoints" on the left.
- Search for ``alcf#dtn_theta``, click on the result.
- On the right, click "Activate", then "Continue". Authenticate with ALCF.

### Configuring libEnsemble

There are several scripts that each need to be adjusted. To explain each:

1. ``define_apps.py``:

  About:

  This script defines and syncs each of our Balsam apps with the Balsam service. A Balsam
  app is an ``ApplicationDefinition`` class with ``site`` and
  ``command_template`` fields. ``site`` specifies to Balsam on which Balsam site
  the app should be run, and ``command_template`` specifies the command (as a Jinja2
  string template) that should be executed. This script contains two apps, ``RemoteLibensembleApp``
   and ``RemoteForces``. If you're running libEnsemble on your personal machine and
   only submitting the Forces app via Balsam, only ``RemoteForces`` needs adjusting.

  Configuring:

  Adjust the ``site`` field in each ``ApplicationDefinition`` to match your remote
  Balsam site. Adjust the various paths in the ``command_template`` fields to match
  your home directory and/or Python paths **on the remote machine**. If running
  libEnsemble on your personal machine, feel free comment-out ``RemoteLibensembleApp.sync()``.

  **Run this script each time you edit it,** since changes to each
  ``ApplicationDefinition`` needs to be synced with the Balsam service.

2. ``run_libe_forces_balsam.py``:

  About:

  This is a typical libEnsemble plus Executor calling script, but instead of
  registering paths to apps like with the MPI Executor, this script loads the
  ``RemoteForces`` app synced with the Balsam service in ``define_apps.py``
  and registers it with libEnsemble's Balsam Executor. If running this
  script on your personal machine, it also uses the Balsam Executor to reserve
  resources at a Balsam site.

  Configuring:

  See the Globus instructions above for setting up Globus transfers within this script.

  Adjust the ``BALSAM_SITE`` field
  to match your remote Balsam site, and fields in the in the
  ``batch = exctr.submit_allocation()`` block further down. For ``site_id``,
  retrieve the corresponding field with ``balsam site ls``.

3. (optional) ``submit_libe_forces_balsam.py``:

  About:

  This Python script is effectively a batch submission script. It uses the Balsam API
  to check out resources (a ``BatchJob``) at a Balsam site, and submits libEnsemble as
  a Balsam Job onto those resources. If transferring statfiles back to your
  personal machine, it also waits until they are all returned and cancels
  the remote ``BatchJob``. *Probably only needed if running libEnsemble remotely.*

  Configuring:

  Every field in UPPER_CASE can be adjusted. ``BALSAM_SITE``, ``PROJECT``,
  and ``QUEUE`` among others will probably need adjusting. ``LIBE_NODES`` and ``LIBE_RANKS``
  specify a subset of resources specifically for libEnsemble out of ``BATCH_NUM_NODES``.

### Running libEnsemble locally

First make sure that all Balsam apps are synced with the Balsam service:

    python define_apps.py

Then run libEnsemble with multiprocessing comms, with one manager and `N` workers:

    python run_libe_forces_balsam.py --comms local --nworkers N

Or, run with MPI comms using one manager and `N-1` workers:

    mpirun -np N python run_libe_forces_balsam.py

To remove output before the next run, use:

    ./cleanup.sh

**This runs libEnsemble itself in-place, with only Forces submitted to a Balsam site.**

### (Optional) Running libEnsemble remotely

The previous instructions for running libEnsemble are understandably insufficient
if running with lots of workers or if the simulation/generation
functions are computationally expensive.

To run both libEnsemble and the Forces app on the compute nodes at Balsam site, use:

    python define_apps.py
    python submit_libe_forces_balsam.py

This routine will wait for corresponding statfiles to be transferred back from
the remote machine, then cancel the allocation.

## Running test run_libe_forces_funcx.py

Naive Electrostatics Code Test

This is designed only as an artificial, highly configurable test
code for a libEnsemble sim func. This variant is primarily to test libEnsemble's
capability to submit simulation functions to a separate machine from where libEnsemble's
manager and workers are running.

### Forces Mini-App

A system of charged particles is initialized and simulated over a number of time-steps.

See `forces_app` directory for details.

This application will need to be compiled on the remote machine where the sim_f will run.
See below.

### Running with libEnsemble.

On the remote machine:

    pip install funcx-endpoint
    funcx-endpoint configure forces

Configure the endpoint's `config.py` to include your project information and
match the machine's specifications.
See [here](https://funcx.readthedocs.io/en/latest/endpoints.html#theta-alcf) for
an example ALCF Theta configuration.

Then to run with local comms (multiprocessing) with one manager and `N` workers:

    python run_libe_forces_funcx.py --comms local --nworkers N

To run with MPI comms using one manager and `N-1` workers:

    mpirun -np N python run_libe_forces.py

Application parameters can be adjusted in `funcx_forces.yaml`.

Note that each function and path must be accessible and/or importable on the
remote machine. Absolute paths are recommended.

To remove output before the next run:

    ./cleanup.sh

## Tutorial

This example is explained in the tutorial **Executor - Assign GPUs**.

https://libensemble.readthedocs.io/en/develop/tutorials/forces_gpu_tutorial.html

Note that at time of writing the calling script `run_libe_forces.py` is identical
to `forces_simple`, and so is provided as a symlink. The `forces_simf` file has slight
modifications to assign GPUs.

## QuickStart

Go to `forces_app` directory:

    cd ../forces_app

To compile the forces application to use the GPU, ensure **forces.c** has the
`#pragma omp target` line uncommented and comment out the equivalent
`#pragma omp parallel` line. Then compile to **forces.x** using one of the GPU build
lines in build_forces.sh or similar for your platform.

    ./build_forces.sh

Then return here and run:

    python run_libe_forces.py --comms local --nworkers 4

By default, each run of forces will use one CPU and one GPU. The `forces.c` code can also
be MPI parallel and will use one GPU for each CPU rank, assuming an even split of ranks
across nodes.

## Running test run_libe_forces.py

Naive Electrostatics Code Test

This is a synthetic, highly configurable simulation function. This test aims
to show libEnsemble's capability to set assign GPU resources as needed by each
worker and to launch application instances via the `MPIExecutor`.

### Forces Mini-App

A system of charged particles is initialized and simulated over a number of time-steps.

See `forces_app` directory for details.

### Running with libEnsemble.

A random sample of seeds is taken and used as input to the sim func (forces miniapp).

In forces_app directory, modify build_forces.sh for target platform and run to
build forces.x:

    ./build_forces.sh

Then to run with local comms (multiprocessing) with one manager and `N` workers:

    python run_libe_forces.py --comms local --nworkers N

To run with MPI comms using one manager and `N-1` workers:

    mpirun -np N python run_libe_forces.py

Application parameters can be adjusted in the file `run_libe_forces.py`.

To remove output before the next run:

    ./cleanup.sh

### Forces Mini-App

A system of charged particles is initialized and simulated over a number of time-steps.

Particles' position and charge are initiated using a random stream.
Particles are replicated on all ranks.
**Each rank** computes forces for a subset of particles (`O(N^2)` operations).
Particle force arrays are `allreduced` across ranks.
Particles are moved (replicated on each rank).
Total energy is appended to the forces.stat file.

Choose or modify a build line from `build_forces.sh` for the target platform and
run to build `forces.x`:

    ./build_forces.sh

To run forces as a standalone executable on `N` procs:

    mpirun -np N ./forces.x <NUM_PARTICLES> <NUM_TIMESTEPS> <SEED>

This is a good test to make sure forces is working, before running via libEnsemble.

The change the rate at which runs are declared bad runs (e.g.,~ for testing worker
kills), add a fourth argument between 0 and 1.

!
! Updated on 6/3/2013
! by Layne Watson
!

MODULE LINEAR_SHEPARD_MOD
INTERFACE
   SUBROUTINE DGELSS(M, N, NRHS, A, LDA, B, LDB, SIGMA, RCOND, RANK, &
        WORK, LWORK, INFO)
     USE REAL_PRECISION
     INTEGER, INTENT(IN) :: M, N, NRHS, LDA, LDB, LWORK
     INTEGER, INTENT(OUT) :: RANK, INFO
     REAL(KIND = R8), INTENT(IN) :: RCOND
     REAL(KIND = R8), DIMENSION(LDA, *), INTENT(INOUT) :: A
     REAL(KIND = R8), DIMENSION(LDB, *), INTENT(INOUT) :: B
     REAL(KIND = R8), DIMENSION(N), INTENT(OUT) :: SIGMA
     REAL(KIND = R8), DIMENSION(LWORK), INTENT(OUT) :: WORK
   END SUBROUTINE DGELSS
END INTERFACE
PRIVATE
PUBLIC LSHEP, LSHEPVAL, RIPPLE
CONTAINS

SUBROUTINE LSHEP ( M, N, X, F, A, RW, IER, RLSHEP )
! This subroutine computes a set of parameters defining a function that
! interpolates N data values F(i) at scattered nodes X(i) in M dimensions. The
! interpolant may be evaluated at an arbitrary point by the function LSHEPVAL.
! The interpolation scheme is a modified linear Shepard method, and
! can use either the Shepard weighted least squares fit or robust
! M-estimation for each local approximation.
!
! Input parameters:
!   M is the dimension of the data.
!   N is the number of nodes.
!   X(M, N) contains the coordinates of the nodes.
!   F(N) contains the function values of the nodes.
! Output parameters:
!   A(M, N) contains the coefficients of the local fits.
!   RW(N) is an array containing the radius of influence for each point.
!   IER
!   = 0, if no errors were encountered.
!   = 1, if N is too small relative to M.
!   = 2, if any least squares problem is rank deficient, in which
!        case an SVD based minimum norm solution is returned; the
!        local fit should still be reasonable.
!   = 3, if the IRLS subroutine returns an error, meaning the IRLS
!        iteration has failed, and the returned local fit may
!        be bad.
! Optional input:
!   RLSHEP specifies by its presence that robust M-estimation is to be used to
!          compute the local approximation.
USE REAL_PRECISION
IMPLICIT NONE

INTEGER, INTENT(IN) :: M, N
REAL(KIND=R8), DIMENSION(M,N), INTENT(IN) :: X
REAL(KIND=R8), DIMENSION(N), INTENT(IN) :: F
REAL(KIND=R8), DIMENSION(M,N), INTENT(OUT) :: A
REAL(KIND=R8), DIMENSION(N), INTENT(OUT) :: RW
INTEGER, INTENT(OUT) :: IER
LOGICAL, OPTIONAL :: RLSHEP

! Local variables.
INTEGER :: FUNC  ! IRLS influence function switch, 1 = Huber, 2 = Tukey's
                 ! bisquare.
INTEGER :: IER1  ! error indicator for IRLS subroutine.
INTEGER :: INFO  ! error indicator for DGELSS.
INTEGER :: ITER  ! number of iterations the IRLS algorithm will perform.
INTEGER :: I, J, K  ! loop control variables.
INTEGER :: LWORK ! length of the work array WORK for DGELSS.
INTEGER :: NP    ! number of nodes used for the local fit.
INTEGER :: RANK  ! rank of the array (used for DGELSS).
INTEGER, DIMENSION(N-1) :: IDIST ! index array for DIST.
REAL(KIND=R8) :: DIAM  ! diameter of the whole date set.
REAL(KIND=R8) :: MAR   ! the median absolute residual.
REAL(KIND=R8) :: RCOND ! reciprocal condition number used in DGELSS.
REAL(KIND=R8) :: RP    ! least squares fit radius R_p.
REAL(KIND=R8), DIMENSION(MIN(N-1, (3*M+1)/2)) :: BETA_IN
               ! variable used in DGELSS.
REAL(KIND=R8), DIMENSION(N-1) :: DIST ! array that stores all the distances.
REAL(KIND=R8), DIMENSION(MIN(N-1, (3*M+1)/2)) :: OMEGA
               ! weights used for linear least squares fit.
REAL(KIND=R8), DIMENSION(MIN(N-1, (3*M+1)/2)) :: RES
               ! the residuals from the linear fit.
REAL(KIND=R8), DIMENSION(M) :: SIGMA   ! array used for DGELSS.
REAL(KIND=R8), DIMENSION(3*M+2*MIN(N-1, (3*M+1)/2)) :: WORK
               ! work array of length LWORK for DGELSS.
REAL(KIND=R8), DIMENSION(MIN(N-1, (3*M+1)/2), M) :: ALPHA, ALPHA_IN
REAL(KIND=R8), DIMENSION(MIN(N-1, (3*M+1)/2), 1) :: BETA
               ! variables used in DGELSS.

IER = 0
! Check the validity of M and N.
IF ( ( M < 1 ) .OR. ( N <= (M + 1) ) ) THEN
   IER = 1
   RETURN
END IF
! Set the number of nodes used in local linear fit.
NP = MIN( N - 1,  (3 * M + 1) / 2 )
! Set the RCOND parameter used in DGELSS.
RCOND = NP * EPSILON( 1.0_R8 )
! Set the LWORK parameter used in DGELSS.
LWORK = 3 * M + 2 * NP
! Calculate RW and A.
DIAM = 0.0_R8
DO K = 1, N
   J = 0
   DO I = 1, N
      IF (I /= K) THEN
         J = J + 1
         DIST(J) = DOT_PRODUCT( X(:, I) - X(:, K), X(:, I) - X(:, K) )
         IDIST(J) = I
      END IF
   END DO
   DIAM = MAX( DIAM, MAXVAL( DIST(1:N-1) ) )
   CALL SORT( DIST, IDIST, NP, N - 1 )
   DIST(1:NP) = SQRT( DIST(1:NP) )
   BETA_IN(1:NP) = F(IDIST(1:NP)) - F(K)
   DO I = 1, NP
      ALPHA_IN(I, 1:M) = X(1:M, IDIST(I)) - X(1:M, K)
   END DO
   RW(K) = DIST(NP)
   IF ( PRESENT(RLSHEP) ) THEN
      OMEGA(1:NP) = 1.0_R8
   ELSE
      RP = 1.1_R8 * RW(K)
      OMEGA(1:NP) =  (RP - DIST(1:NP)) / (RP * DIST(1:NP))
   END IF
   BETA(1:NP,1) = OMEGA(1:NP) * BETA_IN(1:NP)
   DO I = 1, NP
      ALPHA(I, 1:M) = OMEGA(I) * ALPHA_IN(I, 1:M)
   END DO
   CALL DGELSS( NP, M, 1, ALPHA(1:NP, 1:M), NP, BETA(1:NP,1), NP, SIGMA, &
        RCOND, RANK, WORK, LWORK, INFO )
   A(1:M, K) = BETA(1:M,1)
   IF ( RANK < M )  IER = 2
   ROBUST: IF ( PRESENT(RLSHEP) ) THEN
      RES(1:NP) = MATMUL( ALPHA_IN(1:NP, 1:M), BETA(1:M,1) ) - BETA_IN(1:NP)
      MAR = MAD( RES(1:NP), NP )
      IF ( MAR > EPSILON( 1.0_R8 ) ) THEN
         FUNC = 1
         ITER = 5
         CALL IRLS(M, N, MAR, ITER, FUNC, OMEGA, BETA, BETA_IN, ALPHA,&
              ALPHA_IN, RES, NP, IER1 )
         IF ( IER1 /= 0 ) THEN
            IER = 3
            CYCLE
         ELSE
            A(1:M, K) = BETA(1:M,1)
         END IF
         MAR = MAD( RES(1:NP), NP )
         IF ( MAR > EPSILON( 1.0_R8 ) ) THEN
            FUNC = 2
            ITER = 5
            CALL IRLS(M, N, MAR, ITER, FUNC, OMEGA, BETA, BETA_IN, &
                 ALPHA, ALPHA_IN, RES, NP, IER1 )
            IF ( IER1 /= 0 ) THEN
               IER = 3
               CYCLE
            ELSE
               A(1:M, K) = BETA(1:M,1)
            END IF
         END IF
      END IF
! Adjust RW(K) according to weights.
      DO I = 1, NP
         IF ( OMEGA(I) < 0.8_R8 ) THEN
            IF ( I == 1 ) THEN
               RW(K) = DIST(I) / 2.0_R8
            ELSE
               RW(K) = ( DIST(I - 1) + DIST(I) ) / 2.0_R8
            END IF
            EXIT
         END IF
      END DO
   END IF ROBUST
END DO
RW(1:N) = MIN( SQRT( DIAM ) / 2.0_R8, RW(1:N) )
RETURN
END SUBROUTINE LSHEP

SUBROUTINE IRLS( M, N,  S, ITER, FUNC, OMEGA, BETA, BETA_IN, ALPHA, &
           ALPHA_IN, RES, NP, IER )
! IRLS returns the coefficients of the linear least squares fit at the current
! node using robust M-estimation. For Tukey's bisquare influence function,
! there is an additional convergence test.
!
! Input parameters:
!  M    is the dimension of the problem.
!  N    is the number of points.
!  S    is the scale constant.
!  ITER is the number of iterations to be used in the algorithm.
!  FUNC identifies which IRLS influence function to use here, 1 = Huber,
!       2 = Tukey's bisquare.
!  BETA_IN holds distances.
!  ALPHA, ALPHA_IN are used for DGELSS calls.
!  RES is the residuals from the linear fit.
! Output parameters:
!  OMEGA stores the final weights.
!  BETA stores the coefficients of the linear fit using robust M-estimation.
!  NP is the size of OMEGA(:) and BETA(:,1).
!  IER
!   = 0, if no errors were encountered.
!   = 1, if any least squares problem is rank deficient.
!   = 2, if the bisquare IRLS did not converge.
!   = 3, if the input parameters are invalid.
USE REAL_PRECISION
IMPLICIT NONE
INTEGER, INTENT(IN) :: M, N
REAL(KIND=R8), INTENT(INOUT) :: S
INTEGER, INTENT(IN) :: ITER, FUNC
REAL(KIND=R8), INTENT(OUT), DIMENSION(:) :: OMEGA
REAL(KIND=R8), INTENT(OUT), DIMENSION(:,:) :: BETA
REAL(KIND=R8), INTENT(IN), DIMENSION(:) :: BETA_IN
REAL(KIND=R8), INTENT(OUT), DIMENSION(:,:) :: ALPHA
REAL(KIND=R8), INTENT(IN), DIMENSION(:,:) :: ALPHA_IN
REAL(KIND=R8), INTENT(INOUT), DIMENSION(:) :: RES
INTEGER, INTENT(IN) :: NP
INTEGER, INTENT(OUT) :: IER

! Local variables.
INTEGER :: I,J     ! loop control variables.
INTEGER:: INFO   ! error code from DGELSS.
INTEGER :: LWORK ! size of work array for DGELSS.
INTEGER :: RANK  ! rank of array (used for DGELSS).
REAL(KIND=R8) :: RCOND ! reciprocal condition number used in DGELSS.
REAL(KIND=R8), DIMENSION(M) :: SIGMA ! array used for DGELSS.
REAL(KIND=R8) :: ERR_NEW      ! objective function value after bisquare IRLS.
REAL(KIND=R8) :: ERR_OLD      ! objective function value before bisquare IRLS.
REAL(KIND=R8), DIMENSION(3*M+2*MIN(N-1, (5*M+1)/2)) :: WORK
REAL(KIND=R8), PARAMETER, DIMENSION(2) :: TUNING = (/1.0_R8, 3.0_R8/)
               ! tuning parameters for influence functions.
IF ((FUNC /= 1) .AND. (FUNC /= 2)) THEN
    IER=3
    RETURN
END IF
S = TUNING(FUNC) * S
! Set the RCOND parameter used in DGELSS.
RCOND = NP * EPSILON( 1.0_R8 )
! Set the LWORK parameter used in DGELSS.
LWORK = 3 * M + 2 * NP
IF ( FUNC ==  2 ) THEN
   ERR_OLD = SUM( 1.0_R8 - (MAX( 0.0_R8, 1.0_R8 - (RES(1:NP) /  S)**2 ))**3 )
END IF
DO I = 1, ITER
! Update the weight from the previous linear fit residual.
   SELECT CASE ( FUNC )
! Huber function
   CASE (1)
      DO J = 1, NP
         IF ( RES(J) == 0.0_R8 ) THEN
            OMEGA(J) = 1.0_R8
         ELSE
            OMEGA(J) = SQRT( MIN( 1.0_R8, S / ABS( RES(J) ) ) )
         END IF
      END DO
! Bisquare function
   CASE(2)
      OMEGA(1:NP) = MAX( 0.0_R8, 1.0_R8 - (RES(1:NP) / S)**2 )
   END SELECT
! Compute the linear fit with a new weight.
   BETA(1:NP,1) = OMEGA(1:NP) * BETA_IN(1:NP)
   DO J = 1, NP
      ALPHA(J, 1:M) = OMEGA(J) * ALPHA_IN(J, 1:M)
   END DO
   CALL DGELSS( NP, M, 1, ALPHA(1:NP,1:M), NP, BETA(1:NP,1), NP, SIGMA, &
        RCOND, RANK, WORK, LWORK, INFO )
   IF ( RANK < M ) THEN
      IER = 1
      RETURN
   END IF
   RES(1:NP) = MATMUL( ALPHA_IN(1:NP,1:M), BETA(1:M,1) ) - BETA_IN(1:NP)
END DO
IF ( FUNC ==  2 ) THEN
   ERR_NEW = SUM( 1.0_R8 - (MAX( 0.0_R8, 1.0_R8 - (RES(1:NP) / S)**2 ))**3 )
   IF ( ERR_NEW > ERR_OLD ) THEN
      IER = 2
      RETURN
   END IF
END IF
IER = 0
RETURN
END SUBROUTINE IRLS

FUNCTION MAD( RES, NP )
! The function MAD computes the median absolute deviation (MAD) scaled
! estimate for robust M-estimation from the residual array RES.
USE REAL_PRECISION
IMPLICIT NONE
REAL(KIND=R8), DIMENSION(:), INTENT(IN) :: RES
INTEGER, INTENT(IN)::NP
REAL(KIND=R8) :: MAD

! Local variables.
INTEGER :: NMID
REAL(KIND=R8) :: FACTOR, MED

FACTOR = 1.0_R8 / 0.6745_R8
NMID = NP / 2
IF ( MOD(NP, 2) == 0 ) THEN
   MED = (QUANTILE( RES(:), NMID ) + QUANTILE( RES(:), NMID + 1 )) / 2.0_R8
   MAD = FACTOR * (QUANTILE( ABS( RES(:) - MED ), NMID ) + &
        QUANTILE( ABS( RES(:) - MED ), NMID + 1 )) / 2.0_R8
ELSE
   MED = QUANTILE( RES(:), NMID + 1 )
   MAD = FACTOR * QUANTILE( ABS( RES(:) - MED ), NMID + 1 )
END IF
RETURN
END FUNCTION MAD

RECURSIVE FUNCTION QUANTILE( A, K ) RESULT( VALUE )
! Recursive function QUANTILE returns the K-th smallest element in array A.
USE REAL_PRECISION
IMPLICIT NONE
REAL(KIND=R8), DIMENSION (:), INTENT(IN) :: A
INTEGER, INTENT(IN) :: K
REAL(KIND=R8) :: VALUE

! Local variables.
INTEGER :: J
REAL(KIND=R8) :: AK

AK = A(K)
J = COUNT( A(:) < AK )
IF ( J >= K ) THEN
   VALUE = QUANTILE( PACK( A(:), A(:) < AK ), K )
ELSE
   J = COUNT( A(:) > AK ) + K - SIZE( A(:) )
   IF ( J > 0 ) THEN
      VALUE = QUANTILE( PACK( A(:), A(:) > AK ), J )
   ELSE
      VALUE = AK
   END IF
END IF
RETURN
END FUNCTION QUANTILE

SUBROUTINE SORT( DIST, IDIST, NUM, LENGTH )
! The subroutine SORT sorts the real array DIST of length LENGTH in ascending
! order for the smallest NUM elements. IDIST stores the original label for
! each element in array DIST.
! Local variables.
USE REAL_PRECISION
IMPLICIT NONE
REAL(KIND=R8), INTENT(INOUT), DIMENSION(:)::DIST
INTEGER, INTENT(INOUT), DIMENSION(:)::IDIST
INTEGER :: I, ITEMP, J, LENGTH, NUM
REAL(KIND=R8) :: TEMP

DO I = 2, LENGTH
   DO J = 1, MIN( I-1, NUM )
      IF ( DIST(I) < DIST(J) ) THEN
         TEMP = DIST(I)
         ITEMP = IDIST(I)
         DIST(J+1:I) = DIST(J:I-1)
         IDIST(J+1:I) = IDIST(J:I-1)
         DIST(J) = TEMP
         IDIST(J) = ITEMP
         EXIT
      END IF
   END DO
END DO
END SUBROUTINE SORT


FUNCTION LSHEPVAL( XP, M, N, X, F, A, RW, IER )
! LSHEPVAL returns the linear Shepard approximation at the point XP, using the
! local linear approximations computed by LSHEP.
!
! Input parameters:
!  XP is the point at which the linear Shepard interpolant function
!     approximation function is to be evaluated.
!  M is the dimension of the data.
!  N is the number of interpolation points.
!  X contains the interpolation nodes, by column.
!  F contains the function values of the interpolation nodes.
!  A is an M by N matrix containing the coefficients for linear nodal functions
!    returned by LSHEP.
!  RW contains the radius of influence about each interpolation node returned
!    by LSHEP.
! Output parameter:
!  IER
!   = 0, normal returns.
!   = 1, if the point XP is outside the radius of influence RW(i) for all
!        nodes, in which case LSHEPVAL is computed using the original Shepard
!        algorithm with the M+1 closest points.
!   = 2, if the hyperplane normals of the local approximations with positive
!        weights are significantly different. For a nonlinear underlying
!        function f(x), e.g., quadratic f(x), very different normals are
!        typical. For a piecewise linear underlying function f(x), IER = 2
!        signals a potentially large error in LSHEPVAL, since local
!        approximations from different facets of f(x) have been used.
USE REAL_PRECISION
IMPLICIT NONE

INTEGER, INTENT(IN)  :: M, N
REAL(KIND=R8), DIMENSION(M), INTENT(IN) :: XP
REAL(KIND=R8), DIMENSION(M, N), INTENT(IN) :: X
REAL(KIND=R8), DIMENSION(N), INTENT(IN) :: F
REAL(KIND=R8), DIMENSION(M, N), INTENT(IN) :: A
REAL(KIND=R8), DIMENSION(N), INTENT(IN) :: RW
INTEGER, INTENT(OUT):: IER
REAL(KIND=R8) :: LSHEPVAL

! Local variables.
INTEGER :: I   ! number of nodal functions used in Shepard approximation.
INTEGER :: J   ! temporary integer variable.
INTEGER :: K   ! loop control variable.
INTEGER, DIMENSION(M+1) :: ID ! data indices in the original Shepard scheme.
REAL(KIND=R8) :: DIST ! distance between XP and the interpolation nodes.
REAL(KIND=R8) :: TEMP ! temporary real variable.
REAL(KIND=R8) :: W    ! weight value, depends on D.
REAL(KIND=R8), DIMENSION(M+1) :: D ! weights in the original Shepard scheme.
REAL(KIND=R8), DIMENSION(M+1) :: SLOPE ! the hyperplane normal of the Shepard
               ! approximation function.
REAL(KIND=R8), DIMENSION(M+1, N) :: SSLOPE ! the hyperplane normals of the
               ! local approximations with positive weights.
REAL(KIND=R8), DIMENSION(N) :: SW   ! weight values.
REAL(KIND=R8), DIMENSION(N) :: SWC  ! nodal (linear) function values.

IER = 0
I = 0
J = 1
D(1:M+1) = 0.0_R8
TEMP = 0.0_R8
DO K = 1, N
   DIST = SQRT( DOT_PRODUCT( XP(:) - X(:, K), XP(:) - X(:, K) ) )
   IF ( DIST < RW(K) ) THEN
      IF ( RW(K) - DIST == RW(K) ) THEN
         LSHEPVAL = F(K)
         RETURN
      END IF
      I = I + 1
      W = ((RW(K) - DIST) / (RW(K) * DIST))**2
      SW(I) = W
      SWC(I) = DOT_PRODUCT( A(:, K), (XP(:) - X(:, K)) ) + F(K)
      SSLOPE(1:M, I) = A(1:M, K)
      SSLOPE(M+1, I) = -1.0_R8
   ELSE
      W = 1.0_R8 / DIST
      IF ( W > TEMP ) THEN
         D(J) = W
         ID(J) = K
         J = MINLOC( D(1:M+1), DIM = 1 )
         TEMP = D(J)
      END IF
   END IF
END DO
! I = 0 iff the point XP is not within the radius RW(K) of X(:,K) for all K;
! IER = 1.
IF ( I == 0 ) THEN
   D = D**2
   LSHEPVAL = DOT_PRODUCT( D / SUM( D ), F(ID) )
   IER = 1
   RETURN
ELSE
   SW(1:I) = SW(1:I) / SUM( SW(1:I) )
   LSHEPVAL = DOT_PRODUCT( SW(1:I), SWC(1:I) )
! Return IER = 2 iff the angle between two local approximation hyperplanes is
! too large.
   SLOPE(1:M+1) = MATMUL( SSLOPE(1:M+1, 1:I), SW(1:I) )
   SLOPE(:) = SLOPE(:) / SQRT( DOT_PRODUCT( SLOPE(:), SLOPE(:) ) )
   DO K = 1, I
      SSLOPE(:, K) = SSLOPE(:, K) / SQRT( DOT_PRODUCT( SSLOPE(:, K), &
           SSLOPE(:, K) ) )
      IF ( DOT_PRODUCT( SLOPE(1:M+1), SSLOPE(1:M+1, K) ) < 0.9_R8 ) THEN
         IER = 2
         EXIT
      END IF
   END DO
END IF
RETURN
END FUNCTION LSHEPVAL

SUBROUTINE RIPPLE( M, N, X, F, A, RW, IER )
! The subroutine RIPPLE, residual initiated polynomial-time piecewise linear
! estimation, computes a set of parameters defining a function that
! interpolates N data values F(i) at scattered nodes X(i) in M dimensions.
! The interpolant may be evaluated at an arbitrary point by the function
! LSHEPVAL.
! The interpolation scheme is a modified linear Shepard method.
! The time complexity of the algorithm RIPPLE is between the robust
! M-estimation and LMS estimation.
!
! Input parameters:
!   M is the dimension of the data.
!   N is the number of nodes.
!   X(M, N) contains the coordinates of the nodes.
!   F(N) contains the function values of the nodes.
! Output parameters:
!   A(M, N) contains the coefficients of the local fits.
!   RW(N) is an array containing the radius of influence for each point.
!   IER
!   = 0, if no errors were encountered.
!   = 1, if N is too small relative to M.
!   = 2, if the IRLS subroutine returns an error.
USE REAL_PRECISION
IMPLICIT NONE

INTEGER, INTENT(IN) :: M, N
REAL(KIND=R8), DIMENSION(M,N), INTENT(IN) :: X
REAL(KIND=R8), DIMENSION(N), INTENT(IN) :: F
REAL(KIND=R8), DIMENSION(M,N), INTENT(OUT) :: A
REAL(KIND=R8), DIMENSION(N), INTENT(OUT) :: RW
INTEGER, INTENT(OUT) :: IER

! Local variables
INTEGER :: FUNC ! IRLS influence function switch, 1 = Huber, 2 = Tukey's
                ! bisquare.
INTEGER :: IER1 ! error indicator for IRLS subroutine.
INTEGER :: INFO ! error indicator for DGELSS.
INTEGER :: ITER ! number of iterations for IRLS algorithm.
INTEGER :: I, J, K, L  ! loop control variables.
INTEGER :: LWORK ! length of the work array WORK for DGELSS.
INTEGER :: NP    ! number of nodes used for the local fit.
INTEGER :: RANK  ! rank of array (used for DGELSS).
INTEGER, DIMENSION(N-1) :: IDIST    ! index array for DIST.
INTEGER, DIMENSION(MIN(N-1, (3*M+1)/2), M+3) :: D
                    ! distance matrix of indices.
INTEGER, DIMENSION(N, MIN(N-1, (3*M+5)/2)) :: S
                    ! set of indices close to X(:, K).
REAL(KIND=R8) :: DIAM  ! diameter of the whole date set.
REAL(KIND=R8) :: LSE   ! the least squares error.
REAL(KIND=R8) :: MAR   ! the median absolute residual.
REAL(KIND=R8) :: RCOND ! reciprocal condition number used in DGELSS.
REAL(KIND=R8), DIMENSION(MIN(N-1, (5*M+1)/2)) :: BETA_IN
               ! variables used for DGELSS.
REAL(KIND=R8), DIMENSION(N-1) :: DIST  ! array that stores all distances.
REAL(KIND=R8), DIMENSION(MIN(N-1, (5*M+1)/2)) :: OMEGA
               ! weights used for least squares fit.
REAL(KIND=R8), DIMENSION(MIN(N-1, (5*M+1)/2)) :: RES
               ! the residuals from the linear fit.
REAL(KIND=R8), DIMENSION(M) :: SIGMA ! array used for DGELSS.
REAL(KIND=R8), DIMENSION(3*M+2*MIN(N-1, (5*M+1)/2)) :: WORK
               ! work array for DGELSS.
REAL(KIND=R8), DIMENSION(MIN(N-1, (5*M+1)/2), M):: ALPHA, ALPHA_IN
REAL(KIND=R8), DIMENSION(MIN(N-1, (5*M+1)/2), 1) :: BETA
               ! variables used for DGELSS.

IER = 0
! Check the validity of M and N.
IF ( ( M < 1 ) .OR. ( N <= (M + 3) ) ) THEN
   IER = 1
   RETURN
END IF
! Compute the set of indices S.
DIAM = 0.0_R8
NP = MIN( N - 1, (3 * M + 5) / 2 )
DO K = 1, N
   J = 0
   DO I = 1, N
      IF (I /= K) THEN
         J = J + 1
         DIST(J) = DOT_PRODUCT( X(:, I) - X(:, K), X(:, I) - X(:, K) )
         IDIST(J) = I
      END IF
   END DO
   DIAM = MAX( DIAM, MAXVAL( DIST(1:N-1) ) )
   CALL SORT( DIST, IDIST, NP, N - 1 )
   S(K, 1:NP) = IDIST(1:NP)
END DO
! Compute the local linear approximation.
DO K = 1, N
   NP = MIN( N - 1,  (3 * M + 1) / 2 )
   D(1:NP, 1) = S(K, 1:NP)
   DO J = 2, M + 3
      DO I = 1, NP
         DO L = 1, J
            IF ( ALL( S(D(I, J-1), L) /= D(I, 1:J-1) ) .AND. &
                 S(D(I, J-1), L) /= K )  D(I, J) = S(D(I, J-1), L)
         END DO
      END DO
   END DO
   LSE = HUGE(1.0_R8)
! Set the number of nodes used in searching for the set R.
   DO J = 1, NP
      BETA_IN(1:M+3) = F(D(J, 1:M+3)) - F(K)
      DO I = 1, M + 3
         ALPHA_IN(I, 1:M) = X(1:M, D(J, I)) - X(1:M, K)
      END DO
! Eliminate 2 of the M+3 points.
      RCOND = (M + 1) * EPSILON( 1.0_R8 )
      LWORK = 5 * M + 2
      DO I = 3, M + 3
         DO L = 2, I - 1
            ALPHA(1:L-1, 1:M) = ALPHA_IN(1:L-1, 1:M)
            ALPHA(L:I-2, 1:M) = ALPHA_IN(L+1:I-1, 1:M)
            ALPHA(I-1:M+1, 1:M) = ALPHA_IN(I+1:M+3, 1:M)
            BETA(1:L-1,1) = BETA_IN(1:L-1)
            BETA(L:I-2,1) = BETA_IN(L+1:I-1)
            BETA(I-1:M+1,1) = BETA_IN(I+1:M+3)
            CALL DGELSS( M+1,M,1,ALPHA(1:M+1,1:M),M+1,BETA(1:M+1,1),M+1, &
                 SIGMA, RCOND, RANK, WORK, LWORK, INFO )
            IF ( ABS( BETA(M+1,1) ) < LSE )  THEN
               LSE = ABS( BETA(M+1,1) )
               A(1:M, K) = BETA(1:M,1)
               IDIST(1:L-1) = D(J, 1:L-1)
               IDIST(L:I-2) = D(J, L+1:I-1)
               IDIST(I-1:M+1) = D(J, I+1:M+3)
            END IF
         END DO
      END DO
   END DO
! Compute the scale estimate and distance vector from the optimal set R.
   BETA_IN(1:M+1) = F(IDIST(1:M+1)) - F(K)
   DO I = 1, M + 1
      ALPHA_IN(I, 1:M) = X(1:M, IDIST(I)) - X(1:M, K)
      DIST(I) = DOT_PRODUCT( ALPHA_IN(I, 1:M), ALPHA_IN(I, 1:M) )
   END DO
   RES(1:M+1) = MATMUL( ALPHA_IN(1:M+1, 1:M), A(1:M, K) ) - BETA_IN(1:M+1)
   MAR = MAX( MAD( RES(1:M+1),NP ), 1.0E-6_R8 )
! Determine the set T for the final local approx.
   BETA_IN(1:NP) = F(S(K, 1:NP)) - F(K)
   DO I = 1, NP
      ALPHA_IN(I, 1:M) = X(1:M, S(K, I)) - X(1:M, K)
   END DO
   RW(K) = DOT_PRODUCT( ALPHA_IN(NP, :), ALPHA_IN(NP, :) )
   CALL SORT( DIST, IDIST, M + 1, M + 1 )
   DO I = 1, M + 1
      IF ( DIST(I) > RW(K) .OR. ( DIST(I) == RW(K) .AND. ALL( IDIST(I) &
           /= S(K, 1: MIN( N - 1, (3 * M + 1) / 2 )) ) ) ) THEN
         NP = NP + 1
         BETA_IN(NP) = F(IDIST(I)) - F(K)
         ALPHA_IN(NP, 1:M) = X(1:M, IDIST(I)) - X(1:M, K)
      END IF
   END DO
   RW(K) = SQRT( RW(K) )
   RES(1:NP) = MATMUL( ALPHA_IN(1:NP, 1:M), A(1:M, K) ) - BETA_IN(1:NP)
   FUNC = 1
   ITER = 5
   CALL IRLS(M, N, MAR, ITER, FUNC, OMEGA, BETA, BETA_IN, ALPHA, ALPHA_IN, &
        RES, NP, IER1 )
   IF ( IER1  /= 0 ) THEN
      IER = 2
      CYCLE
   ELSE
      A(1:M, K) = BETA(1:M,1)
   END IF
   FUNC = 2
   ITER = 5
   CALL IRLS(M, N, MAR, ITER, FUNC, OMEGA, BETA, BETA_IN, ALPHA, ALPHA_IN, &
        RES, NP, IER1 )
   IF ( IER1 /= 0 ) THEN
      IER = 2
      CYCLE
   ELSE
      A(1:M, K) = BETA(1:M,1)
   END IF
! Adjust RW(K) according to the weights.
   DO I = 1, NP
      IF ( OMEGA(I) < 0.8_R8 ) THEN
         IF ( I == 1 ) THEN
            RW(K) = SQRT( DOT_PRODUCT( ALPHA_IN(I, :), ALPHA_IN(I, :) ) ) &
                 / 2.0_R8
         ELSE
            RW(K) = (SQRT( DOT_PRODUCT( ALPHA_IN(I-1, :), ALPHA_IN(I-1, :) ) )&
                 + SQRT( DOT_PRODUCT( ALPHA_IN(I, :), ALPHA_IN(I, :) ) )) &
                 / 2.0_R8
         END IF
         EXIT
      END IF
   END DO
END DO
RW(1:N) = MIN( SQRT( DIAM ) / 2.0_R8, RW(1:N) )
RETURN
END SUBROUTINE RIPPLE

END MODULE LINEAR_SHEPARD_MOD

module Fortran_Sleep
use, intrinsic :: iso_c_binding, only: c_int
implicit none
interface
   !should be unsigned int ... not available in Fortran
   !OK until highest bit gets set.
   function FortSleep(seconds)  bind(C, name="sleep")
       import
       integer (c_int) :: FortSleep
       integer (c_int), intent (in), VALUE :: seconds
   end function FortSleep
end interface

end module Fortran_Sleep

program hello_fortran
  use mpi
  use, intrinsic :: iso_c_binding, only: c_int
  use Fortran_Sleep

  implicit none

  integer (kind = 4) :: err
  integer (kind = 4) :: rank
  integer (kind = 4) :: nprocs
  character(len=32)  :: arg
  character(len=32)  :: arglist(2)
  integer (c_int)    :: delay,dummy
  integer            :: i

  delay=5
  dummy = FortSleep(delay)


  !init in case get no args
  DO i = 1, 2
    arglist(i) = "None"
  END DO

  DO i = 1, iargc()
    CALL getarg(i, arg)
    arglist(i) = arg
  END DO

  call mpi_init(err)
  call mpi_comm_size (MPI_COMM_WORLD, nprocs, err)
  call mpi_comm_rank (MPI_COMM_WORLD, rank, err)



  write(*,100) rank, nprocs, trim(arglist(1)), trim(arglist(2))

  call MPI_Finalize (err)

  100 FORMAT('Hello World from proc: ',i3,' of',i3,'  arg1: ',a,'  arg2: ',a)
end program hello_fortran

MODULE QNSTOPS_MOD
! Code for generating a latin hypercube experimental design from the QNSTOP
! software package.
!
! Credit to B. D. Amos, D. R. Easterling, L. T. Watson, W. I. Thacker,
! B. S. Castle, and M. W. Trosset. Algorithm XXX: QNSTOP -- Quasi-Newton
! Algorithm for Stochastic Optimization.
!
USE REAL_PRECISION, ONLY : R8
CONTAINS

SUBROUTINE LATINDESIGN(P, LNSTART, LB, UB, XI, LHSDESIGN)
! LATINDESIGN generates a Latin hypercube experimental design with
! LNSTART points, one of which is XI, in the P-dimensional box
! B = { x | LB <= x <= UB }.  Partition each interval [LB(J),UB(J)]
! into LNSTART equal length subintervals, which partitions the box B
! into cells. A Latin hypercube experimental design has the property
! that if the LNSTART points are projected onto any coordinate
! direction K, for 1 <= K <= P, the projection has exactly one point
! in each of the subintervals of [LB(K),UB(K)].  The cells centered
! along the diameter [LB,UB] of the box B are called the diagonal cells.
!
! The algorithm is to first generate LNSTART points in the diagonal
! cells, stored as the columns of the array LHSDESIGN(1:P,1:LNSTART).
! Then swap appropriate coordinates with the last column so that the
! given point XI can be inserted as the last column.  Finally, permute
! the coordinates within rows of LHSDESIGN(1:P,1:LNSTART-1) by doing
! LNSTART-2 random interchanges in each row.
!
! On input:
!
! P is the dimension.
!
! LNSTART is the integer number of points in the experimental design.
!
! LB(1:P) is a real array giving the lower bounds.
!
! UB(1:P) is a real array giving the upper bounds, defining the box
!   { x | LB <= x <= UB } in which design is generated.
!
! XI(1:P) is a real array containing the start point to be inserted in the
!   Latin hypercube design.
!
! On output:
!
! LHSDESIGN(1:P,1:LNSTART) is a real array whose columns are the Latin
!   hypercube experimental design, with XI being the last column.

INTEGER, INTENT(IN):: P, LNSTART
REAL(KIND=R8), DIMENSION(P), INTENT(IN):: LB, UB, XI
REAL(KIND=R8), DIMENSION(P,LNSTART), INTENT(OUT):: LHSDESIGN

! Local variables.
INTEGER:: I, J, L   ! Temporary loop variable.
REAL(KIND=R8):: TEMP  ! Used for swapping coordinates.
REAL(KIND=R8), DIMENSION(P):: WORK  ! Holds the bin sizes.
! SWAP is an array of random values for picking swap rows.
REAL(KIND=R8), DIMENSION(P,LNSTART-2):: SWAP


CALL RANDOM_NUMBER(HARVEST=LHSDESIGN(1:P,1:LNSTART))
WORK = (UB - LB)/REAL(LNSTART, KIND=R8)    ! Bin sizes.

! Start with all the points in diagonal cells.
DO J=1,LNSTART
  LHSDESIGN(1:P,J) = LB(1:P) + WORK(1:P)*(REAL(J-1, KIND=R8) + &
    LHSDESIGN(1:P,J))
END DO

! Now place the given start point XI into the last column by swapping
! coordinates.
DO J=1,P
  L = MIN(INT((XI(J) - LB(J))/WORK(J)) + 1, LNSTART )
  LHSDESIGN(J,L) = LHSDESIGN(J,LNSTART)
  LHSDESIGN(J,LNSTART) = XI(J)
END DO

CALL RANDOM_NUMBER(HARVEST=SWAP(1:P, 1:LNSTART-2))
! Permute coordinates within each row of LHSDESIGN(1:P,1:LNSTART-1) by
! doing LNSTART - 2 interchanges.
DO I=1,P
  DO J=LNSTART-1,2,-1
    L = INT(SWAP(I,J-1)*REAL(J,KIND=R8)) + 1
    TEMP = LHSDESIGN(I,J)
    LHSDESIGN(I,J) = LHSDESIGN(I,L)
    LHSDESIGN(I,L) = TEMP
  END DO
END DO
RETURN
END SUBROUTINE LATINDESIGN

END MODULE QNSTOPS_MOD

*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
* ======================================

      DOUBLE PRECISION FUNCTION DASUM(N,DX,INCX)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*)
*     ..
*
* Purpose:
* =============
*
*    DASUM takes the sum of the absolute values.
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
* Further Details:
* =====================
*
*      jack dongarra, linpack, 3/11/78.
*      modified 3/93 to return if incx .le. 0.
*      modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,M,MP1,NINCX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DABS,MOD
*     ..
      DASUM = 0.0D0
      DTEMP = 0.0D0
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) THEN
*        code for increment equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,6)
         IF (M.NE.0) THEN
            DO I = 1,M
               DTEMP = DTEMP + DABS(DX(I))
            END DO
            IF (N.LT.6) THEN
               DASUM = DTEMP
               RETURN
            END IF
         END IF
         MP1 = M + 1
         DO I = MP1,N,6
            DTEMP = DTEMP + DABS(DX(I)) + DABS(DX(I+1)) +
     $              DABS(DX(I+2)) + DABS(DX(I+3)) +
     $              DABS(DX(I+4)) + DABS(DX(I+5))
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         NINCX = N*INCX
         DO I = 1,NINCX,INCX
            DTEMP = DTEMP + DABS(DX(I))
         END DO
      END IF
      DASUM = DTEMP
      RETURN
      END

      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION DA
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
* Purpose:
* =============
*
*    DAXPY constant times a vector plus a vector.
*    uses unrolled loops for increments equal to one.
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DA is DOUBLE PRECISION. On entry, DA specifies the scalar alpha.
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
*    DY is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCY ) )
*
*    INCY is INTEGER storage spacing between elements of DY
*
* Further Details:
* =====================
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (DA.EQ.0.0D0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*        code for both increments equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,4)
         IF (M.NE.0) THEN
            DO I = 1,M
               DY(I) = DY(I) + DA*DX(I)
            END DO
         END IF
         IF (N.LT.4) RETURN
         MP1 = M + 1
         DO I = MP1,N,4
            DY(I) = DY(I) + DA*DX(I)
            DY(I+1) = DY(I+1) + DA*DX(I+1)
            DY(I+2) = DY(I+2) + DA*DX(I+2)
            DY(I+3) = DY(I+3) + DA*DX(I+3)
         END DO
      ELSE
*
*        code for unequal increments or equal increments
*          not equal to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
          DY(IY) = DY(IY) + DA*DX(IX)
          IX = IX + INCX
          IY = IY + INCY
         END DO
      END IF
      RETURN
      END

      SUBROUTINE DCOPY(N,DX,INCX,DY,INCY)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
* Purpose:
* =============
*
*    DCOPY copies a vector, x, to a vector, y.
*    uses unrolled loops for increments equal to 1.
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
*    DY is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCY ) )
*
*    INCY is INTEGER storage spacing between elements of DY
*
* Further Details:
* =====================
*
*    jack dongarra, linpack, 3/11/78.
*    modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*        code for both increments equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,7)
         IF (M.NE.0) THEN
            DO I = 1,M
               DY(I) = DX(I)
            END DO
            IF (N.LT.7) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,7
            DY(I) = DX(I)
            DY(I+1) = DX(I+1)
            DY(I+2) = DX(I+2)
            DY(I+3) = DX(I+3)
            DY(I+4) = DX(I+4)
            DY(I+5) = DX(I+5)
            DY(I+6) = DX(I+6)
         END DO
      ELSE
*
*        code for unequal increments or equal increments
*          not equal to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            DY(IY) = DX(IX)
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      RETURN
      END

      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
* Purpose:
* =============
*
*    DDOT forms the dot product of two vectors.
*    uses unrolled loops for increments equal to one.
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
*    DY is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCY ) )
*
*    INCY is INTEGER storage spacing between elements of DY
*
* Further Details:
* =====================
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      DDOT = 0.0D0
      DTEMP = 0.0D0
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*        code for both increments equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,5)
         IF (M.NE.0) THEN
            DO I = 1,M
               DTEMP = DTEMP + DX(I)*DY(I)
            END DO
            IF (N.LT.5) THEN
               DDOT=DTEMP
            RETURN
            END IF
         END IF
         MP1 = M + 1
         DO I = MP1,N,5
          DTEMP = DTEMP + DX(I)*DY(I) + DX(I+1)*DY(I+1) +
     $            DX(I+2)*DY(I+2) + DX(I+3)*DY(I+3) + DX(I+4)*DY(I+4)
         END DO
      ELSE
*
*        code for unequal increments or equal increments
*          not equal to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            DTEMP = DTEMP + DX(IX)*DY(IY)
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      DDOT = DTEMP
      RETURN
      END

      SUBROUTINE DGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
*
*  -- Reference BLAS level3 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of
*  Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG
*  Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA,BETA
      INTEGER K,LDA,LDB,LDC,M,N
      CHARACTER TRANSA,TRANSB
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),B(LDB,*),C(LDC,*)
*     ..
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,J,L,NCOLA,NROWA,NROWB
      LOGICAL NOTA,NOTB
*     ..
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER(ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*
*     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are
*     not
*     transposed and set  NROWA, NCOLA and  NROWB  as the number of
*     rows
*     and  columns of  A  and the  number of  rows  of  B
*     respectively.
*
      NOTA = LSAME(TRANSA,'N')
      NOTB = LSAME(TRANSB,'N')
      IF (NOTA) THEN
          NROWA = M
          NCOLA = K
      ELSE
          NROWA = K
          NCOLA = M
      END IF
      IF (NOTB) THEN
          NROWB = K
      ELSE
          NROWB = N
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF ((.NOT.NOTA) .AND. (.NOT.LSAME(TRANSA,'C')) .AND.
     +    (.NOT.LSAME(TRANSA,'T'))) THEN
          INFO = 1
      ELSE IF ((.NOT.NOTB) .AND. (.NOT.LSAME(TRANSB,'C')) .AND.
     +         (.NOT.LSAME(TRANSB,'T'))) THEN
          INFO = 2
      ELSE IF (M.LT.0) THEN
          INFO = 3
      ELSE IF (N.LT.0) THEN
          INFO = 4
      ELSE IF (K.LT.0) THEN
          INFO = 5
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 8
      ELSE IF (LDB.LT.MAX(1,NROWB)) THEN
          INFO = 10
      ELSE IF (LDC.LT.MAX(1,M)) THEN
          INFO = 13
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DGEMM ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR.
     +    (((ALPHA.EQ.ZERO).OR. (K.EQ.0)).AND. (BETA.EQ.ONE))) RETURN
*
*     And if  alpha.eq.zero.
*
      IF (ALPHA.EQ.ZERO) THEN
          IF (BETA.EQ.ZERO) THEN
              DO 20 J = 1,N
                  DO 10 I = 1,M
                      C(I,J) = ZERO
   10             CONTINUE
   20         CONTINUE
          ELSE
              DO 40 J = 1,N
                  DO 30 I = 1,M
                      C(I,J) = BETA*C(I,J)
   30             CONTINUE
   40         CONTINUE
          END IF
          RETURN
      END IF
*
*     Start the operations.
*
      IF (NOTB) THEN
          IF (NOTA) THEN
*
*           Form  C := alpha*A*B + beta*C.
*
              DO 90 J = 1,N
                  IF (BETA.EQ.ZERO) THEN
                      DO 50 I = 1,M
                          C(I,J) = ZERO
   50                 CONTINUE
                  ELSE IF (BETA.NE.ONE) THEN
                      DO 60 I = 1,M
                          C(I,J) = BETA*C(I,J)
   60                 CONTINUE
                  END IF
                  DO 80 L = 1,K
                      TEMP = ALPHA*B(L,J)
                      DO 70 I = 1,M
                          C(I,J) = C(I,J) + TEMP*A(I,L)
   70                 CONTINUE
   80             CONTINUE
   90         CONTINUE
          ELSE
*
*           Form  C := alpha*A**T*B + beta*C
*
              DO 120 J = 1,N
                  DO 110 I = 1,M
                      TEMP = ZERO
                      DO 100 L = 1,K
                          TEMP = TEMP + A(L,I)*B(L,J)
  100                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = ALPHA*TEMP
                      ELSE
                          C(I,J) = ALPHA*TEMP + BETA*C(I,J)
                      END IF
  110             CONTINUE
  120         CONTINUE
          END IF
      ELSE
          IF (NOTA) THEN
*
*           Form  C := alpha*A*B**T + beta*C
*
              DO 170 J = 1,N
                  IF (BETA.EQ.ZERO) THEN
                      DO 130 I = 1,M
                          C(I,J) = ZERO
  130                 CONTINUE
                  ELSE IF (BETA.NE.ONE) THEN
                      DO 140 I = 1,M
                          C(I,J) = BETA*C(I,J)
  140                 CONTINUE
                  END IF
                  DO 160 L = 1,K
                      TEMP = ALPHA*B(J,L)
                      DO 150 I = 1,M
                          C(I,J) = C(I,J) + TEMP*A(I,L)
  150                 CONTINUE
  160             CONTINUE
  170         CONTINUE
          ELSE
*
*           Form  C := alpha*A**T*B**T + beta*C
*
              DO 200 J = 1,N
                  DO 190 I = 1,M
                      TEMP = ZERO
                      DO 180 L = 1,K
                          TEMP = TEMP + A(L,I)*B(J,L)
  180                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = ALPHA*TEMP
                      ELSE
                          C(I,J) = ALPHA*TEMP + BETA*C(I,J)
                      END IF
  190             CONTINUE
  200         CONTINUE
          END IF
      END IF
*
      RETURN
*
*     End of DGEMM .
*
      END

      SUBROUTINE DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
*
*  -- Reference BLAS level2 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA,BETA
      INTEGER INCX,INCY,LDA,M,N
      CHARACTER TRANS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),X(*),Y(*)
*     ..
*
* Purpose:
* =============
*
* DGEMV  performs one of the matrix-vector operations
*
*    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
*
* where alpha and beta are scalars, x and y are vectors and A is an
* m by n matrix.
*
* Arguments:
* ==========
*
*    TRANS is CHARACTER*1
*     On entry, TRANS specifies the operation to be performed as
*     follows:
*
*        TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
*
*        TRANS = 'T' or 't'   y := alpha*A**T*x + beta*y.
*
*        TRANS = 'C' or 'c'   y := alpha*A**T*x + beta*y.
*    M is INTEGER
*     On entry, M specifies the number of rows of the matrix A.
*     M must be at least zero.
*
*    N is INTEGER
*     On entry, N specifies the number of columns of the matrix A.
*     N must be at least zero.
*
*    ALPHA is DOUBLE PRECISION.
*     On entry, ALPHA specifies the scalar alpha.
*
*    A is DOUBLE PRECISION array, dimension ( LDA, N )
*     Before entry, the leading m by n part of the array A must
*     contain the matrix of coefficients.
*
*    LDA is INTEGER
*     On entry, LDA specifies the first dimension of A as declared
*     in the calling (sub) program. LDA must be at least
*     max( 1, m ).
*
*    X is DOUBLE PRECISION array, dimension at least
*     ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
*     and at least
*     ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
*     Before entry, the incremented array X must contain the
*     vector x.
*
*    INCX is INTEGER
*     On entry, INCX specifies the increment for the elements of
*     X. INCX must not be zero.
*
*    BETA is DOUBLE PRECISION.
*     On entry, BETA specifies the scalar beta. When BETA is
*     supplied as zero then Y need not be set on input.
*
*    Y is DOUBLE PRECISION array, dimension at least
*     ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
*     and at least
*     ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
*     Before entry with BETA non-zero, the incremented array Y
*     must contain the vector y. On exit, Y is overwritten by the
*     updated vector y.
*
*    INCY is INTEGER
*     On entry, INCY specifies the increment for the elements of
*     Y. INCY must not be zero.
*
* Further Details:
* =====================
*
*  Level 2 Blas routine.
*  The vector and matrix arguments are not referenced when N = 0, or M = 0
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER(ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,IX,IY,J,JX,JY,KX,KY,LENX,LENY
*     ..
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (.NOT.LSAME(TRANS,'N') .AND. .NOT.LSAME(TRANS,'T') .AND.
     +    .NOT.LSAME(TRANS,'C')) THEN
          INFO = 1
      ELSE IF (M.LT.0) THEN
          INFO = 2
      ELSE IF (N.LT.0) THEN
          INFO = 3
      ELSE IF (LDA.LT.MAX(1,M)) THEN
          INFO = 6
      ELSE IF (INCX.EQ.0) THEN
          INFO = 8
      ELSE IF (INCY.EQ.0) THEN
          INFO = 11
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DGEMV ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR.
     +    ((ALPHA.EQ.ZERO).AND. (BETA.EQ.ONE))) RETURN
*
*     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
*     up the start points in  X  and  Y.
*
      IF (LSAME(TRANS,'N')) THEN
          LENX = N
          LENY = M
      ELSE
          LENX = M
          LENY = N
      END IF
      IF (INCX.GT.0) THEN
          KX = 1
      ELSE
          KX = 1 - (LENX-1)*INCX
      END IF
      IF (INCY.GT.0) THEN
          KY = 1
      ELSE
          KY = 1 - (LENY-1)*INCY
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
*     First form  y := beta*y.
*
      IF (BETA.NE.ONE) THEN
          IF (INCY.EQ.1) THEN
              IF (BETA.EQ.ZERO) THEN
                  DO 10 I = 1,LENY
                      Y(I) = ZERO
   10             CONTINUE
              ELSE
                  DO 20 I = 1,LENY
                      Y(I) = BETA*Y(I)
   20             CONTINUE
              END IF
          ELSE
              IY = KY
              IF (BETA.EQ.ZERO) THEN
                  DO 30 I = 1,LENY
                      Y(IY) = ZERO
                      IY = IY + INCY
   30             CONTINUE
              ELSE
                  DO 40 I = 1,LENY
                      Y(IY) = BETA*Y(IY)
                      IY = IY + INCY
   40             CONTINUE
              END IF
          END IF
      END IF
      IF (ALPHA.EQ.ZERO) RETURN
      IF (LSAME(TRANS,'N')) THEN
*
*        Form  y := alpha*A*x + y.
*
          JX = KX
          IF (INCY.EQ.1) THEN
              DO 60 J = 1,N
                  TEMP = ALPHA*X(JX)
                  DO 50 I = 1,M
                      Y(I) = Y(I) + TEMP*A(I,J)
   50             CONTINUE
                  JX = JX + INCX
   60         CONTINUE
          ELSE
              DO 80 J = 1,N
                  TEMP = ALPHA*X(JX)
                  IY = KY
                  DO 70 I = 1,M
                      Y(IY) = Y(IY) + TEMP*A(I,J)
                      IY = IY + INCY
   70             CONTINUE
                  JX = JX + INCX
   80         CONTINUE
          END IF
      ELSE
*
*        Form  y := alpha*A**T*x + y.
*
          JY = KY
          IF (INCX.EQ.1) THEN
              DO 100 J = 1,N
                  TEMP = ZERO
                  DO 90 I = 1,M
                      TEMP = TEMP + A(I,J)*X(I)
   90             CONTINUE
                  Y(JY) = Y(JY) + ALPHA*TEMP
                  JY = JY + INCY
  100         CONTINUE
          ELSE
              DO 120 J = 1,N
                  TEMP = ZERO
                  IX = KX
                  DO 110 I = 1,M
                      TEMP = TEMP + A(I,J)*X(IX)
                      IX = IX + INCX
  110             CONTINUE
                  Y(JY) = Y(JY) + ALPHA*TEMP
                  JY = JY + INCY
  120         CONTINUE
          END IF
      END IF
*
      RETURN
*
*     End of DGEMV .
*
      END

      SUBROUTINE DGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
*
*  -- Reference BLAS level2 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of
*  Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG
*  Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA
      INTEGER INCX,INCY,LDA,M,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),X(*),Y(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION ZERO
      PARAMETER(ZERO=0.0D+0)
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,IX,J,JY,KX
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (M.LT.0) THEN
          INFO = 1
      ELSE IF (N.LT.0) THEN
          INFO = 2
      ELSE IF (INCX.EQ.0) THEN
          INFO = 5
      ELSE IF (INCY.EQ.0) THEN
          INFO = 7
      ELSE IF (LDA.LT.MAX(1,M)) THEN
          INFO = 9
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DGER  ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR. (ALPHA.EQ.ZERO)) RETURN
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF (INCY.GT.0) THEN
          JY = 1
      ELSE
          JY = 1 - (N-1)*INCY
      END IF
      IF (INCX.EQ.1) THEN
          DO 20 J = 1,N
              IF (Y(JY).NE.ZERO) THEN
                  TEMP = ALPHA*Y(JY)
                  DO 10 I = 1,M
                      A(I,J) = A(I,J) + X(I)*TEMP
   10             CONTINUE
              END IF
              JY = JY + INCY
   20     CONTINUE
      ELSE
          IF (INCX.GT.0) THEN
              KX = 1
          ELSE
              KX = 1 - (M-1)*INCX
          END IF
          DO 40 J = 1,N
              IF (Y(JY).NE.ZERO) THEN
                  TEMP = ALPHA*Y(JY)
                  IX = KX
                  DO 30 I = 1,M
                      A(I,J) = A(I,J) + X(IX)*TEMP
                      IX = IX + INCX
   30             CONTINUE
              END IF
              JY = JY + INCY
   40     CONTINUE
      END IF
*
      RETURN
*
*     End of DGER  .
*
      END

      DOUBLE PRECISION FUNCTION DNRM2(N,X,INCX)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION X(*)
*     ..
*
* Purpose:
* =============
*
* DNRM2 returns the euclidean norm of a vector via the function
* name, so that
*
*    DNRM2 := sqrt( x'*x )
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    X is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
* Further Details:
* =====================
*
*  -- This version written on 25-October-1982.
*     Modified on 14-October-1993 to inline the call to DLASSQ.
*     Sven Hammarling, Nag Ltd.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER(ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION ABSXI,NORM,SCALE,SSQ
      INTEGER IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC ABS,SQRT
*     ..
      IF (N.LT.1 .OR. INCX.LT.1) THEN
          NORM = ZERO
      ELSE IF (N.EQ.1) THEN
          NORM = ABS(X(1))
      ELSE
          SCALE = ZERO
          SSQ = ONE
*        The following loop is equivalent to this call to the LAPACK
*        auxiliary routine:
*        CALL DLASSQ( N, X, INCX, SCALE, SSQ )
*
          DO 10 IX = 1,1 + (N-1)*INCX,INCX
              IF (X(IX).NE.ZERO) THEN
                  ABSXI = ABS(X(IX))
                  IF (SCALE.LT.ABSXI) THEN
                      SSQ = ONE + SSQ* (SCALE/ABSXI)**2
                      SCALE = ABSXI
                  ELSE
                      SSQ = SSQ + (ABSXI/SCALE)**2
                  END IF
              END IF
   10     CONTINUE
          NORM = SCALE*SQRT(SSQ)
      END IF
*
      DNRM2 = NORM
      RETURN
*
*     End of DNRM2.
*
      END

      SUBROUTINE DROT(N,DX,INCX,DY,INCY,C,S)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION C,S
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
*  Purpose:
*  =============
*
*    DROT applies a plane rotation.
*
*  Arguments:
*  ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
*    DY is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCY ) )
*
*    INCY is INTEGER storage spacing between elements of DY
*
*    C is DOUBLE PRECISION
*
*    S is DOUBLE PRECISION
*
*  Further Details:
*  =====================
*
*    jack dongarra, linpack, 3/11/78.
*    modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,IX,IY
*     ..
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*       code for both increments equal to 1
*
         DO I = 1,N
            DTEMP = C*DX(I) + S*DY(I)
            DY(I) = C*DY(I) - S*DX(I)
            DX(I) = DTEMP
         END DO
      ELSE
*
*       code for unequal increments or equal increments not equal
*         to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            DTEMP = C*DX(IX) + S*DY(IY)
            DY(IY) = C*DY(IY) - S*DX(IX)
            DX(IX) = DTEMP
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      RETURN
      END

      SUBROUTINE DSCAL(N,DA,DX,INCX)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION DA
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*)
*     ..
*
* Purpose:
* =============
*
*    DSCAL scales a vector by a constant.
*    uses unrolled loops for increment equal to 1.
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DA is DOUBLE PRECISION On entry, DA specifies the scalar alpha.
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
* Further Details:
* =====================
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,M,MP1,NINCX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,5)
         IF (M.NE.0) THEN
            DO I = 1,M
               DX(I) = DA*DX(I)
            END DO
            IF (N.LT.5) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,5
            DX(I) = DA*DX(I)
            DX(I+1) = DA*DX(I+1)
            DX(I+2) = DA*DX(I+2)
            DX(I+3) = DA*DX(I+3)
            DX(I+4) = DA*DX(I+4)
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         NINCX = N*INCX
         DO I = 1,NINCX,INCX
            DX(I) = DA*DX(I)
         END DO
      END IF
      RETURN
      END

      SUBROUTINE DSWAP(N,DX,INCX,DY,INCY)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
* Purpose:
* =============
*
*    DSWAP interchanges two vectors.
*    uses unrolled loops for increments equal to 1.
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of DX
*
*    DY is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCY ) )
*
*    INCY is INTEGER storage spacing between elements of DY
*
* Further Details:
* =====================
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*       code for both increments equal to 1
*
*
*       clean-up loop
*
         M = MOD(N,3)
         IF (M.NE.0) THEN
            DO I = 1,M
               DTEMP = DX(I)
               DX(I) = DY(I)
               DY(I) = DTEMP
            END DO
            IF (N.LT.3) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,3
            DTEMP = DX(I)
            DX(I) = DY(I)
            DY(I) = DTEMP
            DTEMP = DX(I+1)
            DX(I+1) = DY(I+1)
            DY(I+1) = DTEMP
            DTEMP = DX(I+2)
            DX(I+2) = DY(I+2)
            DY(I+2) = DTEMP
         END DO
      ELSE
*
*       code for unequal increments or equal increments not equal
*         to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            DTEMP = DX(IX)
            DX(IX) = DY(IY)
            DY(IY) = DTEMP
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      RETURN
      END

      SUBROUTINE DTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
*
*  -- Reference BLAS level3 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of
*  Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG
*  Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA
      INTEGER LDA,LDB,M,N
      CHARACTER DIAG,SIDE,TRANSA,UPLO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),B(LDB,*)
*     ..
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,J,K,NROWA
      LOGICAL LSIDE,NOUNIT,UPPER
*     ..
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER(ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*
*     Test the input parameters.
*
      LSIDE = LSAME(SIDE,'L')
      IF (LSIDE) THEN
          NROWA = M
      ELSE
          NROWA = N
      END IF
      NOUNIT = LSAME(DIAG,'N')
      UPPER = LSAME(UPLO,'U')
*
      INFO = 0
      IF ((.NOT.LSIDE) .AND. (.NOT.LSAME(SIDE,'R'))) THEN
          INFO = 1
      ELSE IF ((.NOT.UPPER) .AND. (.NOT.LSAME(UPLO,'L'))) THEN
          INFO = 2
      ELSE IF ((.NOT.LSAME(TRANSA,'N')) .AND.
     +         (.NOT.LSAME(TRANSA,'T')) .AND.
     +         (.NOT.LSAME(TRANSA,'C'))) THEN
          INFO = 3
      ELSE IF ((.NOT.LSAME(DIAG,'U')) .AND. (.NOT.LSAME(DIAG,'N'))) THEN
          INFO = 4
      ELSE IF (M.LT.0) THEN
          INFO = 5
      ELSE IF (N.LT.0) THEN
          INFO = 6
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 9
      ELSE IF (LDB.LT.MAX(1,M)) THEN
          INFO = 11
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DTRMM ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF (M.EQ.0 .OR. N.EQ.0) RETURN
*
*     And when  alpha.eq.zero.
*
      IF (ALPHA.EQ.ZERO) THEN
          DO 20 J = 1,N
              DO 10 I = 1,M
                  B(I,J) = ZERO
   10         CONTINUE
   20     CONTINUE
          RETURN
      END IF
*
*     Start the operations.
*
      IF (LSIDE) THEN
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*A*B.
*
              IF (UPPER) THEN
                  DO 50 J = 1,N
                      DO 40 K = 1,M
                          IF (B(K,J).NE.ZERO) THEN
                              TEMP = ALPHA*B(K,J)
                              DO 30 I = 1,K - 1
                                  B(I,J) = B(I,J) + TEMP*A(I,K)
   30                         CONTINUE
                              IF (NOUNIT) TEMP = TEMP*A(K,K)
                              B(K,J) = TEMP
                          END IF
   40                 CONTINUE
   50             CONTINUE
              ELSE
                  DO 80 J = 1,N
                      DO 70 K = M,1,-1
                          IF (B(K,J).NE.ZERO) THEN
                              TEMP = ALPHA*B(K,J)
                              B(K,J) = TEMP
                              IF (NOUNIT) B(K,J) = B(K,J)*A(K,K)
                              DO 60 I = K + 1,M
                                  B(I,J) = B(I,J) + TEMP*A(I,K)
   60                         CONTINUE
                          END IF
   70                 CONTINUE
   80             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*A**T*B.
*
              IF (UPPER) THEN
                  DO 110 J = 1,N
                      DO 100 I = M,1,-1
                          TEMP = B(I,J)
                          IF (NOUNIT) TEMP = TEMP*A(I,I)
                          DO 90 K = 1,I - 1
                              TEMP = TEMP + A(K,I)*B(K,J)
   90                     CONTINUE
                          B(I,J) = ALPHA*TEMP
  100                 CONTINUE
  110             CONTINUE
              ELSE
                  DO 140 J = 1,N
                      DO 130 I = 1,M
                          TEMP = B(I,J)
                          IF (NOUNIT) TEMP = TEMP*A(I,I)
                          DO 120 K = I + 1,M
                              TEMP = TEMP + A(K,I)*B(K,J)
  120                     CONTINUE
                          B(I,J) = ALPHA*TEMP
  130                 CONTINUE
  140             CONTINUE
              END IF
          END IF
      ELSE
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*B*A.
*
              IF (UPPER) THEN
                  DO 180 J = N,1,-1
                      TEMP = ALPHA
                      IF (NOUNIT) TEMP = TEMP*A(J,J)
                      DO 150 I = 1,M
                          B(I,J) = TEMP*B(I,J)
  150                 CONTINUE
                      DO 170 K = 1,J - 1
                          IF (A(K,J).NE.ZERO) THEN
                              TEMP = ALPHA*A(K,J)
                              DO 160 I = 1,M
                                  B(I,J) = B(I,J) + TEMP*B(I,K)
  160                         CONTINUE
                          END IF
  170                 CONTINUE
  180             CONTINUE
              ELSE
                  DO 220 J = 1,N
                      TEMP = ALPHA
                      IF (NOUNIT) TEMP = TEMP*A(J,J)
                      DO 190 I = 1,M
                          B(I,J) = TEMP*B(I,J)
  190                 CONTINUE
                      DO 210 K = J + 1,N
                          IF (A(K,J).NE.ZERO) THEN
                              TEMP = ALPHA*A(K,J)
                              DO 200 I = 1,M
                                  B(I,J) = B(I,J) + TEMP*B(I,K)
  200                         CONTINUE
                          END IF
  210                 CONTINUE
  220             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*B*A**T.
*
              IF (UPPER) THEN
                  DO 260 K = 1,N
                      DO 240 J = 1,K - 1
                          IF (A(J,K).NE.ZERO) THEN
                              TEMP = ALPHA*A(J,K)
                              DO 230 I = 1,M
                                  B(I,J) = B(I,J) + TEMP*B(I,K)
  230                         CONTINUE
                          END IF
  240                 CONTINUE
                      TEMP = ALPHA
                      IF (NOUNIT) TEMP = TEMP*A(K,K)
                      IF (TEMP.NE.ONE) THEN
                          DO 250 I = 1,M
                              B(I,K) = TEMP*B(I,K)
  250                     CONTINUE
                      END IF
  260             CONTINUE
              ELSE
                  DO 300 K = N,1,-1
                      DO 280 J = K + 1,N
                          IF (A(J,K).NE.ZERO) THEN
                              TEMP = ALPHA*A(J,K)
                              DO 270 I = 1,M
                                  B(I,J) = B(I,J) + TEMP*B(I,K)
  270                         CONTINUE
                          END IF
  280                 CONTINUE
                      TEMP = ALPHA
                      IF (NOUNIT) TEMP = TEMP*A(K,K)
                      IF (TEMP.NE.ONE) THEN
                          DO 290 I = 1,M
                              B(I,K) = TEMP*B(I,K)
  290                     CONTINUE
                      END IF
  300             CONTINUE
              END IF
          END IF
      END IF
*
      RETURN
*
*     End of DTRMM .
*
      END

      SUBROUTINE DTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
*
*  -- Reference BLAS level2 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of
*  Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG
*  Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      INTEGER INCX,LDA,N
      CHARACTER DIAG,TRANS,UPLO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),X(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION ZERO
      PARAMETER(ZERO=0.0D+0)
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,IX,J,JX,KX
      LOGICAL NOUNIT
*     ..
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (.NOT.LSAME(UPLO,'U') .AND. .NOT.LSAME(UPLO,'L')) THEN
          INFO = 1
      ELSE IF (.NOT.LSAME(TRANS,'N') .AND. .NOT.LSAME(TRANS,'T') .AND.
     +         .NOT.LSAME(TRANS,'C')) THEN
          INFO = 2
      ELSE IF (.NOT.LSAME(DIAG,'U') .AND. .NOT.LSAME(DIAG,'N')) THEN
          INFO = 3
      ELSE IF (N.LT.0) THEN
          INFO = 4
      ELSE IF (LDA.LT.MAX(1,N)) THEN
          INFO = 6
      ELSE IF (INCX.EQ.0) THEN
          INFO = 8
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DTRMV ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF (N.EQ.0) RETURN
*
      NOUNIT = LSAME(DIAG,'N')
*
*     Set up the start point in X if the increment is not unity. This
*     will be  ( N - 1 )*INCX  too small for descending loops.
*
      IF (INCX.LE.0) THEN
          KX = 1 - (N-1)*INCX
      ELSE IF (INCX.NE.1) THEN
          KX = 1
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF (LSAME(TRANS,'N')) THEN
*
*        Form  x := A*x.
*
          IF (LSAME(UPLO,'U')) THEN
              IF (INCX.EQ.1) THEN
                  DO 20 J = 1,N
                      IF (X(J).NE.ZERO) THEN
                          TEMP = X(J)
                          DO 10 I = 1,J - 1
                              X(I) = X(I) + TEMP*A(I,J)
   10                     CONTINUE
                          IF (NOUNIT) X(J) = X(J)*A(J,J)
                      END IF
   20             CONTINUE
              ELSE
                  JX = KX
                  DO 40 J = 1,N
                      IF (X(JX).NE.ZERO) THEN
                          TEMP = X(JX)
                          IX = KX
                          DO 30 I = 1,J - 1
                              X(IX) = X(IX) + TEMP*A(I,J)
                              IX = IX + INCX
   30                     CONTINUE
                          IF (NOUNIT) X(JX) = X(JX)*A(J,J)
                      END IF
                      JX = JX + INCX
   40             CONTINUE
              END IF
          ELSE
              IF (INCX.EQ.1) THEN
                  DO 60 J = N,1,-1
                      IF (X(J).NE.ZERO) THEN
                          TEMP = X(J)
                          DO 50 I = N,J + 1,-1
                              X(I) = X(I) + TEMP*A(I,J)
   50                     CONTINUE
                          IF (NOUNIT) X(J) = X(J)*A(J,J)
                      END IF
   60             CONTINUE
              ELSE
                  KX = KX + (N-1)*INCX
                  JX = KX
                  DO 80 J = N,1,-1
                      IF (X(JX).NE.ZERO) THEN
                          TEMP = X(JX)
                          IX = KX
                          DO 70 I = N,J + 1,-1
                              X(IX) = X(IX) + TEMP*A(I,J)
                              IX = IX - INCX
   70                     CONTINUE
                          IF (NOUNIT) X(JX) = X(JX)*A(J,J)
                      END IF
                      JX = JX - INCX
   80             CONTINUE
              END IF
          END IF
      ELSE
*
*        Form  x := A**T*x.
*
          IF (LSAME(UPLO,'U')) THEN
              IF (INCX.EQ.1) THEN
                  DO 100 J = N,1,-1
                      TEMP = X(J)
                      IF (NOUNIT) TEMP = TEMP*A(J,J)
                      DO 90 I = J - 1,1,-1
                          TEMP = TEMP + A(I,J)*X(I)
   90                 CONTINUE
                      X(J) = TEMP
  100             CONTINUE
              ELSE
                  JX = KX + (N-1)*INCX
                  DO 120 J = N,1,-1
                      TEMP = X(JX)
                      IX = JX
                      IF (NOUNIT) TEMP = TEMP*A(J,J)
                      DO 110 I = J - 1,1,-1
                          IX = IX - INCX
                          TEMP = TEMP + A(I,J)*X(IX)
  110                 CONTINUE
                      X(JX) = TEMP
                      JX = JX - INCX
  120             CONTINUE
              END IF
          ELSE
              IF (INCX.EQ.1) THEN
                  DO 140 J = 1,N
                      TEMP = X(J)
                      IF (NOUNIT) TEMP = TEMP*A(J,J)
                      DO 130 I = J + 1,N
                          TEMP = TEMP + A(I,J)*X(I)
  130                 CONTINUE
                      X(J) = TEMP
  140             CONTINUE
              ELSE
                  JX = KX
                  DO 160 J = 1,N
                      TEMP = X(JX)
                      IX = JX
                      IF (NOUNIT) TEMP = TEMP*A(J,J)
                      DO 150 I = J + 1,N
                          IX = IX + INCX
                          TEMP = TEMP + A(I,J)*X(IX)
  150                 CONTINUE
                      X(JX) = TEMP
                      JX = JX + INCX
  160             CONTINUE
              END IF
          END IF
      END IF
*
      RETURN
*
*     End of DTRMV .
*
      END

      SUBROUTINE DTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
*
*  -- Reference BLAS level3 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA
      INTEGER LDA,LDB,M,N
      CHARACTER DIAG,SIDE,TRANSA,UPLO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),B(LDB,*)
*     ..
*
* Purpose:
* =============
*
* DTRSM  solves one of the matrix equations
*
*    op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
*
* where alpha is a scalar, X and B are m by n matrices, A is a unit, or
* non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
*
*    op( A ) = A   or   op( A ) = A**T.
*
* The matrix X is overwritten on B.
*
* Arguments:
* ==========
*
*    SIDE is CHARACTER*1
*     On entry, SIDE specifies whether op( A ) appears on the left
*     or right of X as follows:
*
*        SIDE = 'L' or 'l'   op( A )*X = alpha*B.
*
*        SIDE = 'R' or 'r'   X*op( A ) = alpha*B.
*
*    UPLO is CHARACTER*1
*     On entry, UPLO specifies whether the matrix A is an upper or
*     lower triangular matrix as follows:
*
*        UPLO = 'U' or 'u'   A is an upper triangular matrix.
*
*        UPLO = 'L' or 'l'   A is a lower triangular matrix.
*
*    TRANSA is CHARACTER*1
*     On entry, TRANSA specifies the form of op( A ) to be used in
*     the matrix multiplication as follows:
*
*        TRANSA = 'N' or 'n'   op( A ) = A.
*
*        TRANSA = 'T' or 't'   op( A ) = A**T.
*
*        TRANSA = 'C' or 'c'   op( A ) = A**T.
*
*    DIAG is CHARACTER*1
*     On entry, DIAG specifies whether or not A is unit triangular
*     as follows:
*
*        DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*
*        DIAG = 'N' or 'n'   A is not assumed to be unit
*                            triangular.
*
*    M is INTEGER
*     On entry, M specifies the number of rows of B. M must be at
*     least zero.
*
*    N is INTEGER
*     On entry, N specifies the number of columns of B.  N must be
*     at least zero.
*
*    ALPHA is DOUBLE PRECISION.
*     On entry,  ALPHA specifies the scalar  alpha. When  alpha is
*     zero then  A is not referenced and  B need not be set before
*     entry.
*
*    A is DOUBLE PRECISION array, dimension ( LDA, k ),
*     where k is m when SIDE = 'L' or 'l'
*       and k is n when SIDE = 'R' or 'r'.
*     Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
*     upper triangular part of the array  A must contain the upper
*     triangular matrix  and the strictly lower triangular part of
*     A is not referenced.
*     Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
*     lower triangular part of the array  A must contain the lower
*     triangular matrix  and the strictly upper triangular part of
*     A is not referenced.
*     Note that when  DIAG = 'U' or 'u',  the diagonal elements of
*     A  are not referenced either,  but are assumed to be  unity.
*
*    LDA is INTEGER
*     On entry, LDA specifies the first dimension of A as declared
*     in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*     LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
*     then LDA must be at least max( 1, n ).
*
*    B is DOUBLE PRECISION array, dimension ( LDB, N )
*     Before entry,  the leading  m by n part of the array  B must
*     contain  the  right-hand  side  matrix  B,  and  on exit  is
*     overwritten by the solution matrix  X.
*
*    LDB is INTEGER
*     On entry, LDB specifies the first dimension of B as declared
*     in  the  calling  (sub)  program.   LDB  must  be  at  least
*     max( 1, m ).
*
* Further Details:
* =====================
*
*  Level 3 Blas routine.
*
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,J,K,NROWA
      LOGICAL LSIDE,NOUNIT,UPPER
*     ..
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER(ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*
*     Test the input parameters.
*
      LSIDE = LSAME(SIDE,'L')
      IF (LSIDE) THEN
          NROWA = M
      ELSE
          NROWA = N
      END IF
      NOUNIT = LSAME(DIAG,'N')
      UPPER = LSAME(UPLO,'U')
*
      INFO = 0
      IF ((.NOT.LSIDE) .AND. (.NOT.LSAME(SIDE,'R'))) THEN
          INFO = 1
      ELSE IF ((.NOT.UPPER) .AND. (.NOT.LSAME(UPLO,'L'))) THEN
          INFO = 2
      ELSE IF ((.NOT.LSAME(TRANSA,'N')) .AND.
     +         (.NOT.LSAME(TRANSA,'T')) .AND.
     +         (.NOT.LSAME(TRANSA,'C'))) THEN
          INFO = 3
      ELSE IF ((.NOT.LSAME(DIAG,'U')) .AND. (.NOT.LSAME(DIAG,'N'))) THEN
          INFO = 4
      ELSE IF (M.LT.0) THEN
          INFO = 5
      ELSE IF (N.LT.0) THEN
          INFO = 6
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 9
      ELSE IF (LDB.LT.MAX(1,M)) THEN
          INFO = 11
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DTRSM ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF (M.EQ.0 .OR. N.EQ.0) RETURN
*
*     And when  alpha.eq.zero.
*
      IF (ALPHA.EQ.ZERO) THEN
          DO 20 J = 1,N
              DO 10 I = 1,M
                  B(I,J) = ZERO
   10         CONTINUE
   20     CONTINUE
          RETURN
      END IF
*
*     Start the operations.
*
      IF (LSIDE) THEN
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*inv( A )*B.
*
              IF (UPPER) THEN
                  DO 60 J = 1,N
                      IF (ALPHA.NE.ONE) THEN
                          DO 30 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
   30                     CONTINUE
                      END IF
                      DO 50 K = M,1,-1
                          IF (B(K,J).NE.ZERO) THEN
                              IF (NOUNIT) B(K,J) = B(K,J)/A(K,K)
                              DO 40 I = 1,K - 1
                                  B(I,J) = B(I,J) - B(K,J)*A(I,K)
   40                         CONTINUE
                          END IF
   50                 CONTINUE
   60             CONTINUE
              ELSE
                  DO 100 J = 1,N
                      IF (ALPHA.NE.ONE) THEN
                          DO 70 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
   70                     CONTINUE
                      END IF
                      DO 90 K = 1,M
                          IF (B(K,J).NE.ZERO) THEN
                              IF (NOUNIT) B(K,J) = B(K,J)/A(K,K)
                              DO 80 I = K + 1,M
                                  B(I,J) = B(I,J) - B(K,J)*A(I,K)
   80                         CONTINUE
                          END IF
   90                 CONTINUE
  100             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*inv( A**T )*B.
*
              IF (UPPER) THEN
                  DO 130 J = 1,N
                      DO 120 I = 1,M
                          TEMP = ALPHA*B(I,J)
                          DO 110 K = 1,I - 1
                              TEMP = TEMP - A(K,I)*B(K,J)
  110                     CONTINUE
                          IF (NOUNIT) TEMP = TEMP/A(I,I)
                          B(I,J) = TEMP
  120                 CONTINUE
  130             CONTINUE
              ELSE
                  DO 160 J = 1,N
                      DO 150 I = M,1,-1
                          TEMP = ALPHA*B(I,J)
                          DO 140 K = I + 1,M
                              TEMP = TEMP - A(K,I)*B(K,J)
  140                     CONTINUE
                          IF (NOUNIT) TEMP = TEMP/A(I,I)
                          B(I,J) = TEMP
  150                 CONTINUE
  160             CONTINUE
              END IF
          END IF
      ELSE
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*B*inv( A ).
*
              IF (UPPER) THEN
                  DO 210 J = 1,N
                      IF (ALPHA.NE.ONE) THEN
                          DO 170 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
  170                     CONTINUE
                      END IF
                      DO 190 K = 1,J - 1
                          IF (A(K,J).NE.ZERO) THEN
                              DO 180 I = 1,M
                                  B(I,J) = B(I,J) - A(K,J)*B(I,K)
  180                         CONTINUE
                          END IF
  190                 CONTINUE
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(J,J)
                          DO 200 I = 1,M
                              B(I,J) = TEMP*B(I,J)
  200                     CONTINUE
                      END IF
  210             CONTINUE
              ELSE
                  DO 260 J = N,1,-1
                      IF (ALPHA.NE.ONE) THEN
                          DO 220 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
  220                     CONTINUE
                      END IF
                      DO 240 K = J + 1,N
                          IF (A(K,J).NE.ZERO) THEN
                              DO 230 I = 1,M
                                  B(I,J) = B(I,J) - A(K,J)*B(I,K)
  230                         CONTINUE
                          END IF
  240                 CONTINUE
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(J,J)
                          DO 250 I = 1,M
                              B(I,J) = TEMP*B(I,J)
  250                     CONTINUE
                      END IF
  260             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*B*inv( A**T ).
*
              IF (UPPER) THEN
                  DO 310 K = N,1,-1
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(K,K)
                          DO 270 I = 1,M
                              B(I,K) = TEMP*B(I,K)
  270                     CONTINUE
                      END IF
                      DO 290 J = 1,K - 1
                          IF (A(J,K).NE.ZERO) THEN
                              TEMP = A(J,K)
                              DO 280 I = 1,M
                                  B(I,J) = B(I,J) - TEMP*B(I,K)
  280                         CONTINUE
                          END IF
  290                 CONTINUE
                      IF (ALPHA.NE.ONE) THEN
                          DO 300 I = 1,M
                              B(I,K) = ALPHA*B(I,K)
  300                     CONTINUE
                      END IF
  310             CONTINUE
              ELSE
                  DO 360 K = 1,N
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(K,K)
                          DO 320 I = 1,M
                              B(I,K) = TEMP*B(I,K)
  320                     CONTINUE
                      END IF
                      DO 340 J = K + 1,N
                          IF (A(J,K).NE.ZERO) THEN
                              TEMP = A(J,K)
                              DO 330 I = 1,M
                                  B(I,J) = B(I,J) - TEMP*B(I,K)
  330                         CONTINUE
                          END IF
  340                 CONTINUE
                      IF (ALPHA.NE.ONE) THEN
                          DO 350 I = 1,M
                              B(I,K) = ALPHA*B(I,K)
  350                     CONTINUE
                      END IF
  360             CONTINUE
              END IF
          END IF
      END IF
*
      RETURN
*
*     End of DTRSM .
*
      END

      INTEGER FUNCTION IDAMAX(N,DX,INCX)
*
*  -- Reference BLAS level1 routine (version 3.8.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2017
*
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*)
*     ..
*
* Purpose:
* =============
*
*    IDAMAX finds the index of the first element having maximum absolute value.
*
* Arguments:
* ==========
*
*    N is INTEGER number of elements in input vector(s)
*
*    DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*
*    INCX is INTEGER storage spacing between elements of SX
*
* Further Details:
* =====================
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DMAX
      INTEGER I,IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DABS
*     ..
      IDAMAX = 0
      IF (N.LT.1 .OR. INCX.LE.0) RETURN
      IDAMAX = 1
      IF (N.EQ.1) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
         DMAX = DABS(DX(1))
         DO I = 2,N
            IF (DABS(DX(I)).GT.DMAX) THEN
               IDAMAX = I
               DMAX = DABS(DX(I))
            END IF
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         IX = 1
         DMAX = DABS(DX(1))
         IX = IX + INCX
         DO I = 2,N
            IF (DABS(DX(IX)).GT.DMAX) THEN
               IDAMAX = I
               DMAX = DABS(DX(IX))
            END IF
            IX = IX + INCX
         END DO
      END IF
      RETURN
      END

      LOGICAL FUNCTION LSAME(CA,CB)
*
*  -- Reference BLAS level1 routine (version 3.1) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      CHARACTER CA,CB
*     ..
*
* Purpose:
* =============
*
* LSAME returns .TRUE. if CA is the same letter as CB regardless of
* case.
*
* Arguments:
* ==========
*
*    CA is CHARACTER*1
*    CB is CHARACTER*1
*    CA and CB specify the single characters to be compared.
*
*  =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC ICHAR
*     ..
*     .. Local Scalars ..
      INTEGER INTA,INTB,ZCODE
*     ..
*
*     Test if the characters are equal
*
      LSAME = CA .EQ. CB
      IF (LSAME) RETURN
*
*     Now test for equivalence if both characters are alphabetic.
*
      ZCODE = ICHAR('Z')
*
*     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
*     machines, on which ICHAR returns a value with bit 8 set.
*     ICHAR('A') on Prime machines returns 193 which is the same as
*     ICHAR('A') on an EBCDIC machine.
*
      INTA = ICHAR(CA)
      INTB = ICHAR(CB)
*
      IF (ZCODE.EQ.90 .OR. ZCODE.EQ.122) THEN
*
*        ASCII is assumed - ZCODE is the ASCII code of either lower or
*        upper case 'Z'.
*
          IF (INTA.GE.97 .AND. INTA.LE.122) INTA = INTA - 32
          IF (INTB.GE.97 .AND. INTB.LE.122) INTB = INTB - 32
*
      ELSE IF (ZCODE.EQ.233 .OR. ZCODE.EQ.169) THEN
*
*        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
*        upper case 'Z'.
*
          IF (INTA.GE.129 .AND. INTA.LE.137 .OR.
     +        INTA.GE.145 .AND. INTA.LE.153 .OR.
     +        INTA.GE.162 .AND. INTA.LE.169) INTA = INTA + 64
          IF (INTB.GE.129 .AND. INTB.LE.137 .OR.
     +        INTB.GE.145 .AND. INTB.LE.153 .OR.
     +        INTB.GE.162 .AND. INTB.LE.169) INTB = INTB + 64
*
      ELSE IF (ZCODE.EQ.218 .OR. ZCODE.EQ.250) THEN
*
*        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
*        plus 128 of either lower or upper case 'Z'.
*
          IF (INTA.GE.225 .AND. INTA.LE.250) INTA = INTA - 32
          IF (INTB.GE.225 .AND. INTB.LE.250) INTB = INTB - 32
      END IF
      LSAME = INTA .EQ. INTB
*
*     RETURN
*
*     End of LSAME
*
      END

      SUBROUTINE XERBLA( SRNAME, INFO )
*
*  -- Reference BLAS level1 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      CHARACTER*(*)      SRNAME
      INTEGER            INFO
*     ..
*
* Purpose:
* =============
*
* XERBLA  is an error handler for the LAPACK routines.
* It is called by an LAPACK routine if an input parameter has an
* invalid value.  A message is printed and execution stops.
*
* Installers may consider modifying the STOP statement in order to
* call system-specific exception-handling facilities.
*
* Arguments:
* ==========
*
*    SRNAME is CHARACTER*(*)
*    The name of the routine which called XERBLA.
*
*    INFO is INTEGER
*    The position of the invalid parameter in the parameter list
*    of the calling routine.
*
*  =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC          LEN_TRIM
*     ..
*     .. Executable Statements ..
*
      WRITE( *, FMT = 9999 )SRNAME( 1:LEN_TRIM( SRNAME ) ), INFO
*
      STOP
*
 9999 FORMAT( ' ** On entry to ', A, ' parameter number ', I2, ' had ',
     $      'an illegal value' )
*
*     End of XERBLA
*
      END

! Module and subroutines implementing an adaptive weighting scheme for
! generating uniformly spaced points on the Pareto front for multiobjective
! optimization problems.
!
! Created : 5/20 by T. H. Chang (THC)
! Updates : 4/21 (THC)
MODULE VTMOP_MOD
! Use the R8 data type from HOMPACK90 for approximately 64-bit precision on
! all known machines.
USE REAL_PRECISION, ONLY : R8

! The default scope for VTMOP_MOD is public.
PUBLIC
! The following module arrays and pointers are private.
PRIVATE :: VTMOP_MOD_WEIGHTS, VTMOP_MOD_SURROGATES
! The following LSHEP (ACM TOMS Algorithm 905) parameters are private.
PRIVATE :: LSHEP_D, LSHEP_P, LSHEP_N_PTS, LSHEP_N_TABOO, LSHEP_A, &
           LSHEP_DES_TOL, LSHEP_FVALS, LSHEP_RW, LSHEP_SCALE,     &
           LSHEP_SHIFT, LSHEP_TABOO, LSHEP_XVALS
! The following auxiliary subroutines are private.
PRIVATE :: SCALAR_FUNC, SURROGATE_FUNC

! The derived data VTMOP_TYPE type carries metadata about the multiobjective
! optimization problem between iterations of the algorithm.
TYPE VTMOP_TYPE
   ! Contents of the VTMOP_TYPE data object.
   INTEGER :: D, P ! Problem dimensions.
   INTEGER :: ITERATE ! Total number of iterations elapsed.
   INTEGER :: LCLIST ! Length of CLIST(:,:) array.
   INTEGER :: LOPT_BUDGET ! Budget for the local optimizer.
   LOGICAL :: CHKPT ! Checkpointing mode.
   LOGICAL :: PMODE ! Parallel execution mode.
   REAL(KIND=R8) :: DECAY ! Rate of decay for the local trust region (LTR).
   REAL(KIND=R8) :: DES_TOL ! Design point tolerance.
   REAL(KIND=R8) :: EPS ! Working precision for the problem.
   REAL(KIND=R8) :: EPSW ! Fudge factor for zero weights.
   REAL(KIND=R8) :: MIN_RADF ! Minimum LTR radius as a fraction of UB-LB.
   REAL(KIND=R8) :: OBJ_TOL ! Objective point tolerance.
   REAL(KIND=R8) :: TRUST_RADF ! Initial LTR radius as a fraction of UB-LB.
   REAL(KIND=R8), ALLOCATABLE :: CLIST(:,:) ! Previously used LTR centers.
   REAL(KIND=R8), ALLOCATABLE :: LB(:), UB(:) ! Lower/upper design bounds.
   REAL(KIND=R8), ALLOCATABLE :: OBJ_BOUNDS(:,:) ! Lower/upper obj bounds.
   REAL(KIND=R8), ALLOCATABLE :: WEIGHTS(:,:) ! Adaptive weights.

   ! Pointers to procedures that are called by the subroutine VTMOP_OPT.
   ! Subroutine to evaluate surrogate models.
   PROCEDURE(VTMOP_MOD_SEVAL_INT), NOPASS, POINTER :: EVAL_SURROGATES
   ! Subroutine to fit surrogate models.
   PROCEDURE(VTMOP_MOD_SFIT_INT), NOPASS, POINTER :: FIT_SURROGATES
   ! Subroutine to perform local optimization over surrogate models.
   PROCEDURE(VTMOP_MOD_LOCAL_INT), NOPASS, POINTER :: LOCAL_OPT
END TYPE VTMOP_TYPE

! Module variables.
! Module variables for checkpointing.
CHARACTER(LEN=20) :: VTMOP_CHKPTFILE = "vtmop.chkpt" ! Checkpoint file name.
CHARACTER(LEN=20) :: VTMOP_DATAFILE = "vtmop.dat" ! Database file name.
! LSHEP (ACM TOMS Algorithm 905) surrogate model parameters.
INTEGER :: LSHEP_D, LSHEP_N_PTS, LSHEP_N_TABOO, LSHEP_P
REAL(KIND=R8) :: LSHEP_DES_TOL
! Module variables for checkpointing.
INTEGER :: VTMOP_CHKPTUNIT = 11 ! Iteration data checkpoint unit.
INTEGER :: VTMOP_DATAUNIT = 12 ! Function evaluation database unit.
! Module variables containing problem metadata.
INTEGER :: VTMOP_MOD_BB_BUDGET ! The blackbox function evaluation budget.
INTEGER :: VTMOP_MOD_D ! Number of design variables.
INTEGER :: VTMOP_MOD_DBN ! Size of the databases.
INTEGER :: VTMOP_MOD_P ! Number of objectives.
! Module variables for checkpointing.
LOGICAL :: VTMOP_MOD_CHKPT ! Global copy of the checkpointing status.
! Module variables containing problem metadata.
REAL(KIND=R8) :: VTMOP_MOD_DES_TOL ! Design space tolerance.

! Dynamic module arrays.
! Arrays for the LSHEP (ACM TOMS Algorithm 905) surrogate models.
REAL(KIND=R8), ALLOCATABLE :: LSHEP_A(:,:,:)
REAL(KIND=R8), ALLOCATABLE :: LSHEP_FVALS(:,:)
REAL(KIND=R8), ALLOCATABLE :: LSHEP_RW(:,:)
REAL(KIND=R8), ALLOCATABLE :: LSHEP_TABOO(:,:)
REAL(KIND=R8), ALLOCATABLE :: LSHEP_SCALE(:)
REAL(KIND=R8), ALLOCATABLE :: LSHEP_SHIFT(:)
REAL(KIND=R8), ALLOCATABLE :: LSHEP_XVALS(:,:)
! Module arrays for maintaining the database and weights.
REAL(KIND=R8), ALLOCATABLE :: VTMOP_MOD_DBF(:,:) ! Database of objective values.
REAL(KIND=R8), ALLOCATABLE :: VTMOP_MOD_WEIGHTS(:) ! Scalarization weights.
REAL(KIND=R8), ALLOCATABLE :: VTMOP_MOD_DBX(:,:) ! Database of design points.

! Pointers to module procedures for the objective function and its surrogate.
PROCEDURE(VTMOP_MOD_OBJ_INT), POINTER :: VTMOP_MOD_OBJ_FUNC
PROCEDURE(VTMOP_MOD_SEVAL_INT), POINTER :: VTMOP_MOD_SURROGATES

! The THREADPRIVATE list specifies a list of public variables that will be
! initialized PRIVATE to each thread and persist outside of PARALLEL blocks.
!$OMP THREADPRIVATE(VTMOP_MOD_WEIGHTS)

! Interfaces for external procedures.
INTERFACE
   ! QSORTC_DVEC interface.
   SUBROUTINE QSORTC_DVEC(A, IDX)
      USE REAL_PRECISION
      ! Input/output parameters.
      REAL(KIND=R8), INTENT(INOUT) :: A(:, :)
      INTEGER, INTENT(OUT) :: IDX(SIZE(A, 2))
   END SUBROUTINE QSORTC_DVEC

   ! DELAUNAYGRAPH interface.
   SUBROUTINE DELAUNAYGRAPH( D, N, PTS, GRAPH, IERR, EPS, IBUDGET, PMODE )
      USE REAL_PRECISION
      ! Input arguments.
      INTEGER, INTENT(IN) :: D, N
      REAL(KIND=R8), INTENT(INOUT) :: PTS(:,:)
      ! Output arguments.
      LOGICAL, INTENT(OUT) :: GRAPH(:,:)
      INTEGER, INTENT(OUT) :: IERR
      ! Optional arguments.
      REAL(KIND=R8), OPTIONAL, INTENT(IN) :: EPS
      INTEGER, OPTIONAL, INTENT(IN) :: IBUDGET
      LOGICAL, OPTIONAL, INTENT(IN) :: PMODE
   END SUBROUTINE DELAUNAYGRAPH

   ! Scalarized objective function interface.
   FUNCTION VTMOP_MOD_SCALAR_INT(C, IERR) RESULT(F)
      USE REAL_PRECISION, ONLY : R8
      REAL(KIND=R8), INTENT(IN) :: C(:)
      INTEGER, INTENT(OUT) :: IERR
      REAL(KIND=R8) :: F
   END FUNCTION VTMOP_MOD_SCALAR_INT

   ! Local optimization subroutine interface.
   SUBROUTINE VTMOP_MOD_LOCAL_INT(D, X, LB, UB, OBJ_FUNC, BUDGET, TOL, IERR)
      USE REAL_PRECISION, ONLY : R8
      INTEGER, INTENT(IN) :: D
      REAL(KIND=R8), INTENT(INOUT) :: X(:)
      REAL(KIND=R8), INTENT(IN) :: LB(:)
      REAL(KIND=R8), INTENT(IN) :: UB(:)
      INTERFACE
         FUNCTION OBJ_FUNC(C, IERR) RESULT(F)
            USE REAL_PRECISION, ONLY : R8
            REAL(KIND=R8), INTENT(IN) :: C(:)
            INTEGER, INTENT(OUT) :: IERR
            REAL(KIND=R8) :: F
         END FUNCTION OBJ_FUNC
      END INTERFACE
      INTEGER, INTENT(IN) :: BUDGET
      REAL(KIND=R8), INTENT(IN) :: TOL
      INTEGER, INTENT(OUT) :: IERR
   END SUBROUTINE VTMOP_MOD_LOCAL_INT

   ! Objective subroutine interface.
   SUBROUTINE VTMOP_MOD_OBJ_INT(C, V, IERR)
      USE REAL_PRECISION, ONLY : R8
      REAL(KIND=R8), INTENT(IN) :: C(:)
      REAL(KIND=R8), INTENT(OUT) :: V(:)
      INTEGER, INTENT(OUT) :: IERR
   END SUBROUTINE VTMOP_MOD_OBJ_INT

   ! Surrogate function evaluation interface.
   SUBROUTINE VTMOP_MOD_SEVAL_INT(C, V, IERR)
      USE REAL_PRECISION, ONLY : R8
      ! Parameters.
      REAL(KIND=R8), INTENT(IN) :: C(:)
      REAL(KIND=R8), INTENT(OUT) :: V(:)
      INTEGER, INTENT(OUT) :: IERR
   END SUBROUTINE VTMOP_MOD_SEVAL_INT

   ! Surrogate function fitting interface.
   SUBROUTINE VTMOP_MOD_SFIT_INT(D, P, N, X_VALS, Y_VALS, FIRST, PARALLEL, &
                                 DES_TOL, SCALE_FACT, SHIFT_FACT, IERR)
      USE REAL_PRECISION, ONLY : R8
      ! Parameters.
      INTEGER, INTENT(IN) :: D
      INTEGER, INTENT(IN) :: P
      INTEGER, INTENT(IN) :: N
      REAL(KIND=R8), INTENT(IN) :: X_VALS(:,:)
      REAL(KIND=R8), INTENT(IN) :: Y_VALS(:,:)
      LOGICAL, INTENT(IN) :: FIRST
      LOGICAL, INTENT(IN) :: PARALLEL
      REAL(KIND=R8), INTENT(IN) :: DES_TOL
      REAL(KIND=R8), INTENT(IN) :: SCALE_FACT(:)
      REAL(KIND=R8), INTENT(IN) :: SHIFT_FACT(:)
      INTEGER, INTENT(OUT) :: IERR
   END SUBROUTINE VTMOP_MOD_SFIT_INT
END INTERFACE

CONTAINS

! The following public subroutines are referenced by the driver VTMOP_SOLVE
! program and could be used individually by an advanced user for a
! return-to-caller interface.

SUBROUTINE VTMOP_INIT( VTMOP, D, P, LB, UB, IERR, LOPT_BUDGET, DECAY,     &
                       DES_TOL, EPS, EPSW, OBJ_TOL, MIN_RADF, TRUST_RADF, &
                       OBJ_BOUNDS, LOCAL_OPT, FIT_SURROGATES,             &
                       EVAL_SURROGATES, PMODE, ICHKPT )
! This subroutine initializes a VTMOP object for tracking the adaptive
! weighting scheme described in
!
! Deshpande, Shubhangi, Layne T. Watson, and Robert A. Canfield.
! "Multiobjective optimization using an adaptive weighting scheme."
! Optimization Methods and Software 31.1 (2016): 110-133.
!
!
! On input:
!
! D is the dimension of the design space.
!
! P is the dimension of the objective space.
!
! LB(1:D) is the real vector of lower bound constraints for the
!    D design variables.
!
! UB(1:D) is the real vector of upper bound constraints for the
!    D design variables.
!
!
! On output:
!
! VTMOP is an object of derived data type VTMOP_TYPE, which carries meta data
!    about the multiobjective problem.
!
! IERR is an integer error flag.
!
! Hundreds digit:
!  000 : Normal output. Successful initialization of VTMOP object.
!
!  1xx : Errors detected.
!   Tens digit:
!     11x : The input parameters contained illegal dimensions or values.
!       Ones digit:
!         110 : D (design dimension) must be a positive integer.
!         111 : P (objective dimension) must be at least two.
!         112 : The lead dimension of LB(:) must match D.
!         113 : The lead dimension of UB(:) must match D.
!         114 : LB(:) must be elementwise strictly less than UB(:) - DES_TOL.
!     12x : The optional dummy arguments contained illegal values.
!       Ones digit:
!         123 : LOPT_BUDGET must be positive.
!         124 : DECAY must be in the range (EPS, 1-EPS).
!         125 : TRUST_RADF must be larger than or equal to MIN_RADF.
!         128 : If either FIT_SURROGATES or EVAL_SURROGATES are present,
!               then both must be present.
!         129 : If OBJ_BOUNDS is given, then it must have dimensions P by 2
!               and all OBJ_BOUNDS(:,1) < OBJ_BOUNDS(:,2).
!     13x : A memory allocation error has occurred.
!       Ones digit:
!         130 : A memory allocation error occurred.
!         131 : A memory deallocation error occurred.
!
!  9xx : A checkpointing error has occurred.
!    901 : WARNING: the VTMOP object was successfully recovered from the
!          checkpoint but does not match the input data.
!
!  The following error codes are returned by VTMOP_CHKPT_NEW. Further details
!  can be found in the header for VTMOP_CHKPT_NEW.
!    91x : The VTMOP passed to the checkpoint was invalid.
!    92x : Error creating the checkpoint file.
!
!  The following error codes are returned by VTMOP_CHKPT_RECOVER, when
!  VTMOP_INIT is called in recovery mode. Further details can be found in
!  the header for VTMOP_CHKPT_RECOVER.
!    95x : Error reading data from the checkpoint file.
!    96x : A memory management error occurred during recovery.
!
!
! Optional input arguments.
!
! LOPT_BUDGET is an integer input, which specifies the budget for the
!    local optimization subroutine. The default value for LOPT_BUDGET is
!    2500 surrogate evaluations. Note that this value is not saved during
!    checkpointing, and must be reset by the user when recovery mode is
!    active, whenever a non-default value is desired.
!
! DECAY is a real input specifying the decay rate for the local
!    trust region (LTR) radius. This value affects how many times an
!    isolated point can be the center of a LTR before it is discarded.
!    By default, DECAY = 0.5.
!
! DES_TOL is the tolerance for the design space. A design point that
!    is within DES_TOL of an evaluated design point will not be reevaluated.
!    The default value for DES_TOL is the square-root of the working precision
!    EPS. Note that any value that is smaller than the working precsion EPS
!    will be ignored and EPS will be used.
!
! EPS is a real input, which specifies the working precision of the
!    machine. The default value for EPS is SQRT(EPSILON), where EPSILON
!    is the unit roundoff. Note that if the value supplied is smaller than
!    the default value then the default value will be used.
!
! EPSW is a small positive number, which is used as the fudge factor for
!    zero-valued weights. A zero-valued weight does not guarantee Pareto
!    optimality. Therefore, all zero weights are set to EPSW. The appropriate
!    value of EPSW is problem dependent. By default, EPSW is the fourth root
!    of EPSILON (the unit roundoff). Note that any value that is smaller
!    than SQRT(EPSILON) is ignored and SQRT(EPSILON) will be used.
!
! OBJ_TOL is the tolerance for the objective space. An objective point
!    that is within OBJ_TOL of being dominated by another objective point
!    will be treated as such. The default value of OBJ_TOL is the
!    square-root of EPS. This value should be strictly greater than the
!    value of EPS. Note that any value that is smaller than the
!    working precsion EPS will be ignored and EPS will be used.
!
! OBJ_BOUNDS(1:P,1:2) is an optional real P by 2 array, whose first column
!    is a list of lower bounds and whose second column is a list of upper
!    bounds on the range of interesting objective values. When present,
!    this value is used to prune the list of potential LTR centers, so
!    that only objective values in the specified range are used when
!    looking for gaps in the Pareto. In particular, an objective value
!    F(x) will be considered for a LTR center if and only if
!    OBJ_BOUNDS(I,1) .LE. F_I(x) .LE. OBJ_BOUNDS(I,2) for all I = 1, ..., P.
!    By default, there are no bounds on the interesting range. Note that
!    this value is intentionally not saved during checkpointing, and must
!    be reset by the user when recovery mode is active, whenever a
!    non-default value is desired. This is the only input, for which
!    changing the value after loading from a previous checkpoint is not
!    ill-advised.
!
! MIN_RADF is the smallest value for the fraction r defining the trust region
!    box dimensions r * (UB - LB), before an isolated point is abandoned.
!    By default, MIN_RADF = 0.1 * TRUST_RADF, and is also set to this default
!    value if it is less than DES_TOL. After MIN_RADF and TRUST_RADF are set,
!    MIN_RADF < TRUST_RADF must hold.
!
! TRUST_RADF defines the initial trust region centered at an isolated
!    point X as [X - TRUST_RADF * (UB - LB), X + TRUST_RADF * (UB - LB)]
!    intersected with [LB, UB].  By default, TRUST_RADF = 0.2, and is also set
!    to this value if the value given is outside the interval
!    (DES_TOL, 1 - DES_TOL).
!
! LOCAL_OPT is a SUBROUTINE, whose interface matches that of
!    VTMOP_MOD_LOCAL_INT. LOCAL_OPT is used to optimize the surrogate model.
!    The default value for LOCAL_OPT is GPS, a lightweight Fortran
!    implementation of the polling algorithm generalized pattern search, as
!    used by NOMAD (ACM TOMS Alg. 909). Note that this value is not saved
!    during checkpointing, and must be reset by the user when recovery mode
!    is active, whenever a non-default value is desired.
!
! FIT_SURROGATES is a module subroutine that fits P surrogate models, by
!    setting variables in its module. The interface for FIT_SURROGATES
!    must match that of VTMOP_MOD_SFIT_INT. By default, FIT_SURROGATES is
!    LSHEP_FIT. Note that this value is not saved during checkpointing, and
!    must be reset by the user when recovery mode is active, whenever a
!    non-default value is desired.
!
! EVAL_SURROGATES is a module subroutine that evaluates the P surrogate
!    models fit by FIT_SURROGATES. The interface for EVAL_SURROGATES must
!    match that of VTMOP_MOD_SEVAL_INT. By default, EVAL_SURROGATES is
!    LSHEP_EVAL. Note that this value is not saved during checkpointing, and
!    must be reset by the user when recovery mode is active, whenever a
!    non-default value is desired.
!
! PMODE is a logical input that specifies whether or not iteration tasks
!    should be performed in parallel. By default, PMODE = .FALSE. Note
!    that this value is not saved during checkpointing, and must be reset
!    by the user when recovery mode is active, whenever a non-default value
!    is desired.
!
! ICHKPT is an integer that specifies the checkpointing status. The
!    checkpoint file and checkpoint unit are "vtmop.chkpt" and 10 by
!    default, but can be adjusted by setting the module variables
!    VTMOP_CHKPTFILE and VTMOP_CHKPTUNIT. Possible values are:
!
!    ICHKPT = 0 : No checkpointing (default setting).
!    ICHKPT < 0 : Recover from the last checkpoint.
!    ICHKPT > 0 : Begin a new checkpoint file.
!
! In recovery mode the inputs D, P, LB, and UB are still referenced
!    (for sanity checks). Also, the procedure arguments are still
!    needed to recover the procedure settings. No other optional
!    arguments are referenced.
!
IMPLICIT NONE
! Input parameters.
INTEGER, INTENT(IN) :: D ! Dimension of design space.
INTEGER, INTENT(IN) :: P ! Dimension of objective space.
REAL(KIND=R8), INTENT(IN) :: LB(:) ! Lower bound constraints.
REAL(KIND=R8), INTENT(IN) :: UB(:) ! Upper bound constraints.
! Output parameters.
TYPE(VTMOP_TYPE), INTENT(OUT) :: VTMOP ! Data struct containing problem info.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Optional parameters.
INTEGER, OPTIONAL, INTENT(IN) :: LOPT_BUDGET ! Local optimizer budget.
LOGICAL, OPTIONAL, INTENT(IN) :: PMODE ! Parallel execution mode.
INTEGER, OPTIONAL, INTENT(IN) :: ICHKPT ! Checkpointing mode.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: DECAY ! Decay rate for LTR.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: DES_TOL ! Design space tolerance.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: EPS ! Working precision.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: EPSW ! Fudge factor for zero weights.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: OBJ_TOL ! Objective space tolerance.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: MIN_RADF ! Minimum LTR radius fraction.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: TRUST_RADF ! Initial LTR radius fraction.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: OBJ_BOUNDS(:,:) ! Upper/lower obj bounds.
! Optional procedure arguments.
! Locally convergent optimization procedure for solving surrogate problem.
PROCEDURE(VTMOP_MOD_LOCAL_INT), OPTIONAL :: LOCAL_OPT
! Procedure for fitting the surrogate models.
PROCEDURE(VTMOP_MOD_SFIT_INT), OPTIONAL :: FIT_SURROGATES
! Procedure for evaluating the surrogate models.
PROCEDURE(VTMOP_MOD_SEVAL_INT), OPTIONAL :: EVAL_SURROGATES

! Local copy of optional variable.
INTEGER :: ICHKPTL
! External BLAS function for computing Euclidean distance.
REAL(KIND=R8), EXTERNAL :: DNRM2

! Check for illegal input dimensions and values.
IF (D < 1) THEN ! Illegal design space dimension.
   IERR = 110; RETURN; END IF
IF (P < 2) THEN ! Illegal objective space dimension.
   IERR = 111; RETURN; END IF
IF (SIZE(LB,1) .NE. D) THEN ! Lower bounds dimension must match D.
   IERR = 112; RETURN; END IF
IF (SIZE(UB,1) .NE. D) THEN ! Upper bounds dimension must match D.
   IERR = 113; RETURN; END IF
! Get optional inputs.
ICHKPTL = 0
IF (PRESENT(ICHKPT)) ICHKPTL = ICHKPT

! If in checkpoint recovery mode, read the VTMOP object in.
IF (ICHKPTL < 0) THEN
   ! Load problem status from last checkpoint.
   CALL VTMOP_CHKPT_RECOVER(VTMOP, IERR)
   IF (IERR .NE. 0) RETURN
   ! Perform the final sanity check.
   IF ( (VTMOP%D .NE. D) .OR. (VTMOP%P .NE. P) .OR. &
        ANY(VTMOP%LB(:) .NE. LB(:)) .OR. ANY(VTMOP%UB(:) .NE. UB(:)) ) THEN
      IERR = 901; END IF
   ! Set the checkpointing flag.
   VTMOP%CHKPT = .TRUE.

! Otherwise, perform a normal initialization.
ELSE
   ! Initialize the VTMOP structure to maintain the status of the problem.
   VTMOP%D = D
   VTMOP%P = P
   VTMOP%LCLIST = 20
   ALLOCATE(VTMOP%LB(D), VTMOP%UB(D), VTMOP%CLIST(D+1,VTMOP%LCLIST), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 130; RETURN; END IF
   VTMOP%ITERATE = 0
   VTMOP%LB(:) = LB(:)
   VTMOP%UB(:) = UB(:)

   ! Check for optional inputs.
   ! Initialize the working precision.
   VTMOP%EPS = SQRT(EPSILON(0.0_R8))
   IF(PRESENT(EPS)) THEN
      ! The default value of EPS cannot be decreased. Ignore such inputs.
      IF(EPS > VTMOP%EPS) VTMOP%EPS = EPS
   END IF
   ! Initialize the fudge factor for zero weights.
   VTMOP%EPSW = EPSILON(0.0_R8) ** 0.25_R8
   IF(PRESENT(EPSW)) THEN
      ! Ignore EPSW if it is less than the square-root of the machine EPSILON.
      IF(EPSW .GE. SQRT(EPSILON(0.0_R8))) VTMOP%EPSW = EPSW
   END IF
   ! Initialize the design space and objective space tolerances.
   VTMOP%DES_TOL = SQRT(VTMOP%EPS)
   IF (PRESENT(DES_TOL)) THEN
      IF(DES_TOL > VTMOP%EPS) THEN
         VTMOP%DES_TOL = DES_TOL
      ELSE
         VTMOP%DES_TOL = VTMOP%EPS
      END IF
   END IF
   VTMOP%OBJ_TOL = SQRT(VTMOP%EPS)
   IF (PRESENT(OBJ_TOL)) THEN
      IF(OBJ_TOL > VTMOP%EPS) THEN
         VTMOP%OBJ_TOL = OBJ_TOL
      ELSE
         VTMOP%OBJ_TOL = VTMOP%EPS
      END IF
   END IF
   ! Initialize the decay rate.
   VTMOP%DECAY = 0.5_R8
   IF(PRESENT(DECAY)) THEN
      ! The decay rate must be between EPS and 1-EPS.
      IF(DECAY > 1.0_R8 - VTMOP%EPS .OR. DECAY < VTMOP%EPS) THEN
         IERR = 124; RETURN; END IF
      VTMOP%DECAY = DECAY
   END IF
   ! Initialize the LTR radius fraction and minimum LTR radius fraction.
   VTMOP%TRUST_RADF = 0.2_R8
   IF(PRESENT(TRUST_RADF)) THEN
      ! The LTR radius fraction must be greater than the design space tolerance.
      IF(TRUST_RADF .GE. VTMOP%DES_TOL .AND. TRUST_RADF < 1.0_R8) THEN
         VTMOP%TRUST_RADF = TRUST_RADF; END IF
   END IF
   ! The minimum LTR radius fraction must be greater than the design
   ! space tolerance. By default, tolerate decay down to 10% of the
   ! initial LTR radius.
   VTMOP%MIN_RADF = MAX(0.1_R8 * VTMOP%TRUST_RADF, VTMOP%DES_TOL)
   IF(PRESENT(MIN_RADF)) THEN
      IF(MIN_RADF .GE. VTMOP%DES_TOL) VTMOP%MIN_RADF = MIN_RADF
   END IF
   ! Check that the size of the LTR radius is appropriate.
   IF(VTMOP%MIN_RADF > VTMOP%TRUST_RADF) THEN
      IERR = 125; RETURN; END IF
   ! Lower bounds must be elementwise strictly less than upper bounds.
   ! Use the design space tolerance to check.
   IF(ANY(LB(:) .GE. UB(:) - VTMOP%DES_TOL)) THEN
      IERR = 114; RETURN; END IF
   ! Initialize the checkpointing mode.
   VTMOP%CHKPT = .FALSE.
   ! If ICHKPT > 0, initialize the checkpoint file and activate checkpointing.
   ! Check whether checkpointing is enabled.
   IF (ICHKPTL .NE. 0) THEN
      ! Initialize the checkpoint file and save the initialized VTMOP.
      CALL VTMOP_CHKPT_NEW(VTMOP, IERR)
      IF (IERR .NE. 0) RETURN
      ! Activate checkpointing mode.
      VTMOP%CHKPT = .TRUE.
   END IF
END IF

! The remaining optional inputs are not saved when checkpointing is active.
! Therefore, if non-default values are desired, these values must be re-set
! by the user, even in recovery mode.

! Initialize the local optimization budget.
VTMOP%LOPT_BUDGET = 2500
IF(PRESENT(LOPT_BUDGET)) THEN
   ! The budget must be at least 1, return an error for nonpositive values.
   IF(LOPT_BUDGET < 1) THEN
      IERR = 123; RETURN; END IF
   VTMOP%LOPT_BUDGET = LOPT_BUDGET
END IF
! Initialize the objective bounds.
ALLOCATE(VTMOP%OBJ_BOUNDS(P,2), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 130; RETURN; END IF
VTMOP%OBJ_BOUNDS(:,1) = -HUGE(0.0_R8)
VTMOP%OBJ_BOUNDS(:,2) = HUGE(0.0_R8)
IF(PRESENT(OBJ_BOUNDS)) THEN
   ! When present, OBJ_BOUNDS must have dimension P by 2 and
   ! OBJ_BOUNDS(:,1) < OBJ_BOUNDS(:,2).
   IF(SIZE(OBJ_BOUNDS,1) .NE. P .OR. SIZE(OBJ_BOUNDS,2) .NE. 2) THEN
      IERR = 129; RETURN
   ELSE
      IF(ANY(OBJ_BOUNDS(:,1) .GE. OBJ_BOUNDS(:,2))) THEN
         IERR = 129; RETURN; END IF
      VTMOP%OBJ_BOUNDS(:,:) = OBJ_BOUNDS(:,:)
   END IF
END IF
! Set the parallel execution mode.
VTMOP%PMODE = .FALSE.
IF(PRESENT(PMODE)) VTMOP%PMODE = PMODE
! Set the procedure arguments.
VTMOP%LOCAL_OPT => GPS ! Default optimizer is GPS.
IF(PRESENT(LOCAL_OPT)) THEN
   VTMOP%LOCAL_OPT => LOCAL_OPT; END IF
VTMOP%FIT_SURROGATES => LSHEP_FIT ! Default fit is LSHEP_FIT.
IF(PRESENT(FIT_SURROGATES)) THEN
   IF (.NOT. PRESENT(EVAL_SURROGATES)) THEN
      IERR = 128; RETURN; END IF
   VTMOP%FIT_SURROGATES => FIT_SURROGATES
END IF
VTMOP%EVAL_SURROGATES => LSHEP_EVAL ! Default evaluation is LSHEP_EVAL.
IF(PRESENT(EVAL_SURROGATES)) THEN
   IF (.NOT. PRESENT(FIT_SURROGATES)) THEN
      IERR = 128; RETURN; END IF
   VTMOP%EVAL_SURROGATES => EVAL_SURROGATES
END IF

RETURN
END SUBROUTINE VTMOP_INIT

SUBROUTINE VTMOP_LTR( VTMOP, DES_PTS, OBJ_PTS, LTR_LB, LTR_UB, IERR )
! This subroutine identifies the most isolated point, builds a local
! trust region (LTR), and chooses the adaptive weights, as described in
!
! Deshpande, Shubhangi, Layne T. Watson, and Robert A. Canfield.
! "Multiobjective optimization using an adaptive weighting scheme."
! Optimization Methods and Software 31.1 (2016): 110-133.
!
!
! On input:
!
! VTMOP is an object of derived data type VTMOP_TYPE, which carries meta data
!    about the multiobjective problem. VTMOP is created using VTMOP_INIT.
!
! DES_PTS(1:D,1:N) is a real matrix of all design points in the feasible
!    design space [LB, UB], stored by column. The second dimension of
!    DES_PTS(:,:) (N) is assumed based on the shape and must be at least D+1
!    to build an accurate surrogate model. In the special case of the zeroth
!    iteration, DES_PTS need not be allocated.
!
! OBJ_PTS(1:P,1:N) is a real matrix of objective values corresponding
!    to the design points in DES_PTS(:,:), stored by column: for cost
!    function F, OBJ_PTS(:,I) = F(DES_PTS(:,I)). In the special case of the
!    zeroth iteration, OBJ_PTS need not be allocated.
!
!
! On output:
!
! LTR_LB(1:D) is a real array of lower bounds for the LTR.
!
! LTR_UB(1:D) is a real array of upper bounds for the LTR.
!
! IERR is an integer error flag.
!
! Hundreds digit:
!  0xx : Normal output.
!    Ones digit:
!      000 : Successfully constructed a new LTR and selected adaptive weights.
!      003 : Maximal accuracy has already been achieved, no isolated points
!            can be further refined for the problem tolerance.
!
!  2xx : Error detected in input, or during VTMOP_INIT (initialization) code.
!   Tens digit:
!     21x : The input parameters contained illegal dimensions or values.
!       Ones digit:
!         210 : The VTMOP object appears to be uninitialized.
!         211 : The VTMOP object is initialized, but its dimensions either
!               do not agree or contain illegal values. This is likely the
!               result of an undetected segmentation fault.
!         212 : The lead dimension of LTR_LB(:) must match the design
!               dimension D, stored in VTMOP.
!         213 : The lead dimension of LTR_UB(:) must match the design
!               dimension D, stored in VTMOP.
!         214 : The lead dimension of DES_PTS(:,:) must match D.
!         215 : The lead dimension of OBJ_PTS(:,:) must match P.
!         216 : The second dimensions of DES_PTS and OBJ_PTS must match.
!     22x : A memory error occurred while managing the dynamic memory in VTMOP.
!         220 : A memory allocation error while copying the history.
!         221 : A memory deallocation error occurred while freeing temp arrays.
!         222 : A memory allocation error while allocating the adaptive weights.
!     23x : A memory error occurred while managing the local arrays.
!       Ones digit:
!         230 : A memory allocation error occurred.
!         231 : A memory deallocation error occurred.
!     240 : Detected a set of unused adaptive weights. This subroutine
!           may have been called out of sequence.
!     250 : No objective values found (so far) within the range
!           [OBJ_BOUNDS(:,1), OBJ_BOUNDS(:,2)]. Consider relaxing these
!           bounds.
!
!  5xx : Error thrown by DELAUNAYSPARSE.
!    Tens and ones digits carry the exact error code from DELAUNAYSPARSE,
!    passed by the subroutine DELAUNAYGRAPH. The occurrence of these error
!    codes could indicate poor objective scaling. When receiving these
!    error codes, try either (1) rescaling all objective functions so that
!    their range of possible outputs is roughly equal, or (2) increasing the
!    value of OBJ_TOL.
!
!  9xx : A checkpointing error was thrown.
!    91x : The VTMOP passed to the checkpoint was invalid.
!    93x : Error writing iteration information to the checkpoint file.
!
USE IEEE_ARITHMETIC
IMPLICIT NONE
! Input parameters.
TYPE(VTMOP_TYPE), INTENT(INOUT) :: VTMOP ! Data struct containing problem info.
REAL(KIND=R8), INTENT(IN) :: DES_PTS(:,:) ! Table of precomputed design pts.
REAL(KIND=R8), INTENT(IN) :: OBJ_PTS(:,:) ! Table of objective values.
! Output parameters.
REAL(KIND=R8), INTENT(OUT) :: LTR_LB(:) ! LTR lower bound constraints.
REAL(KIND=R8), INTENT(OUT) :: LTR_UB(:) ! LTR upper bound constraints.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Problem dimensions.
INTEGER :: D ! Design space dimension.
INTEGER :: M ! Cardinality of the current Pareto set.
INTEGER :: N ! Number of design/objective points in the database.
INTEGER :: P ! Number of objectives.
! Local variables.
LOGICAL :: ACCEPT ! Acceptance condition for new center point.
LOGICAL :: FOUND ! Indicate whether the box center was found.
INTEGER :: I, J, K ! Loop indexing / temp variables.
INTEGER :: MAXIND ! The index of the most isolated point.
REAL(KIND=R8) :: BOX(VTMOP%D+1) ! Center and radius of next LTR.
REAL(KIND=R8) :: MINVAL_P ! Minimum value taken by the Pth objective.
! Local dynamic arrays.
LOGICAL, ALLOCATABLE :: DELGRAPH(:,:) ! Delaunay graph.
INTEGER, ALLOCATABLE :: INDICES(:) ! For tracking indices when sorting.
REAL(KIND=R8), ALLOCATABLE :: CLIST_TMP(:,:) ! Temp array for expanding CLIST.
REAL(KIND=R8), ALLOCATABLE :: DISCREP(:) ! List of star discrepancies.
REAL(KIND=R8), ALLOCATABLE :: EFFICIENT_SET(:,:) ! Efficient point set.
REAL(KIND=R8), ALLOCATABLE :: HOMOGENEOUS_PF(:,:) ! Homogeneous Pareto front.
REAL(KIND=R8), ALLOCATABLE :: PARETO_SET(:,:) ! Pareto front.
! External BLAS procedures.
REAL(KIND=R8), EXTERNAL :: DNRM2 ! Euclidean distance (BLAS).

! Retrieve problem dimensions from input data.
D = VTMOP%D; P = VTMOP%P; N = SIZE(DES_PTS,2)
! Check for illegal problem dimensions.
IF ( (.NOT. ALLOCATED(VTMOP%LB)) .OR. (.NOT. ALLOCATED(VTMOP%UB)) &
     .OR. (.NOT. ALLOCATED(VTMOP%CLIST)) ) THEN
   IERR = 210; RETURN; END IF
IF ((D < 1) .OR. (P < 2) .OR. (SIZE(VTMOP%LB,1) .NE. D) .OR. &
    (SIZE(VTMOP%UB,1) .NE. D)) THEN
   IERR = 211; RETURN; END IF
IF (SIZE(LTR_LB,1) .NE. D) THEN ! Lower bounds dimension does not match D.
   IERR = 212; RETURN; END IF
IF (SIZE(LTR_UB,1) .NE. D) THEN ! Upper bounds dimension does not match D.
   IERR = 213; RETURN; END IF
! If the adaptive weights array is already allocated, then VTMOP_OPT has not
! been called since the last call to VTMOP_LTR.
IF (ALLOCATED(VTMOP%WEIGHTS)) THEN
   IERR = 240; RETURN; END IF

! In the zeroth iteration, use static weights on the entire design space.
IF (VTMOP%ITERATE .EQ. 0) THEN
   ! Set the LTR bounds.
   LTR_LB(:) = VTMOP%LB(:)
   LTR_UB(:) = VTMOP%UB(:)
   ! Allocate the initial weights.
   ALLOCATE(VTMOP%WEIGHTS(P,P+1), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 222; RETURN; END IF
   ! Set the individual weights.
   DO I = 1, P
      ! Set zero-valued weights to VTMOP%EPS to avoid pathological cases.
      VTMOP%WEIGHTS(:,I) = VTMOP%EPSW
      VTMOP%WEIGHTS(I,I) = 1.0_R8 - VTMOP%EPSW*REAL(P-1,KIND=R8)
   END DO
   ! Set the adaptive weights.
   VTMOP%WEIGHTS(:,P+1) = 1.0_R8 / REAL(P, KIND=R8)

! Otherwise, for the Kth iteration (K > 0), perform a general iteration.
ELSE
   ! Check that the dimensions of DES_PTS and OBJ_PTS match.
   IF (SIZE(DES_PTS,1) .NE. D) THEN
      IERR = 214; RETURN; END IF
   IF (SIZE(OBJ_PTS,1) .NE. P) THEN
      IERR = 215; RETURN; END IF
   IF (SIZE(OBJ_PTS,2) .NE. N) THEN
      IERR = 216; RETURN; END IF

   ! If CLIST is at capacity, then reallocate CLIST.
   IF (VTMOP%ITERATE > VTMOP%LCLIST) THEN
      ! Allocate the temporary array to copy CLIST.
      ALLOCATE(CLIST_TMP(D+1,VTMOP%LCLIST), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 220; RETURN; END IF
      CLIST_TMP = VTMOP%CLIST
      ! Reallocate CLIST to twice its current size.
      DEALLOCATE(VTMOP%CLIST, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 221; RETURN; END IF
      ALLOCATE(VTMOP%CLIST(D+1,VTMOP%LCLIST*2), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 220; RETURN; END IF
      ! Restore values back into CLIST and free the temporary array.
      VTMOP%CLIST(:,1:VTMOP%LCLIST) = CLIST_TMP(:,:)
      DEALLOCATE(CLIST_TMP, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 221; RETURN; END IF
      ! Update the size of VTMOP%LCLIST.
      VTMOP%LCLIST = VTMOP%LCLIST * 2
   END IF

   ! Allocate the dynamic arrays for storing both copies of the Pareto front.
   ALLOCATE(INDICES(N), PARETO_SET(P,N), EFFICIENT_SET(D,N), &
            HOMOGENEOUS_PF(P-1,N), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 230; RETURN; END IF
   ! Make copies of the objective and their indices for sorting.
   FORALL (I=1:N) INDICES(I) = I
   PARETO_SET(:,:) = OBJ_PTS(:,:)
   ! Ignore NANs and values outside of the OBJ_BOUNDS.
   I = 1
   DO WHILE(I .LE. N)
      IF (ANY(IEEE_IS_NAN(PARETO_SET(:,I))) .OR.            &
          ANY(PARETO_SET(:,I) < VTMOP%OBJ_BOUNDS(:,1)) .OR. &
          ANY(PARETO_SET(:,I) > VTMOP%OBJ_BOUNDS(:,2))) THEN
         PARETO_SET(:,I:N-1) = PARETO_SET(:,I+1:N)
         EFFICIENT_SET(:,I:N-1) = EFFICIENT_SET(:,I+1:N)
         INDICES(I:N-1) = INDICES(I+1:N)
         N = N - 1
      ELSE
         I = I + 1
      END IF
   END DO
   ! Check whether there are still any viable points remaining.
   IF (N .EQ. 0) THEN
      IERR = 250; RETURN; END IF
   ! Sort objective and design points.
   CALL QSORTC_DVEC(PARETO_SET(:,1:N), INDICES(1:N))
   EFFICIENT_SET(:,1:N) = DES_PTS(:,INDICES(1:N))
   ! Free the indices; they are not needed anymore.
   DEALLOCATE(INDICES, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 231; RETURN; END IF
   ! Compute the minimum value obtained by the Pth objective. This value is
   ! used to shift the points in the Pth dimension, so that they are above
   ! the hyperplane X(P) = 1. This prevents division by zero.
   MINVAL_P = MINVAL(PARETO_SET(P,:)) - 1.0_R8
   ! The first entry in PARETO_SET/EFFICIENT_SET is always Pareto optimal.
   M = 1 ! Count the cardinality of the Pareto front.
   HOMOGENEOUS_PF(:,M) = PARETO_SET(1:P-1,1) / (PARETO_SET(P,1) - MINVAL_P)
   ! Get the current Pareto front (in both the objective space and in the
   ! homogeneous coordinates).
   OUTER : DO I = 2, N
      ! Compute the homogeneous coordinates for the Ith point.
      HOMOGENEOUS_PF(:,M+1) = PARETO_SET(1:P-1,I) / &
                                 (PARETO_SET(P,I) - MINVAL_P)
      ! Check against all points in the current solution set.
      INNER : DO J = 1, M
         ! Check whether the Jth point dominates the Ith point.
         IF (ALL(PARETO_SET(:,J) .LE. PARETO_SET(:,I) + VTMOP%OBJ_TOL)) THEN
            CYCLE OUTER ! Skip the Ith point.
         END IF
         ! Check whether the Ith point and Jth point are equal in the
         ! homogeneous coordinate system (up to the working precision).
         IF (DNRM2(P-1, HOMOGENEOUS_PF(:,M+1) - HOMOGENEOUS_PF(:,J), 1) &
                < VTMOP%OBJ_TOL) THEN
            CYCLE OUTER ! Only store the first occurrence of a duplicate.
         END IF
      END DO INNER
      ! Increment the counter and update both Pareto front arrays.
      M = M + 1
      PARETO_SET(:,M) = PARETO_SET(:,I)
      EFFICIENT_SET(:,M) = EFFICIENT_SET(:,I)
   END DO OUTER

   ! Allocate the remaining dynamic arrays.
   ALLOCATE(DELGRAPH(M,M), DISCREP(M), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 230; RETURN; END IF

   ! Use DELAUNAYGRAPH to compute the Delaunay graph (serially or in parallel).
   CALL DELAUNAYGRAPH(P-1, M, HOMOGENEOUS_PF(:,1:M), DELGRAPH, IERR, &
                       EPS=VTMOP%EPS, PMODE=VTMOP%PMODE)
   IF (IERR < 10) THEN ! Normal execution.
      IERR = 0
   ELSE ! An irrecoverable error occurred.
      IERR = IERR + 500
      RETURN
   END IF

   ! Identify the most isolated point using the star discrepancy.
   DO I = 1, M
      ! Compute the star discrepancy at index I using DELGRAPH(:,I).
      DISCREP(I) = 0.0_R8
      K = 0
      DO J = 1, M
         IF(DELGRAPH(J,I)) THEN
            DISCREP(I) = DISCREP(I) + &
                         DNRM2(P, PARETO_SET(:,J)-PARETO_SET(:,I), 1)
            K = K + 1
         END IF
      END DO
      IF (K > 0) THEN
         ! In general, point at index I has at least one Delaunay neighbor.
         DISCREP(I) = DISCREP(I) / REAL(K, KIND=R8)
      ELSE
         ! In rare cases, the point at index I has no neighbors. This
         ! can only occur when the Pareto front consists of a single point.
         DISCREP(I) = 1.0_R8
      END IF
   END DO

   ! Loop until an acceptable center is found.
   ACCEPT = .FALSE.
   DO WHILE(.NOT. ACCEPT)
      ! Identify the largest discrepancy, except negative/zero values.
      MAXIND = MAXLOC(DISCREP, DIM=1, MASK=(DISCREP > VTMOP%EPS))
      ! If no values with positive discrepancy remain, terminate.
      IF (MAXIND .EQ. 0) EXIT
      ! Otherwise, set BOX(1:D) to the corresponding design point.
      BOX(1:D) = EFFICIENT_SET(:,MAXIND)
      ! Check whether the current design point has been used before.
      FOUND = .FALSE.
      DO I = VTMOP%ITERATE-1, 1, -1
         IF ( DNRM2(D, VTMOP%CLIST(1:D,I) - BOX(1:D), 1) < VTMOP%DES_TOL ) THEN
            FOUND = .TRUE.
            EXIT
         END IF
      END DO
      ! A previous entry in VTMOP%CLIST(:,:) matches.
      IF (FOUND) THEN
         ! Copy the item and decay the LTR radius.
         BOX = VTMOP%CLIST(:,I)
         BOX(D+1) = BOX(D+1) * VTMOP%DECAY
         ! The minimum tolerance has not yet been exceeded.
         IF (BOX(D+1) > VTMOP%MIN_RADF) THEN
            ! Append BOX(:) to CLIST(:,:).
            VTMOP%CLIST(:,VTMOP%ITERATE) = BOX(:)
            ACCEPT = .TRUE.
         ! The minimum tolerance has been exceeded, set the
         ! discrepancy to a negative number.
         ELSE
            DISCREP(MAXIND) = -1.0_R8
         END IF
      ! No match found.
      ELSE
         ! Append BOX(:) to CLIST(:,:).
         BOX(D+1) = VTMOP%TRUST_RADF
         VTMOP%CLIST(:,VTMOP%ITERATE) = BOX(:)
         ACCEPT = .TRUE.
      END IF
   END DO

   ! If no point was accepted, terminate. It must be that the Pareto front
   ! has been approximated to the maximum tolerance.
   IF (.NOT. ACCEPT) THEN
      IERR = 3;
      RETURN
   END IF

   ! Build the LTR. It is the intersection over the current box and the
   ! bound constraints.
   DO I = 1, D
      LTR_LB(I) = MAX(BOX(I)-BOX(D+1)*(VTMOP%UB(I)-VTMOP%LB(I)), VTMOP%LB(I))
      LTR_UB(I) = MIN(BOX(I)+BOX(D+1)*(VTMOP%UB(I)-VTMOP%LB(I)), VTMOP%UB(I))
   END DO

   ! Count the number of Delaunay neighbors of PARETO_SET(:,MAXIND) using
   ! DELGRAPH(:,MAXIND).
   K = 0
   DO I = 1, M
      IF(DELGRAPH(I, MAXIND)) K = K + 1
   END DO
   ! Construct the adaptive weights. First, consider the special case where
   ! there are insufficiently many Delaunay neighbors.
   IF (K < 1) THEN
      ! Allocate the adaptive weights.
      ALLOCATE(VTMOP%WEIGHTS(P,P+1), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 222; RETURN; END IF
      ! Set the individual weights.
      DO I = 1, P
         ! Set zero-valued weights to VTMOP%EPSW to avoid pathological cases.
         VTMOP%WEIGHTS(:,I) = VTMOP%EPSW
         VTMOP%WEIGHTS(I,I) = 1.0_R8 - VTMOP%EPSW*REAL(P-1,KIND=R8)
      END DO
      ! Set the adaptive weights.
      VTMOP%WEIGHTS(:,P+1) = 1.0_R8 / REAL(P, KIND=R8)

   ! In the general case, use the Delaunay neighborhood.
   ELSE
      ! Allocate the adaptive weights.
      ALLOCATE(VTMOP%WEIGHTS(P,P+K), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 222; RETURN; END IF
      ! Set the individual weights.
      DO I = 1, P
         ! Set zero-valued weights to VTMOP%EPSW to avoid pathological cases.
         VTMOP%WEIGHTS(:,I) = VTMOP%EPSW
         VTMOP%WEIGHTS(I,I) = 1.0_R8 - VTMOP%EPSW*REAL(P-1,KIND=R8)
      END DO
      ! Set the adaptive weights.
      K = 1
      DO I = 1, M
         ! Check that I and MAXIND are Delaunay neighbors.
         IF (DELGRAPH(I,MAXIND)) THEN
            ! Set the adaptive weights.
            VTMOP%WEIGHTS(:,P+K) = ABS(PARETO_SET(:,I) - PARETO_SET(:,MAXIND))
            ! Invert when greater than or equal to zero.
            DO J = 1, P
               IF (VTMOP%WEIGHTS(J,P+K) < VTMOP%EPS) THEN
                  VTMOP%WEIGHTS(J,P+K) = VTMOP%EPSW
               ELSE
                  VTMOP%WEIGHTS(J,P+K) = 1.0_R8 / VTMOP%WEIGHTS(J,P+K)
               END IF
            END DO
            ! Normalize to make VTMOP%WEIGHTS(:,P+K) convex.
            VTMOP%WEIGHTS(:,P+K) = VTMOP%WEIGHTS(:,P+K) / &
                                   SUM(VTMOP%WEIGHTS(:,P+K))
            K = K + 1
         END IF
      END DO
   END IF
   ! Free heap memory.
   DEALLOCATE(DELGRAPH, DISCREP, PARETO_SET, HOMOGENEOUS_PF, STAT=IERR)
   IF (IERR .NE. 0) IERR = 231
END IF

! If CHKPT is set, then save to the checkpoint file.
IF (VTMOP%CHKPT) THEN
   ! Save the updated VTMOP object to the checkpoint file.
   CALL VTMOP_CHKPT(VTMOP, IERR)
   IF (IERR .NE. 0) RETURN
END IF
RETURN
END SUBROUTINE VTMOP_LTR

SUBROUTINE VTMOP_OPT( VTMOP, LTR_LB, LTR_UB, DES_PTS, OBJ_PTS, CAND_PTS, IERR )
! This subroutine fits and optimizes P surrogate models within the current
! local trust region (LTR), over the adaptive weights in the VTMOP object,
! as described in
!
! Deshpande, Shubhangi, Layne T. Watson, and Robert A. Canfield.
! "Multiobjective optimization using an adaptive weighting scheme."
! Optimization Methods and Software 31.1 (2016): 110-133.
!
!
! On input:
!
! VTMOP is an object of derived data type VTMOP_TYPE, which carries meta data
!    about the multiobjective problem. VTMOP is created using VTMOP_INIT.
!
! LTR_LB(1:D) is the real vector of lower bounds for the LTR.
!
! LTR_UB(1:D) is the real vector of upper bounds for the LTR.
!
! DES_PTS(1:D,1:N) is a real matrix of all design points in the feasible
!    design space [LB, UB], stored by column. The second dimension of
!    DES_PTS(:,:) (N) is assumed based on the shape and must be at least
!    D+1 to build an accurate surrogate model.
!
! OBJ_PTS(1:P,1:N) is a real matrix of objective values corresponding
!    to the design points in DES_PTS(:,:), stored by column: for
!    cost function F, OBJ_PTS(:,I) = F(DES_PTS(:,I)).
!
! CAND_PTS(:,:) is an ALLOCATABLE real array, which need not be allocated
!    on input. If allocated, any contents of CAND_PTS are lost, and CAND_PTS
!    are reallocated on output.
!
!
! On output:
!
! CAND_PTS(1:D,1:M) is a list of candidate design points to be evaluated
!    before the next iteration of the algorithm. CAND_PTS contains
!    no redundant design points.
!
! IERR is an integer error flag. IERR=0 signifies a successful iteration.
!
! Hundreds digit:
!  000 : Normal output. Successful iteration, and list CAND_PTS obtained.
!
!  3xx : Errors detected.
!   Tens digit:
!     31x : The input parameters contained illegal dimensions or values.
!       Ones digit:
!         310 : Either the LB(:) or UB(:) array is not allocated.
!         311 : Either P or D contains an illegal value, or does not
!               agree with input sizes.
!         312 : The lead dimension of LB(:) must match D.
!         313 : The lead dimension of UB(:) must match D.
!         314 : LB(:) must be elementwise strictly less than UB(:) - TOL.
!         315 : The lead dimension of DES_PTS(:,:) must match D.
!         316 : The lead dimension of OBJ_PTS(:,:) must match P.
!         317 : The second dimensions of DES_PTS and OBJ_PTS must match.
!     32x : An irregularity was detected in the supplied VTMOP data type.
!       Ones digit:
!         320 : The adaptive weights are not allocated. Check that
!               the last subroutine called was VTMOP_LTR.
!         321 : The adaptive weights array is allocated, but its lead
!               dimension does not match the number of objectives P. This
!               is most likely the result of an undetected segmentation
!               fault.
!         322 : There are too few adaptive weights. This is most likely the
!               result of an undetected segmentation fault.
!         323 : One of the adaptive weights contains a negative value. This
!               is most likely the result of an undetected segmentation
!               fault.
!     33x : A memory error has occurred.
!       Ones digit:
!         330 : A memory allocation error occurred in the local memory.
!         331 : A memory deallocation error occurred in the local memory.
!         332 : A memory deallocation error occurred while freeing the
!               adaptive weights for the next iteration.
!     340 : Too few points were supplied in DES_PTS and OBJ_PTS to construct
!           an accurate surrogate. At least D+1 points are required.
!
!  6xx : Error thrown by FIT_SURROGATES.
!    Tens and ones digits carry the error code from FIT_SURROGATES subroutine.
!    Note, this assumes that FIT_SURROGATES returns an error code less than
!    100.
!
!  7xx : Error thrown by LOCAL_OPT.
!    Tens and ones digits carry the error code from LOCAL_OPT subroutine.
!    Note, this assumes that LOCAL_OPT returns an error code less than 100.
!
!  9xx : A checkpointing error was thrown.
!    91x : The VTMOP passed to the checkpoint was invalid.
!    93x : Error writing iteration information to the checkpoint file.
!
IMPLICIT NONE
! Input parameters.
TYPE(VTMOP_TYPE), INTENT(INOUT) :: VTMOP ! Data struct containing problem info.
REAL(KIND=R8), INTENT(IN) :: LTR_LB(:) ! Lower bound constraints.
REAL(KIND=R8), INTENT(IN) :: LTR_UB(:) ! Upper bound constraints.
REAL(KIND=R8), INTENT(IN) :: DES_PTS(:,:) ! Table of design points.
REAL(KIND=R8), INTENT(IN) :: OBJ_PTS(:,:) ! Table of objective values.
! Output parameters.
REAL(KIND=R8), INTENT(OUT), ALLOCATABLE :: CAND_PTS(:,:) ! Efficient set.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Problem dimensions.
INTEGER :: D ! Design space dimension.
INTEGER :: L ! Number of adaptive weights for the current iteration.
INTEGER :: M ! Number of candidate design points to be returned.
INTEGER :: N ! Number of design/objective points in the database.
INTEGER :: P ! Number of objectives.
! Local variables.
INTEGER :: I, J ! Loop indexing variables.
REAL(KIND=R8) :: MIN_X(VTMOP%D,SIZE(VTMOP%WEIGHTS,2)) ! Potential candidate pts.
! External BLAS function for computing Euclidean distance.
REAL(KIND=R8), EXTERNAL :: DNRM2

! Get problem dimensions from input data.
D = VTMOP%D; P = VTMOP%P; N = SIZE(DES_PTS,2); L = SIZE(VTMOP%WEIGHTS,2)
! Check for illegal problem dimensions.
IF ((.NOT. ALLOCATED(VTMOP%LB)) .OR. (.NOT. ALLOCATED(VTMOP%UB))) THEN
   IERR = 310; RETURN; END IF
IF ((D < 1) .OR. (P < 2) .OR. (SIZE(VTMOP%LB,1) .NE. D) .OR. &
    (SIZE(VTMOP%UB,1) .NE. D)) THEN
   IERR = 311; RETURN; END IF
IF (SIZE(LTR_LB,1) .NE. D) THEN ! Lower bound dimension does not match D.
   IERR = 312; RETURN; END IF
IF (SIZE(LTR_UB,1) .NE. D) THEN ! Upper bound dimension does not match D.
   IERR = 313; RETURN; END IF
IF (ANY(LTR_LB .GE. LTR_UB - VTMOP%DES_TOL) .OR. &
    ANY(LTR_LB < VTMOP%LB - VTMOP%EPS) .OR.      &
    ANY(LTR_UB > VTMOP%UB + VTMOP%EPS)) THEN
   IERR = 314; RETURN; END IF
! Check that the dimensions of DES_PTS and OBJ_PTS match.
IF (SIZE(DES_PTS,1) .NE. D) THEN
   IERR = 315; RETURN; END IF
IF (SIZE(OBJ_PTS,1) .NE. P) THEN
   IERR = 316; RETURN; END IF
IF (SIZE(OBJ_PTS,2) .NE. N) THEN
   IERR = 317; RETURN; END IF
! Check the adaptive VTMOP%WEIGHTS array.
IF(.NOT. ALLOCATED(VTMOP%WEIGHTS)) THEN
   IERR = 320; RETURN; END IF
IF(SIZE(VTMOP%WEIGHTS,1) .NE. P) THEN
   IERR = 321; RETURN; END IF
IF(L < P+1) THEN
   IERR = 322; RETURN; END IF
IF(ANY(VTMOP%WEIGHTS < -VTMOP%EPS)) THEN
   IERR = 323; RETURN; END IF
! Too few points to fit a surrogate model.
IF (N < D+1) THEN
   IERR = 340; RETURN; END IF

! Fit P surrogate models.
IF (VTMOP%ITERATE .EQ. 0) THEN
   CALL VTMOP%FIT_SURROGATES(D, P, N, DES_PTS, OBJ_PTS, .TRUE., VTMOP%PMODE, &
                             VTMOP%DES_TOL, VTMOP%UB(:)-VTMOP%LB(:),         &
                             VTMOP%LB(:), IERR)
   IF (IERR .NE. 0) THEN
      IERR = IERR + 600; RETURN; END IF
ELSE
   CALL VTMOP%FIT_SURROGATES(D, P, N, DES_PTS, OBJ_PTS, .FALSE., VTMOP%PMODE, &
                             VTMOP%DES_TOL, VTMOP%UB(:)-VTMOP%LB(:),          &
                             VTMOP%LB(:), IERR)
   IF (IERR .NE. 0) THEN
      IERR = IERR + 600; RETURN; END IF
END IF

! Initialize the module variables containing the problem dimensions.
VTMOP_MOD_D = D
VTMOP_MOD_P = P
! Set the module surrogate functions.
VTMOP_MOD_SURROGATES => VTMOP%EVAL_SURROGATES

! Optimize the surrogate models for all adaptive weightings.
!$OMP PARALLEL &
!
! The PRIVATE list specifies uninitialized variables, of which each
! thread has a private copy.
!$OMP& PRIVATE(I), &
!
! The REDUCTION clause specifies a PRIVATE variable that will retain
! some value (i.e., max, min, sum, etc.) upon output.
!$OMP& REDUCTION(MAX:IERR), &
!
! Any variables not explicitly listed above receive the SHARED scope
! by default and are visible across all threads.
!$OMP& DEFAULT(SHARED), &
!
! Only use this level of parallelism if PMODE is .TRUE.
!$OMP& IF(VTMOP%PMODE)
! Initialize the error flag.
IERR = 0
! Allocate the adaptive weights array.
IF(ALLOCATED(VTMOP_MOD_WEIGHTS)) THEN
   DEALLOCATE(VTMOP_MOD_WEIGHTS, STAT=IERR)
   IF (IERR .NE. 0) IERR = 331
END IF
ALLOCATE(VTMOP_MOD_WEIGHTS(P), STAT=IERR)
IF (IERR .NE. 0) IERR = 330
! Optimize L adaptive weightings of the P surrogate models.
!$OMP DO SCHEDULE(STATIC)
DO I = 1, L
   ! If an error occurs, skip to the end.
   IF (IERR .NE. 0) CYCLE
   ! Set the module weights.
   VTMOP_MOD_WEIGHTS(:) = VTMOP%WEIGHTS(:,I)
   ! Call the local optimizer.
   MIN_X(:,I) = (LTR_LB(:) + LTR_UB(:)) / 2.0_R8
   CALL VTMOP%LOCAL_OPT( D, MIN_X(:,I), LTR_LB(:), LTR_UB(:),              &
                         SURROGATE_FUNC, VTMOP%LOPT_BUDGET, VTMOP%DES_TOL, &
                         IERR )
END DO
!$OMP END DO
!$OMP END PARALLEL
IF (IERR .NE. 0) THEN
   IERR = IERR + 700; RETURN; END IF

! Post processing loop to filter out redundant evaluation points.
M = L ! Track the number of distinct candidate points to return.
I = 1 ! Track the current iterate.
FILTER_LOOP : DO WHILE(.TRUE.)
   ! If the end of the reduced list is reached, exit the loop.
   IF (I > M) EXIT FILTER_LOOP
   ! If MIN_X(:,I) is already in DES_PTS(:,:), don't add to CAND_PTS(:,:).
   DO J = 1, SIZE(DES_PTS(:,:), 2)
      IF (DNRM2(D, DES_PTS(:,J)-MIN_X(:,I), 1) < VTMOP%DES_TOL) THEN
         ! Perform a deletion by overwriting the current entry with the last.
         MIN_X(:,I) = MIN_X(:,M)
         M = M - 1
         ! Skip forward.
         CYCLE FILTER_LOOP
      END IF
   END DO
   ! If MIN_X(:,J) = MIN_X(:,I), for J <= I, don't add to CAND_PTS(:,:).
   DO J = 1, I - 1
      IF (DNRM2(D, MIN_X(:,J)-MIN_X(:,I), 1) < VTMOP%DES_TOL) THEN
         ! Perform a deletion by overwriting the current entry with the last.
         MIN_X(:,I) = MIN_X(:,M)
         M = M - 1
         ! Skip forward.
         CYCLE FILTER_LOOP
      END IF
   END DO
   ! If all the tests passed, advance the iteration index.
   I = I + 1
END DO FILTER_LOOP

! Increment the iteration counter.
VTMOP%ITERATE = VTMOP%ITERATE + 1
! Free CAND_PTS if they are already allocated.
IF(ALLOCATED(CAND_PTS)) THEN
   DEALLOCATE(CAND_PTS, STAT=IERR)
   IF(IERR .NE. 0) THEN
      IERR = 331; RETURN; END IF
END IF
! Allocate and fill CAND_PTS(:,:) to return.
ALLOCATE(CAND_PTS(D,M), STAT=IERR)
IF(IERR .NE. 0) THEN
   IERR = 330; RETURN; END IF
CAND_PTS(:,:) = MIN_X(:,1:M)
! Free the WEIGHTS array for next iteration.
DEALLOCATE(VTMOP%WEIGHTS, STAT=IERR)
IF(IERR .NE. 0) IERR = 332
! Free the VTMOP_MOD_WEIGHTS array.
DEALLOCATE(VTMOP_MOD_WEIGHTS, STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 332; RETURN; END IF

! If CHKPT is set, save to the checkpoint file.
! Check whether checkpointing is enabled.
IF (VTMOP%CHKPT) THEN
   ! Save the updated VTMOP object to the checkpoint file.
   CALL VTMOP_CHKPT(VTMOP, IERR)
   IF (IERR .NE. 0) RETURN
END IF
RETURN
END SUBROUTINE VTMOP_OPT

SUBROUTINE VTMOP_FINALIZE( VTMOP, DES_PTS, OBJ_PTS, M, PARETO_F, EFFICIENT_X, &
                           IERR )
! This subroutine finalizes a multiobjective optimization problem, by
! computing the entire weakly Pareto set, and freeing all dynamic memory
! allocated to the VTMOP object.
!
!
! On input:
!
! VTMOP is an object of derived data type VTMOP_TYPE, which carries meta data
!    about the multiobjective problem. VTMOP is created using VTMOP_INIT.
!
! DES_PTS(1:D,1:N) is a real matrix of all design points in
!    the feasible design space [LB, UB], stored in column major order.
!    The second dimension of DES_PTS(:,:) (N) is assumed based on the shape
!    and must be at least D+1 to build an accurate surrogate model.
!
! OBJ_PTS(1:P,1:N) is a real matrix of objective values corresponding
!    to the design points in DES_PTS(:,:), stored in column major order.
!    I.e., for cost function F, OBJ_PTS(:,I) = F(DES_PTS(:,I)).
!
! PARETO_F(:,:) is an ALLOCATABLE real array. PARETO_F need not be allocated
!    on input. If allocated, any contents of PARETO_F are lost, as PARETO_F
!    is reallocated on output.
!
! EFFICIENT_X(:,:) is an ALLOCATABLE real array. EFFICIENT_X need not be
!    allocated on input. If allocated, any contents of EFFICIENT_X are
!    lost, as EFFICIENT_X is reallocated on output.
!
!
! On output:
!
! M is the cardinality of the weakly Pareto set.
!
! EFFICIENT_X(1:D,1:M) contains the entire weakly efficient set, stored in
!    column major ordering, with corresponding objective values in PARETO_F.
!
! PARETO_F(1:P,1:M) contains the entire weakly nondominated set. Note,
!    PARETO_F may contain duplicate values since the entire weakly nondominated
!    set is returned.
!
! IERR is an integer error flag.
!
! Hundreds digit:
!  000 : Normal output. Successful iteration, and list CAND_PTS obtained.
!
!  4xx : Errors detected.
!   Tens digit:
!     41x : The input parameters contained illegal dimensions or values.
!       Ones digit:
!         410 : The VTMOP object contains illegal problem dimensions. This
!               is most likely the result of an undetected segmentation
!               fault.
!         411 : The lead dimension of DES_PTS(:,:) must match D.
!         412 : The lead dimension of OBJ_PTS(:,:) must match P.
!         413 : The second dimensions of DES_PTS and OBJ_PTS must match.
!     42x : A memory error occurred while managing the output arrays.
!       Ones digit:
!         420 : A memory allocation error occurred while allocating an
!               output array PARETO_F and EFFICIENT_X.
!         421 : A memory deallocation error occurred while freeing an
!               output array PARETO_F or EFFICIENT_X, which was already
!               allocated on input.
!     43x : A memory error has occurred while managing internal memory.
!       Ones digit:
!         430 : A memory allocation error occurred in the local memory.
!         431 : A memory deallocation error occurred in the local memory.
!     441 : A memory error has occurred while freeing the VTMOP object or
!           module memory. The output arrays EFFICIENT_X and PARETO_F
!           should be unaffected.
!
USE IEEE_ARITHMETIC
IMPLICIT NONE
! Input parameters.
TYPE(VTMOP_TYPE), INTENT(INOUT) :: VTMOP ! Data struct containing problem info.
REAL(KIND=R8), INTENT(IN) :: DES_PTS(:,:) ! Table of precomputed design pts.
REAL(KIND=R8), INTENT(IN) :: OBJ_PTS(:,:) ! Table of objective values.
! Output parameters.
INTEGER, INTENT(OUT) :: M ! Cardinality of the weakly Pareto set.
REAL(KIND=R8), ALLOCATABLE, INTENT(OUT) :: PARETO_F(:,:)
REAL(KIND=R8), ALLOCATABLE, INTENT(OUT) :: EFFICIENT_X(:,:)
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Problem dimensions.
INTEGER :: D ! Design space dimension.
INTEGER :: N ! Cardinality of the weakly Pareto set.
INTEGER :: P ! Number of objectives.
! Local variables.
INTEGER :: I, J ! Loop indexing variables.
! Local dynamic arrays.
INTEGER, ALLOCATABLE :: INDICES(:) ! For tracking indices when sorting.
REAL(KIND=R8), ALLOCATABLE :: PARETO_SET(:,:) ! Pareto front.
REAL(KIND=R8), ALLOCATABLE :: EFFICIENT_SET(:,:) ! Efficient set.
! External BLAS procedures.
REAL(KIND=R8), EXTERNAL :: DNRM2 ! Euclidean distance (BLAS).

! Get problem dimensions from input data.
D = VTMOP%D; P = VTMOP%P; N = SIZE(DES_PTS,2)
! Check for illegal problem dimensions.
IF ((D < 1) .OR. (P < 2)) THEN
   IERR = 410; RETURN; END IF
IF (SIZE(DES_PTS,1) .NE. D) THEN
   IERR = 411; RETURN; END IF
IF (SIZE(OBJ_PTS,1) .NE. P) THEN
   IERR = 412; RETURN; END IF
IF (SIZE(OBJ_PTS,2) .NE. N) THEN
   IERR = 413; RETURN; END IF

! Allocate the dynamic arrays for storing both copies of the Pareto front.
ALLOCATE(INDICES(N), PARETO_SET(P,N), EFFICIENT_SET(D,N), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 430; RETURN; END IF

! Make copies of the objective and their indices for sorting.
FORALL (I=1:N) INDICES(I) = I
PARETO_SET(:,:) = OBJ_PTS(:,:)
! Replace NANs with large numbers so that they will be ignored.
DO I = 1, N
   IF (ANY(IEEE_IS_NAN(PARETO_SET(:,I)))) PARETO_SET(:,I) = HUGE(0.0_R8)
END DO
! Sort objective and design points.
CALL QSORTC_DVEC(PARETO_SET, INDICES)
EFFICIENT_SET(:,:) = DES_PTS(:,INDICES)
! Free the indices; they are not needed anymore.
DEALLOCATE(INDICES, STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 431; RETURN; END IF
! The first entry in PARETO_SET/EFFICIENT_SET is always Pareto optimal.
M = 1 ! Count the cardinality of the Pareto front.
! Get the weakly Pareto and efficient sets.
OUTER : DO I = 2, N
   ! Check against all points in the current solution set.
   INNER : DO J = 1, M
      ! Check whether the points at indices I and J are equal.
      IF (DNRM2(P, PARETO_SET(:,I) - PARETO_SET(:,J), 1) < VTMOP%OBJ_TOL) THEN
         CYCLE INNER ! Consider all weakly Pareto points.
      END IF
      ! Check whether the Jth point dominates the Ith point.
      IF (ALL(PARETO_SET(:,J) .LE. PARETO_SET(:,I) + VTMOP%OBJ_TOL)) THEN
         CYCLE OUTER ! Skip the Ith point.
      END IF
   END DO INNER
   ! Increment the counter and update both Pareto front arrays.
   M = M + 1
   PARETO_SET(:,M) = PARETO_SET(:,I)
   EFFICIENT_SET(:,M) = EFFICIENT_SET(:,I)
END DO OUTER

! Reallocate the output arrays.
IF (ALLOCATED(PARETO_F)) THEN
   DEALLOCATE(PARETO_F, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 421; RETURN; END IF
END IF
IF (ALLOCATED(EFFICIENT_X)) THEN
   DEALLOCATE(EFFICIENT_X, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 421; RETURN; END IF
END IF
ALLOCATE(EFFICIENT_X(D,M), PARETO_F(P,M), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 420; RETURN; END IF
! Populate the output arrays.
EFFICIENT_X(:,:) = EFFICIENT_SET(:,1:M)
PARETO_F(:,:) = PARETO_SET(:,1:M)
! Free the local memory.
DEALLOCATE(EFFICIENT_SET, PARETO_SET, STAT=IERR)
IF (IERR .NE. 0) THEN
    IERR = 431; RETURN; END IF
! Free the VTMOP data structure's memory.
IF (ALLOCATED(VTMOP%WEIGHTS)) THEN
   DEALLOCATE(VTMOP%WEIGHTS, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 441; RETURN; END IF
END IF
IF (ALLOCATED(VTMOP%LB)) THEN
   DEALLOCATE(VTMOP%LB, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 441; RETURN; END IF
END IF
IF (ALLOCATED(VTMOP%UB)) THEN
   DEALLOCATE(VTMOP%UB, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 441; RETURN; END IF
END IF
IF (ALLOCATED(VTMOP%CLIST)) THEN
   DEALLOCATE(VTMOP%CLIST, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 441; RETURN; END IF
END IF
IF (ALLOCATED(VTMOP%OBJ_BOUNDS)) THEN
   DEALLOCATE(VTMOP%OBJ_BOUNDS, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 441; RETURN; END IF
END IF
RETURN
END SUBROUTINE VTMOP_FINALIZE

! The following subroutines are for performing checkpointing.

SUBROUTINE VTMOP_CHKPT_NEW(VTMOP, IERR)
! Create a new checkpoint file for a given instance of VTMOP.
!
!
! On input:
!
! VTMOP is an object of derived data type VTMOP_TYPE, which carries metadata
!    about the multiobjective problem.
!
!
! On output:
!
! IERR is an integer error flag.
!
!  000 : Normal output. Successful initialization of a new VTMOP checkpoint.
!
!  9xx : Errors detected.
!     91x : The input parameters contained illegal dimensions or values.
!         910 : VTMOP does not appear to have been properly allocated.
!         911 : VTMOP has been allocated, but appears to contain corrupted
!               or inconsistent data.
!     92x : A file I/O error was detected.
!         920 : An error occurred while opening the checkpoint file.
!         921 : An error occurred while writing data to the checkpoint file.
!         922 : An error occurred while closing the checkpoint file.
!
IMPLICIT NONE
! Input parameters.
TYPE(VTMOP_TYPE), INTENT(IN) :: VTMOP ! Data structure containing problem info.
! Output parameters.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Check for uninitialized values.
IF ( (.NOT. ALLOCATED(VTMOP%LB)) .OR. (.NOT. ALLOCATED(VTMOP%UB)) ) THEN
   IERR = 910; RETURN; END IF
! Check for illegal/mismatched values.
IF ( VTMOP%D < 1 .OR. VTMOP%P < 2) THEN
   IERR = 911; RETURN; END IF
IF (SIZE(VTMOP%LB, 1) .NE. VTMOP%D .OR. SIZE(VTMOP%UB) .NE. VTMOP%D) THEN
   IERR = 911; RETURN; END IF
! Open the checkpoint file, using unformatted write.
OPEN(VTMOP_CHKPTUNIT, FILE=VTMOP_CHKPTFILE, FORM="unformatted", &
     ACTION="write", IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 920; RETURN; END IF
! Write unformatted VTMOP metadata to the checkpoint file.
WRITE(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%D, VTMOP%P
IF (IERR .NE. 0) THEN
   IERR = 921; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
WRITE(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%DECAY, VTMOP%DES_TOL, VTMOP%EPS,     &
                                    VTMOP%EPSW, VTMOP%OBJ_TOL, VTMOP%MIN_RADF, &
                                    VTMOP%TRUST_RADF
IF (IERR .NE. 0) THEN
   IERR = 921; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
WRITE(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%LB(1:VTMOP%D), VTMOP%UB(1:VTMOP%D)
IF (IERR .NE. 0) THEN
   IERR = 921; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Close the checkpoint file.
CLOSE(VTMOP_CHKPTUNIT, IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 922; RETURN; END IF
RETURN
END SUBROUTINE VTMOP_CHKPT_NEW

SUBROUTINE VTMOP_CHKPT(VTMOP, IERR)
! Save VTMOP's iteration data to an existing checkpoint file.
!
!
! On input:
!
! VTMOP is an object of derived data type VTMOP_TYPE, which carries meta data
!    about the multiobjective problem.
!
!
! On output:
!
! IERR is an integer error flag.
!
!  000 : Normal output. Iteration data saved to the checkpoint file.
!
!  9xx : Errors detected.
!     91x : The input parameters contained illegal dimensions or values.
!         910 : VTMOP does not appear to have been properly allocated.
!         911 : VTMOP has been allocated, but appears to contain corrupted
!               or inconsistent data.
!     93x : A file I/O error was detected.
!         930 : The checkpoint file could not be opened, check whether
!               CHKPTFILE has been properly initialized.
!         931 : An error occurred while writing data to the checkpoint file.
!         932 : An error occurred while closing the checkpoint file.
!
IMPLICIT NONE
! Input parameters.
TYPE(VTMOP_TYPE), INTENT(IN) :: VTMOP ! Data structure containing problem info.
! Output parameters.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Check for uninitialized values.
IF ( (.NOT. ALLOCATED(VTMOP%LB)) .OR. (.NOT. ALLOCATED(VTMOP%UB)) ) THEN
   IERR = 910; RETURN; END IF
! Check for illegal/mismatched values.
IF ( VTMOP%D < 1 .OR. VTMOP%P < 2) THEN
   IERR = 911; RETURN; END IF
IF (SIZE(VTMOP%LB, 1) .NE. VTMOP%D .OR. SIZE(VTMOP%UB) .NE. VTMOP%D) THEN
   IERR = 911; RETURN; END IF
! Open the checkpoint file, using unformatted append.
OPEN(VTMOP_CHKPTUNIT, FILE=VTMOP_CHKPTFILE, FORM="unformatted", ACTION="write", &
     POSITION="append", STATUS="old", IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 930; RETURN; END IF
! The status of VTMOP%WEIGHTS tells the phase of the VTMOP algorithm.
IF (ALLOCATED(VTMOP%WEIGHTS)) THEN
   IF (VTMOP%ITERATE > 0) THEN ! Don't write CLIST for the zeroth iteration.
      ! Write unformatted VTMOP iteration data to the checkpoint file.
      WRITE(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%CLIST(1:VTMOP%D+1,VTMOP%ITERATE)
      IF (IERR .NE. 0) THEN
         IERR = 931; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
   END IF
   ! Write unformatted adaptive weights to the checkpoint file.
   WRITE(VTMOP_CHKPTUNIT, IOSTAT=IERR) SIZE(VTMOP%WEIGHTS, 2)
   IF (IERR .NE. 0) THEN
      IERR = 931; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
   WRITE(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%WEIGHTS(:,:)
   IF (IERR .NE. 0) THEN
      IERR = 931; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
ELSE
   ! Write the iteration counter.
   WRITE(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%ITERATE
   IF (IERR .NE. 0) THEN
      IERR = 931; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
END IF
! Close the checkpoint file.
CLOSE(VTMOP_CHKPTUNIT, IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 932; RETURN; END IF
RETURN
END SUBROUTINE VTMOP_CHKPT

SUBROUTINE VTMOP_CHKPT_RECOVER(VTMOP, IERR)
! Recover VTMOP's progress from a checkpoint file.
!
!
! On output:
!
! The status of VTMOP is as specified in CHKPTFILE.
!
! IERR is an integer error flag.
!
!  000 : Normal output. Iteration data saved to the checkpoint file.
!
!  9xx : Errors detected.
!     94x : A file I/O error was detected.
!         940 : The checkpoint file could not be opened, check whether
!               CHKPTFILE has been properly initialized.
!         941 : An error occurred while writing data to the checkpoint file.
!         942 : An error occurred while closing the checkpoint file.
!     95x : A memory allocation error occurred.
!         950 : A memory allocation error occurred.
!         951 : A memory deallocation error occurred.
!     960 : Failed the sanity check. Either the checkpoint feature was
!           implemented improperly, or VTMOP_CHKPTFILE was corrupted.
!
IMPLICIT NONE
! Output parameters.
TYPE(VTMOP_TYPE), INTENT(OUT) :: VTMOP ! Data structure containing problem info.
INTEGER, INTENT(OUT) :: IERR ! Error flag arrays.
! Temporary arrays.
INTEGER :: NW
REAL(KIND=R8), ALLOCATABLE :: TMP(:,:)
! Open the checkpoint file, using unformatted write.
OPEN(VTMOP_CHKPTUNIT, FILE=VTMOP_CHKPTFILE, FORM="unformatted", ACTION="read", &
     STATUS="old", IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 940; RETURN; END IF
! Read in the problem dimensions.
READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%D, VTMOP%P
IF (IERR .NE. 0) THEN
   IERR = 941; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Read in the problem parameters.
READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%DECAY, VTMOP%DES_TOL, VTMOP%EPS,     &
                                   VTMOP%EPSW, VTMOP%OBJ_TOL, VTMOP%MIN_RADF, &
                                   VTMOP%TRUST_RADF
IF (IERR .NE. 0) THEN
   IERR = 941; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Allocate the bound constraints.
ALLOCATE(VTMOP%LB(VTMOP%D), VTMOP%UB(VTMOP%D), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 950; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Read in the bound constraints.
READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%LB(1:VTMOP%D), VTMOP%UB(1:VTMOP%D)
IF (IERR .NE. 0) THEN
   IERR = 941; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Initialize the iteration data.
VTMOP%ITERATE = 0
VTMOP%LCLIST = 20
ALLOCATE(VTMOP%CLIST(VTMOP%D+1,VTMOP%LCLIST), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 950; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF

! Recreate the 0th iteration.

! Read the size of the next batch of adaptive weights.
READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) NW
IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
   IERR = 0; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Allocate VTMOP%WEIGHTS accordingly.
ALLOCATE(VTMOP%WEIGHTS(VTMOP%P, NW), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 950; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Read in the next batch of adaptive weights.
READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%WEIGHTS(:,:)
IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
   IERR = 0; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Next checkpoint tells that the search phase has completed.
READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) NW
IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
   IERR = 0; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Update the iteration counter, and do a sanity check.
VTMOP%ITERATE = VTMOP%ITERATE + 1
IF (NW .NE. VTMOP%ITERATE) THEN
   IERR = 960; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
! Free the adaptive weights for the next iteration.
DEALLOCATE(VTMOP%WEIGHTS, STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 951; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF

! Read data into VTMOP%CLIST(:,:) until the end of file.
READ_LOOP : DO WHILE (.TRUE.)
   ! Check if VTMOP%CLIST(:,:) needs to be resized.
   IF (VTMOP%ITERATE .EQ. VTMOP%LCLIST) THEN
      ! Allocate the temporary array.
      ALLOCATE(TMP(VTMOP%D+1,VTMOP%ITERATE), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 950; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
      ! Make a temporary copy.
      TMP(:,:) = VTMOP%CLIST(:,:)
      ! Update the size of VTMOP%LCLIST.
      VTMOP%LCLIST = VTMOP%LCLIST * 2
      ! Reallocate VTMOP%CLIST to twice its current size.
      DEALLOCATE(VTMOP%CLIST, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 951; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
      ALLOCATE(VTMOP%CLIST(VTMOP%D+1, VTMOP%LCLIST), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 950; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
      ! Restore values back into CLIST and free the temporary array.
      VTMOP%CLIST(:,1:VTMOP%ITERATE) = TMP(:,:)
      DEALLOCATE(TMP, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 951; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
   END IF
   ! Now, read in the next point in the center list from the file.
   READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%CLIST(1:VTMOP%D+1, VTMOP%ITERATE)
   IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
      IERR = 0; EXIT READ_LOOP; END IF
   ! Read the size of the next batch of adaptive weights.
   READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) NW
   IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
      IERR = 0; EXIT READ_LOOP; END IF
   ! Allocate VTMOP%WEIGHTS accordingly.
   ALLOCATE(VTMOP%WEIGHTS(VTMOP%P, NW), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 950; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
   ! Read in the next batch of adaptive weights.
   READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) VTMOP%WEIGHTS(:,:)
   IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
      IERR = 0; EXIT READ_LOOP; END IF
   ! Next checkpoint tells that the search phase has completed.
   READ(VTMOP_CHKPTUNIT, IOSTAT=IERR) NW
   IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
      IERR = 0; EXIT READ_LOOP; END IF
   ! Update the iteration counter, and do a sanity check.
   VTMOP%ITERATE = VTMOP%ITERATE + 1
   IF (NW .NE. VTMOP%ITERATE) THEN
      IERR = 960; EXIT READ_LOOP; END IF
   ! Free the adaptive weights for the next iteration.
   DEALLOCATE(VTMOP%WEIGHTS, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 951; CLOSE(VTMOP_CHKPTUNIT); RETURN; END IF
END DO READ_LOOP
! Close the checkpoint file.
CLOSE(VTMOP_CHKPTUNIT, IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 942; RETURN; END IF
RETURN
END SUBROUTINE VTMOP_CHKPT_RECOVER

SUBROUTINE VTMOP_NEW_DATA(D, P, IERR)
! Create a new checkpoint data file to store VTMOP's function evaluation data.
!
!
! On input:
!
! D is the dimension of the design space.
!
! P is the dimension of the objective space.
!
!
! On output:
!
! IERR is an integer error flag.
!
!  000 : Normal output. Successful initialization of a new data checkpoint
!        file.
!
!  97x : Errors detected.
!     97x : A data I/O error was detected.
!         970 : An error occurred while opening the data file.
!         971 : An error occurred while writing data to the data file.
!         972 : An error occurred while closing the data file.
!
IMPLICIT NONE
! Input parameters.
INTEGER, INTENT(IN) :: D, P ! Problem dimensions.
! Output parameters.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Create a new data file, using unformatted write.
OPEN(VTMOP_DATAUNIT, FILE=VTMOP_DATAFILE, FORM="unformatted", ACTION="write", &
     IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 970; RETURN; END IF
! Write the problem dimensions.
WRITE(VTMOP_DATAUNIT, IOSTAT=IERR) D, P
IF (IERR .NE. 0) THEN
   IERR = 971; CLOSE(VTMOP_DATAUNIT); RETURN; END IF
! Close the data file.
CLOSE(VTMOP_DATAUNIT, IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 972; RETURN; END IF
RETURN
END SUBROUTINE VTMOP_NEW_DATA

SUBROUTINE VTMOP_SAVE_DATA(DES_PT, OBJ_PT, IERR)
! Save VTMOP's function evaluation data to an existing checkpoint file.
!
!
! On input:
!
! DES_PT(:) is a design point to save.
!
! OBJ_PT(:) is a corresponding objective value to save.
!
!
! On output:
!
! IERR is an integer error flag.
!
!  000 : Normal output. Successful initialization of a new VTMOP checkpoint.
!
!  9xx : Errors detected.
!     98x : A data I/O error was detected.
!         980 : An error occurred while opening the data file.
!         981 : An error occurred while writing data to the data file.
!         982 : An error occurred while closing the data file.
!
IMPLICIT NONE
! Input parameters.
REAL(KIND=R8), INTENT(IN) :: DES_PT(:), OBJ_PT(:)
! Output parameters.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Open an existing data file, using unformatted append.
OPEN(VTMOP_DATAUNIT, FILE=VTMOP_DATAFILE, FORM="unformatted", ACTION="write", &
     POSITION="append", STATUS="old", IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 980; RETURN; END IF
! Write the design point and objective value.
WRITE(VTMOP_DATAUNIT, IOSTAT=IERR) DES_PT(:), OBJ_PT(:)
IF (IERR .NE. 0) THEN
   IERR = 981; CLOSE(VTMOP_DATAUNIT); RETURN; END IF
! Close the checkpoint file.
CLOSE(VTMOP_DATAUNIT, IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 982; RETURN; END IF
RETURN
END SUBROUTINE VTMOP_SAVE_DATA

SUBROUTINE VTMOP_RECOVER_DATA(DBN, DBX, DBF, IERR, DB_SIZE)
! Recover VTMOP's function evaluation database from an existing checkpoint
! file.
!
!
! On input:
!
! DBX(:,:) and DBF(:,:) are unallocated, allocatable arrays.
!
! On output:
!
! DBN is the integer counter specifying the final length of DB{X|F}
!
! DBX(:,:) is allocated to the problem dimensions and contains the
!    recovered database of design points.
!
! DBF(:,:) is allocated to the problem dimensions and contains the
!    recovered database of objective points.
!
! IERR is an integer error flag.
!
!  000 : Normal output. Successful initialization of a new VTMOP checkpoint.
!
!  99x : Errors detected.
!     99x : A data I/O error was detected.
!         990 : An error occurred while opening the data file.
!         991 : An error occurred while reading data from the data file.
!         992 : An error occurred while closing the data file.
!         993 : There was an issue allocating the local memory.
!         994 : The number of recovered data points exceeds the budget.
!
!
! Optional arguments:
!
! DB_SIZE, when present, specifies the amount of memory to allocate for
!    DBX and DBF.  By default, DBX and DBF are allocated to a length of
!    1000.
!
IMPLICIT NONE
! Output parameters.
INTEGER, INTENT(OUT) :: DBN ! The size of the final database.
REAL(KIND=R8), ALLOCATABLE, INTENT(OUT) :: DBX(:,:) ! Recovered design points.
REAL(KIND=R8), ALLOCATABLE, INTENT(OUT) :: DBF(:,:) ! Recovered objective pts.
INTEGER, INTENT(OUT) :: IERR ! Error flag arrays.
INTEGER, OPTIONAL, INTENT(IN) :: DB_SIZE ! Size of the database.
! Local variables.
INTEGER :: D, P ! Problem dimensions.
INTEGER :: DB_SIZEL ! Local copy of database size parameters.
REAL(KIND=R8), ALLOCATABLE :: DES_PT(:), OBJ_PT(:) ! Temp arrays.
! Read in the optional inputs.
DB_SIZEL = 1000
IF (PRESENT(DB_SIZE)) THEN
   IF (DB_SIZE > 0) DB_SIZEL = DB_SIZE
END IF
! Create a new data file, using unformatted write.
OPEN(VTMOP_DATAUNIT, FILE=VTMOP_DATAFILE, FORM="unformatted", ACTION="read", &
     STATUS="old", IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 990; RETURN; END IF
! Read in the problem dimensions.
READ(VTMOP_DATAUNIT, IOSTAT=IERR) D, P
IF (IERR .NE. 0) THEN
   IERR = 991; CLOSE(VTMOP_DATAUNIT); RETURN; END IF
! Allocate the output array memory.
IF (ALLOCATED(DBX)) THEN
   DEALLOCATE(DBX, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 993; RETURN; END IF
END IF
IF (ALLOCATED(DBF)) THEN
   DEALLOCATE(DBF, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 993; RETURN; END IF
END IF
ALLOCATE(DBX(D,DB_SIZEL), DBF(P,DB_SIZEL), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 993; RETURN; END IF
! Allocate the local memory.
ALLOCATE(DES_PT(D), OBJ_PT(P), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 993; RETURN; END IF
! Read until all data points are recovered.
DBN = 0
DO WHILE(.TRUE.)
   READ(VTMOP_DATAUNIT, IOSTAT=IERR) DES_PT, OBJ_PT
   IF (IERR .NE. 0) THEN ! A read error occurred. This must be EOF.
      IERR = 0; EXIT; END IF
   ! If the database is at capacity, return an error.
   IF (DBN .GE. DB_SIZEL) THEN
      IERR = 994; RETURN; END IF
   ! Add DES_PT and OBJ_PT to the module database.
   DBN = DBN + 1
   DBX(:,DBN) = DES_PT(:)
   DBF(:,DBN) = OBJ_PT(:)
END DO
! Close the data file.
CLOSE(VTMOP_DATAUNIT, IOSTAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 992; RETURN; END IF
RETURN
END SUBROUTINE VTMOP_RECOVER_DATA

! The following module procedures are used internally.

FUNCTION SURROGATE_FUNC(C, IERR) RESULT(F)
! This module procedure uses the private module array VTMOP_MOD_WEIGHTS
! to scalarize the output of VTMOP_MOD_SURROGATES, matches the interface
! of VTMOP_MOD_SCALAR_INT, and can be passed as input to a generic single
! objective optimization procedure.
!
!
! On input:
!
! C(:) is a design point to be evaluated.
!
!
! On output:
!
! IERR is an integer error flag. Any nonzero value indicates an
!    illegal/missing value, as reported by VTMOP_MOD_SURROGATES.
!
! F is a scalar output, as determined by VTMOP_MOD_WEIGHTS(:).
!
IMPLICIT NONE
! Parameters.
REAL(KIND=R8), INTENT(IN) :: C(:)
INTEGER, INTENT(OUT) :: IERR
REAL(KIND=R8) :: F
! Local variables.
REAL(KIND=R8) :: V(VTMOP_MOD_P)
! BLAS function for computing inner products.
REAL(KIND=R8), EXTERNAL :: DDOT
! Evaluate the surrogates.
CALL VTMOP_MOD_SURROGATES(C, V, IERR)
IF (IERR .NE. 0) RETURN
! Compute the weighted sum.
F = DDOT(VTMOP_MOD_P, VTMOP_MOD_WEIGHTS, 1, V, 1)
RETURN
END FUNCTION SURROGATE_FUNC

! The following procedures define the default surrogate, using
! the module LINEAR_SHEPARD from SHEPPACK (ACM TOMS Alg. 905).

SUBROUTINE LSHEP_FIT(D, P, N, X_VALS, Y_VALS, FIRST, PARALLEL, DES_TOL, &
                     SCALE_FACT, SHIFT_FACT, IERR)
! This subroutine fits all P surrogate using the module LINEAR_SHEPARD
! from SHEPPACK.
!
! Thacker, William I., J. Zhang, L. T. Watson, J. B. Birch, M. A. Iyer, and
! M. W. Berry. Algorithm 905: SHEPPACK: Modified Shepard algorithm for
! interpolation of scattered multivariate data. ACM Trans. Math. Softw. (TOMS)
! 37.3 (2010): 34.
!
!
! On input:
!
! D is the dimension of the design space.
!
! P is the dimension of the objective space.
!
! N is the current size of the internal database.
!
! X_VALS(1:D,1:N) is a real vector containing the current database
!    of evaluated design points.
!
! Y_VALS(1:P,1:N) is a real vector containing the current database
!    of corresponding objective values.
!
! FIRST is a logical type that specifies whether this is the first iteration
!    of the algorithm. In the first iteration, since data is sparse, the
!    radius of influence for each design point is doubled.
!
! PARALLEL is a logical type that specifies whether the P LSHEP models should
!    be fit in parallel, using OpenMP.
!
! DES_TOL is a real type that specifies the design space tolerance.
!
! SCALE_FACT(1:D) is a real type that specifies the rescale factor for each
!    dimension of the input data. In particular, each point in X_VALS is
!    transformed by (X_VALS(:,I) - SHIFT_FACT(:)) / SCALE_FACT(:).
!
! SHIFT_FACT(1:D) is a real type that specifies the shift factor for each
!    dimension of the input data. In particular, each point in X_VALS is
!    transformed by (X_VALS(:,I) - SHIFT_FACT(:)) / SCALE_FACT(:).
!
!
! On output:
!
! IERR is an integer error flag.
!
!  00 : Normal output. Successfully fit the P LSHEP models.
!
!  1x : An illegal input was supplied.
!      11 : The problem dimensions D, P, or N contain illegal values.
!      12 : The sizes of the databases X_VALS(:,:) and Y_VALS(:,:) do not
!           match the problem dimensions
!  2x : Error reported by the LSHEP fit subroutine.
!      21 : The number of non-NaN values in the database was not enough
!           to fit the LSHEP models. Try increasing the search budget,
!           or consider whether the cost function is defined within
!           the given bound constraints.
!  3x : A memory allocation error occurred.
!      30 : A memory allocation error occurred.
!      31 : A memory deallocation error occurred.
!
!
! The following module variables are also altered on output.
!
! The P local linear fits are stored in the private module array
! LSHEP_A(:,:,1:P) and the radii of influence in the private module array
! LSHEP_RW(:,1:P). Also, this subroutine makes copies of the current dataset
! in LSHEP_XVALS(:,:) and LSHEP_FVALS(:,:), along with problem dimensions
! in LSHEP_D, LSHEP_P, and LSHEP_N_PTS. LSHEP_DES_TOL is set to the value
! DES_TOL. LSHEP_SCALE and LSHEP_SHIFT are set to SCALE_FACT and SHIFT_FACT,
! respectively.
!
! Finally, a taboo list LSHEP_TABOO(:,:) is created with length LSHEP_N_TABOO.
! If there are any missing values (marked as NaN values) in Y_VALS, then
! these entries appear in LSHEP_TABOO(:,:).
!
!
USE LINEAR_SHEPARD_MOD
USE IEEE_ARITHMETIC
IMPLICIT NONE
! Parameters.
INTEGER, INTENT(IN) :: D ! The dimension of the design space.
INTEGER, INTENT(IN) :: P ! The dimension of the objective space.
INTEGER, INTENT(IN) :: N ! The number of points in X_VALS/Y_VALS.
REAL(KIND=R8), INTENT(IN) :: X_VALS(:,:) ! N points in the design space.
REAL(KIND=R8), INTENT(IN) :: Y_VALS(:,:) ! Corresponding objective values.
LOGICAL, INTENT(IN) :: FIRST ! FIRST is .TRUE. in the 0th iteration.
LOGICAL, INTENT(IN) :: PARALLEL ! Fit the P surrogate models in parallel.
REAL(KIND=R8), INTENT(IN) :: DES_TOL ! Design space tolerance.
REAL(KIND=R8), INTENT(IN) :: SCALE_FACT(:) ! Scale factor for data points.
REAL(KIND=R8), INTENT(IN) :: SHIFT_FACT(:) ! Shift factor for data points.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Local variables.
INTEGER :: I ! Loop indexing variable.
REAL(KIND=R8) :: TMP_FVALS(P,N) ! Temporary list of F values.
REAL(KIND=R8) :: TMP_TABOO(D,N) ! Temporary taboo list.
REAL(KIND=R8) :: TMP_XVALS(D,N) ! Temporary list of x values.
! Check for illegal input dimensions.
IF (D < 1 .OR. P < 2 .OR. N < D+2) THEN
   IERR = 11; RETURN; END IF
! Check that the database dimensions match the input dimensions.
IF ( SIZE(X_VALS, 1) .NE. D .OR.    &
     SIZE(X_VALS, 2) .NE. N .OR.    &
     SIZE(Y_VALS, 1) .NE. P .OR.    &
     SIZE(Y_VALS, 2) .NE. N .OR.    &
     SIZE(SCALE_FACT,1) .NE. D .OR. &
     SIZE(SHIFT_FACT,1) .NE. D ) THEN
   IERR = 12; RETURN; END IF
! Set the LSHEP problem dimensions.
LSHEP_D = D
LSHEP_P = P
LSHEP_DES_TOL = DES_TOL
! Get the SCALE and SHIFT factors.
IF (ALLOCATED(LSHEP_SCALE)) THEN
   DEALLOCATE(LSHEP_SCALE, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 31; RETURN; END IF
END IF
IF (ALLOCATED(LSHEP_SHIFT)) THEN
   DEALLOCATE(LSHEP_SHIFT, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 31; RETURN; END IF
END IF
ALLOCATE(LSHEP_SCALE(D), LSHEP_SHIFT(D), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 30; RETURN; END IF
LSHEP_SCALE(:) = SCALE_FACT(:)
LSHEP_SHIFT(:) = SHIFT_FACT(:)
! Populate the temporary arrays with correct values.
LSHEP_N_PTS = 0
LSHEP_N_TABOO = 0
DO I = 1, N
   ! Check for NAN values.
   IF (ANY(IEEE_IS_NAN(Y_VALS(:,I)))) THEN
      ! Build the taboo list.
      LSHEP_N_TABOO = LSHEP_N_TABOO + 1
      TMP_TABOO(:,LSHEP_N_TABOO) = (X_VALS(:,I)-LSHEP_SHIFT(:))/LSHEP_SCALE(:)
   ELSE
      ! Build the LSHEP surrogate data set.
      LSHEP_N_PTS = LSHEP_N_PTS + 1
      TMP_XVALS(:,LSHEP_N_PTS) = (X_VALS(:,I)-LSHEP_SHIFT(:))/LSHEP_SCALE(:)
      TMP_FVALS(:,LSHEP_N_PTS) = Y_VALS(:,I)
   END IF
END DO
! Check that a reasonable number of non-NaN points were found.
IF (LSHEP_N_PTS > D+1) THEN
   ! Free the module arrays for resizing.
   IF (ALLOCATED(LSHEP_A)) THEN
      DEALLOCATE(LSHEP_A, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 31; RETURN; END IF
   END IF
   IF (ALLOCATED(LSHEP_RW)) THEN
      DEALLOCATE(LSHEP_RW, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 31; RETURN; END IF
   END IF
   IF (ALLOCATED(LSHEP_XVALS)) THEN
      DEALLOCATE(LSHEP_XVALS, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 31; RETURN; END IF
   END IF
   IF (ALLOCATED(LSHEP_FVALS)) THEN
      DEALLOCATE(LSHEP_FVALS, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 31; RETURN; END IF
   END IF
   IF (ALLOCATED(LSHEP_TABOO)) THEN
      DEALLOCATE(LSHEP_TABOO, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 31; RETURN; END IF
   END IF
   ! Reallocate LSHEP_A, LSHEP_RW, LSHEP_FVALS, and LSHEP_XVALS.
   ALLOCATE( LSHEP_A(D, LSHEP_N_PTS, P), LSHEP_RW(LSHEP_N_PTS, P),   &
             LSHEP_XVALS(D,LSHEP_N_PTS), LSHEP_FVALS(LSHEP_N_PTS,P), &
             STAT=IERR )
   IF (IERR .NE. 0) THEN
      IERR = 30; RETURN; END IF
! If not enough non-NAN points were found, LSHEP_FIT cannot proceed.
ELSE
   IERR = 21; RETURN; END IF
! Populate the LSHEP arrays.
LSHEP_XVALS(:,:) = TMP_XVALS(:,1:LSHEP_N_PTS)
LSHEP_FVALS(:,:) = TRANSPOSE(TMP_FVALS(:,1:LSHEP_N_PTS))
! If LSHEP_N_TABOO > 0, allocate the taboo list.
IF (LSHEP_N_TABOO > 0) THEN
   ALLOCATE(LSHEP_TABOO(D,LSHEP_N_TABOO), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 30; RETURN; END IF
   LSHEP_TABOO(:,:) = TMP_TABOO(:,1:LSHEP_N_TABOO)
END IF
! This is the beginning of an iteration task parallelism block. This block
! fits P surrogate models in parallel and stores the weights/radii in A and RW.
!$OMP PARALLEL DO SCHEDULE(STATIC) &
!
! The PRIVATE list specifies uninitialized variables, of which each
! thread has a private copy.
!$OMP& PRIVATE(I, IERR), &
!
! Any variables not explicitly listed above receive the SHARED scope
! by default and are visible across all threads.
!$OMP& DEFAULT(SHARED), &
!
! Only execute if in parallel mode.
!$OMP& IF(PARALLEL)
DO I = 1, LSHEP_P
   ! Perform the LSHEP fit for each of the P surrogate models.
   ! There is no need to consider IERR, since the only serious error
   ! case has already been handled.
   CALL LSHEP( LSHEP_D, LSHEP_N_PTS, LSHEP_XVALS, LSHEP_FVALS(:,I), &
               LSHEP_A(:,:,I), LSHEP_RW(:,I), IERR )
END DO
!$OMP END PARALLEL DO
! Reset the error flag to zero to indicate a successful output.
IERR = 0
! Double the radii of influence in the 0th iteration.
IF (FIRST) LSHEP_RW(:,:) = LSHEP_RW(:,:) * 2.0_R8
RETURN
END SUBROUTINE LSHEP_FIT

SUBROUTINE LSHEP_EVAL(C, V, IERR)
! This subroutine evaluates the P surrogate using the module LINEAR_SHEPARD
! from SHEPPACK.
!
! Thacker, William I., J. Zhang, L. T. Watson, J. B. Birch, M. A. Iyer, and
! M. W. Berry. Algorithm 905: SHEPPACK: Modified Shepard algorithm for
! interpolation of scattered multivariate data. ACM Trans. Math. Softw. (TOMS)
! 37.3 (2010): 34.
!
! This subroutine uses the private module variables and arrays LSHEP_D,
! LSHEP_P, LSHEP_N_PTS, LSHEP_XVALS, LSHEP_FVALS, LSHEP_A, LSHEP_DES_TOL,
! and LSHEP_RW, as set by the subroutine LSHEP_FIT.
!
! Also, this subroutine checks the taboo list
! LSHEP_TABOO(1:LSHEP_D,1:LSHEP_N_TABOO)
! for missing values.
!
!
! On input:
!
! C(:) is a real point in the design space.
!
!
! On output:
!
! V(:) is the objective value predicted at C(:), according to the LSHEP
!    surrogate functions.
!
! IERR is an integer error flag. Any nonzero value indicates an
!    illegal/missing value, as recorded in the taboo list LSHEP_TABOO.
!
USE LINEAR_SHEPARD_MOD
IMPLICIT NONE
! Parameters.
REAL(KIND=R8), INTENT(IN) :: C(:) ! Input point (from the design space).
REAL(KIND=R8), INTENT(OUT) :: V(:) ! Output point (from the objective space).
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Local variables.
INTEGER I ! Loop indexing variable.
REAL(KIND=R8) :: CL(SIZE(C,1)) ! Rescaled input point.
! BLAS function for Euclidean distance.
REAL(KIND=R8), EXTERNAL :: DNRM2
! Rescale the input point and store in CL(:).
CL(:) = (C(:)-LSHEP_SHIFT(:)) / LSHEP_SCALE(:)
! First check the taboo list.
DO I = 1, LSHEP_N_TABOO
   IF (DNRM2(LSHEP_D, CL(:) - LSHEP_TABOO(:,I), 1) < LSHEP_DES_TOL) THEN
      IERR = -1; RETURN; END IF
END DO
! Evaluate the surrogate models.
DO I = 1, LSHEP_P
   V(I) = LSHEPVAL( CL, LSHEP_D, LSHEP_N_PTS, LSHEP_XVALS, LSHEP_FVALS(:,I), &
                    LSHEP_A(:,:,I), LSHEP_RW(:,I), IERR )
   IF (IERR .GE. 10) RETURN
END DO
! Reset error flag to success code.
IERR = 0
RETURN
END SUBROUTINE LSHEP_EVAL

! The following is the optimization procedure. It is a lightweight native
! Fortran implementation of the polling algorithm generalized pattern search
! (GPS) as in the NOMAD software package (ACM TOMS Alg. 909).

SUBROUTINE GPS(D, X, LB, UB, OBJ_FUNC, BUDGET, TOL, IERR)
! This is a lightweight implementation of MADS designed for usage with
! computationally cheap surrogate functions, based on the algorithm GPS
! described in
!
! Le Digabel, Sébastien. Algorithm 909: NOMAD: Nonlinear Optimization with
! the MADS Algorithm. ACM Trans. Math. Softw. (TOMS) 37.4 (2011): 15.
!
! All features not relevant for local optimization of computationally cheap
! surrogates, such as quadratic surrogate models for poll ordering, the global
! search phase, the variable neighborhood search, and the taboo list are
! omitted.
!
!
! On input:
!
! D is the dimension of the design space.
!
! X(1:D) contains a design point from which to start the local optimization
!    procedure.
!
! LB(1:D) contains the lower bound constraints for the design space or the
!    current local trust region (LTR).
!
! UB(1:D) contains the upper bound constraints for the design space or the
!    current LTR.
!
! OBJ_FUNC is a subroutine, whose interface matches VTMOP_MOD_SCALAR_INT.
!    OBJ_FUNC returns a scalarization of the surrogate models. Any
!    missing/illegal values requested should trigger OBJ_FUNC to return
!    a nonzero error flag.
!
! BUDGET is the iteration budget for iterations of the algorithm GPS.
!
! TOL is the tolerance for the design space. Once the mesh fineness reaches
!    TOL the algorithm terminates, regardless of the value of BUDGET.
!
!
! On output:
!
! X(:) is a local minimizer of the scalarized surrogate functions, described
!    by OBJ_FUNC.
!
! IERR is an integer error flag.
!
!  00 : Normal output. Successfully converged on a local minimizer, or
!       BUDGET iterations of GPS.
!
!  1x : An illegal input was supplied.
!      10 : The problem dimensions D, P, or N contain illegal values.
!      11 : The dimension of the bound constraint arrays LB(:) or UB(:) do
!           not match the design dimension.
!      12 : LB(:) must be elementwise strictly less than UB(:) - TOL.
!      13 : X(:) must be a point in the specified bound constraints [LB, UB].
!
IMPLICIT NONE
! Parameter list.
INTEGER, INTENT(IN) :: D ! The dimension of the design space.
REAL(KIND=R8), INTENT(INOUT) :: X(:) ! The starting point for GPS.
REAL(KIND=R8), INTENT(IN) :: LB(:) ! The lower bound constraints.
REAL(KIND=R8), INTENT(IN) :: UB(:) ! The upper bound constraints.
PROCEDURE(VTMOP_MOD_SCALAR_INT) :: OBJ_FUNC ! The scalarized objective function.
INTEGER, INTENT(IN) :: BUDGET ! The iteration budget.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
REAL(KIND=R8), INTENT(IN) :: TOL ! The design space tolerance.
! Local variables.
INTEGER :: I, J ! Loop index variables.
INTEGER :: MIN_POLL ! Minimum poll index.
REAL(KIND=R8) :: X_VAL ! Current X value.
REAL(KIND=R8) :: POLLS(D,2*D) ! List of poll directions.
REAL(KIND=R8) :: POLL_VALS(2*D) ! List of poll values.
REAL(KIND=R8) :: MESH_GPS(D,2*D) ! The GPS mesh.
REAL(KIND=R8) :: MESH_SIZE ! The current mesh size.
REAL(KIND=R8) :: RESCALE(D) ! Rescale factors for bounding box.
! Check for bad inputs.
IF (SIZE(X, 1) .NE. D) THEN
   IERR = 10; RETURN; END IF
IF ( (SIZE(LB, 1) .NE. D) .OR. (SIZE(UB,1) .NE. D) ) THEN
   IERR = 11; RETURN; END IF
IF ( ANY(LB(:) .GE. UB(:) - TOL) ) THEN
   IERR = 12; RETURN; END IF
IF ( ANY(X(:) .GE. UB(:) + TOL) .OR. ANY(X(:) .LE. LB(:) - TOL) ) THEN
   IERR = 13; RETURN; END IF
! Initialize the mesh fineness and rescale factors.
RESCALE(:) = (UB(:) - LB(:)) / 2.0_R8
MESH_SIZE = 1.0_R8
! Generate the GPS mesh.
DO I = 1, D
   MESH_GPS(:,2*I-1) = 0.0_R8
   MESH_GPS(I,2*I-1) = 1.0_R8
   MESH_GPS(:,2*I) = 0.0_R8
   MESH_GPS(I,2*I) = -1.0_R8
END DO
! Initialize the center value.
X_VAL = OBJ_FUNC(X, IERR)
! Avoid missing values.
IF (IERR .NE. 0) THEN
   X_VAL = HUGE(0.0_R8)
   IERR = 0
END IF
! Loop until the iteration budget is exhausted.
DO I = 1, BUDGET ! Stopping condition 1: budget exhausted.
   DO J = 1, 2*D
      ! Get the next poll point.
      POLLS(:,J) = X(:) + (MESH_GPS(:,J) * RESCALE(:) * MESH_SIZE)
      ! Now predict the objective value for the poll.
      IF ( ANY(POLLS(:,J) > UB(:)) .OR. &
           ANY(POLLS(:,J) < LB(:)) ) THEN
         ! Use an extreme barrier approach for bound violations.
         POLL_VALS(J) = HUGE(0.0_R8)
      ELSE
         ! For legal values, query the objective surrogate.
         POLL_VALS(J) = OBJ_FUNC(POLLS(:,J), IERR)
         ! Avoid missing values.
         IF (IERR .NE. 0) THEN
            X_VAL = HUGE(0.0_R8)
            IERR = 0
         END IF
      END IF
   END DO
   ! Check all poll directions for the best result.
   MIN_POLL = MINLOC(POLL_VALS, 1)
   IF (POLL_VALS(MIN_POLL) < X_VAL) THEN
      ! If the result is an improvement, then move to the new poll location.
      X(:) = POLLS(:,MIN_POLL)
      X_VAL = POLL_VALS(MIN_POLL)
   ELSE
      ! Otherwise, decay the mesh size.
      MESH_SIZE = MESH_SIZE * 0.5_R8
      ! If the mesh size has reached its limit, then exit.
      IF (MESH_SIZE < TOL) EXIT ! Stop cond 2: mesh tolerance reached.
   END IF
END DO
RETURN
END SUBROUTINE GPS

! The following are possible global search options. LH_DESIGN returns a
! batch of design points to evaluate.

SUBROUTINE LH_DESIGN(D, LB, UB, N_PTS, CAND_PTS, IERR, TOL, XI)
! This wrapper generates a Latin hypercube design of experiment using the
! QNSTOP subroutine LATINDESIGN, as implemented in
!
! Amos, B. D., D. R. Easterling, L. T. Watson, W. I. Thacker, B. S. Castle,
! and M. W. Trosset. Algorithm XXX: QNSTOP -- Quasi-Newton Algorithm for
! Stochastic Optimization. Tech Report. Virginia Polytechnic Institute and
! State University (2014).
!
! This design can be used to perform an exploration of the entire design
! space, or the current local trust region (LTR).
!
!
! On input:
!
! D is the dimension of the design space.
!
! LB(1:D) contains the lower bound constraints for the design space or the
!    current LTR.
!
! UB(1:D) contains the upper bound constraints for the design space or the
!    current LTR.
!
! N_PTS is an integer specifying the size of the requested design.
!
!
! On output:
!
! CAND_PTS(:,:) is a real allocatable array. On output, CAND_PTS(:,:)
!    is allocated to size D by N_PTS, and contains a Latin hypercube design.
!
! IERR is an integer error flag, which relays error messages from
!    VTdirect.
!
!  00 : Normal output. VTdirect has successfully run for MAXITERS iterations,
!       or until some other termination condition, for each of the weightings
!       in the ADAPTIVE_WEIGHTS(:,:) array.
!
!  1x : Input data error.
!     10 : D does not match the size of LB(:) or UB(:).
!     11 : LB(:) must be componentwise less than UB(:) - TOL.
!     12 : When present, the size of XI(:) must match with D.
!     13 : When present, XI(:) must be within the bound constraints [LB, UB].
!  20 : A memory allocation error has occurred.
!
!
! Optional input arguments:
!
! TOL is the tolerance for the design space. This value is only used for
!    sanity checks. By default, TOL is the square-root of the machine
!    epsilon.
!
! XI(1:D) is an initial point in the design space, to include in the Latin
!    hypercube design. When supplied, N_PTS additional points are generated,
!    with the understanding that XI has already been evaluated.
!
USE QNSTOPS_MOD, ONLY : LATINDESIGN
IMPLICIT NONE
! Parameter list.
INTEGER, INTENT(IN) :: D ! The dimension of the design space.
REAL(KIND=R8), INTENT(IN) :: LB(:), UB(:) ! Lower and upper bound constraints.
INTEGER, INTENT(IN) :: N_PTS ! Number of points in the design.
REAL(KIND=R8), ALLOCATABLE, INTENT(OUT) :: CAND_PTS(:,:) ! The output design.
INTEGER, INTENT(OUT) :: IERR ! Error flag.
! Optional Parameters.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: TOL ! Design space tolerance.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: XI(:) ! An initial design point.
! Local variables.
REAL(KIND=R8) :: DES_PTS(D,N_PTS+1) ! Set of new candidate points.
REAL(KIND=R8) :: TOL_L ! Local copy of the tolerance.
REAL(KIND=R8) :: XIL(D) ! Local copy of initial point.
! Check for bad input dimensions.
IF (SIZE(LB,1) .NE. D .OR. SIZE(UB,1) .NE. D) THEN
   IERR = 10; RETURN; END IF
! Get optional inputs.
TOL_L = SQRT(EPSILON(0.0_R8))
IF (PRESENT(TOL)) THEN
   IF (TOL > TOL_L) TOL_L = TOL
END IF
! Check that the bounds are appropriate.
IF (ANY(UB(:) - LB(:) < TOL_L)) THEN
   IERR = 11; RETURN; END IF
! Different rules depending on whether an initial point is supplied.
IF (PRESENT(XI)) THEN
   ! Check that XI is of the correct dimension.
   IF (SIZE(XI,1) .NE. D) THEN
      IERR = 12; RETURN; END IF
   ! Check that XI is within the bounds.
   IF (ANY(XI(:) > UB(:) + TOL_L) .OR. ANY(XI(:) < LB(:) - TOL_L)) THEN
      IERR = 13; RETURN; END IF
   ! Create a design with N_PTS+1 points, so that XI(:) is included in the
   ! design but N_PTS new points are generated.
   IF (N_PTS > 0) THEN
      CALL LATINDESIGN(D, N_PTS+1, LB, UB, XI, DES_PTS)
   ELSE
      DES_PTS(1:D,1) = XI(:)
   END IF
ELSE
   ! Otherwise, randomly generate XIL.
   CALL RANDOM_NUMBER(XIL(:))
   ! Rescale to bounds.
   XIL(:) = XIL(:) * (UB(:) - LB(:)) + LB(:)
   ! Create a design with N_PTS points.
   IF (N_PTS > 1) THEN
      CALL LATINDESIGN(D, N_PTS, LB, UB, XIL, DES_PTS(1:D,1:N_PTS))
   ELSE
      DES_PTS(1:D,1) = XIL(:)
   END IF
END IF
! Allocate the output array.
ALLOCATE(CAND_PTS(D,N_PTS), STAT=IERR)
IF (IERR .NE. 0) THEN
   IERR = 20; RETURN; END IF
! Copy the points into the output array.
CAND_PTS(:,:) = DES_PTS(:,1:N_PTS)
RETURN
END SUBROUTINE LH_DESIGN

END MODULE VTMOP_MOD

! The subroutine DELAUNAYGRAPH is an external procedure, as it may be of
! interest independently.

SUBROUTINE DELAUNAYGRAPH(D, N, PTS, GRAPH, IERR, EPS, IBUDGET, PMODE)
! This subroutine produces the Delaunay graph for a set of N points in R^D
! in polynomial time using DELAUNAYSPARSE. If DELAUNAYSPARSE reports that PTS
! is embedded in a lower-dimensional linear manifold (error code 31), then
! PTS is projected onto the span of its left singular vectors with nonzero
! singular values (i.e., principle component analysis).
!
!
! On input:
!
! D is the dimension of the space for PTS.
!
! N is the number of data points in PTS.
!
! PTS(1:D,1:N) is a real matrix with N columns, each containing the
!    coordinates of a single data point in R^D.
!
!
! On output:
!
! PTS has been rescaled and shifted. All the data points in PTS are now
!    contained in the unit hyperball in R^D.
!
! GRAPH(1:N,1:N) is a symmetric matrix of type LOGICAL containing the
!    Delaunay graph structure. If GRAPH(I,J) is .TRUE., then the vertices
!    PTS(:,I) and PTS(:,J) are Delaunay neighbors in some Delaunay
!    triangulation. Otherwise, if GRAPH(I,J) is .FALSE., then PTS(:,I) and
!    PTS(:,J) are not neighbors in some Delaunay triangulation.
!
! IERR is an integer error flag. For the most part, IERR relays
!    error codes from DELAUNAYSPARSE{S|P}.
!    The error codes are:
!
! 00 : Successfully interpolated all midpoints and constructed the Delaunay
!      graph structure.
! 01 : Too few points were provided to compute a complete triangulation.
!      The Delaunay graph was still computed, under the assumption that
!      all points are Delaunay neighbors.
! 02 : The input set PTS is embedded in a lower dimensional linear manifold.
!      The Delaunay graph was still computed for a dimension reduced copy of
!      PTS.
!
! 10 : The dimension D must be positive.
! 12 : The supplied LOGICAL matrix GRAPH(:,:) is not of dimension N x N.
! 13 : The first dimension of PTS does not agree with the dimension D.
! 14 : The second dimension of PTS does not agree with the number of points N.
!
! 26 : The budget supplied in IBUDGET does not contain a positive
!      integer.
!
! 30 : Two or more points in the data set PTS are too close together with
!      respect to the working precision (EPS), which would result in a
!      numerically degenerate simplex.
!
! 40 : An error caused DELAUNAYSPARSE to terminate before the entire
!      Delaunay graph could be computed.
!
! 50 : A memory allocation error occurred while allocating the internal
!      work array for DELAUNAYSPARSE.
! 51 : A memory allocation error occurred while allocating the work arrays
!      for DGESVD, for performing dimension reduction.
! 52 : A memory deallocation error occurred while freeing work arrays for
!      DGESVD.
!
! 60 : The budget was exceeded before the algorithm converged for at least
!      one of the simplices. If the dimension is high, try increasing IBUDGET.
!      This error can also be caused by a working precision EPS that is too
!      small for the conditioning of the problem.
!
! 61 : A value that was judged appropriate later caused LAPACK to encounter a
!      singularity. Try increasing the value of EPS.
!
! 70 : Allocation error for the extrapolation work arrays.
! 71 : The SLATEC subroutine DWNNLS failed to converge during the projection
!      of an extrapolation point onto the convex hull.
! 72 : The SLATEC subroutine DWNNLS has reported a usage error.
! 73 : At least one of the midpoints was ruled significantly outside the
!      convex hull of PTS by DELAUNAYSPARSE. This is a numerical precision
!      issue that should never occur. Consider increasing EPS.
!
!      The errors 72, 80--83, and 90 should never occur, and likely indicate
!      a compiler bug or hardware failure.
! 80 : The LAPACK subroutine DGEQP3 has reported an illegal value.
! 81 : The LAPACK subroutine DGETRF has reported an illegal value.
! 82 : The LAPACK subroutine DGETRS has reported an illegal value.
! 83 : The LAPACK subroutine DORMQR has reported an illegal value.
!
! 90 : The LAPACK subroutine DGESVD has reported an illegal value.
! 91 : The LAPACK subroutine DGESVD has failed to converge.
!
!
! Optional arguments:
!
! EPS contains the working precision for the problem on input. By default,
!    EPS is assigned \sqrt{\mu} where \mu denotes the unit roundoff for the
!    machine. In general, any values that differ by less than EPS are judged
!    as equal, and any weights that are greater than -EPS are judged as
!    nonnegative.  EPS cannot take a value less than the default value of
!    \sqrt{\mu}. If any value less than \sqrt{\mu} is supplied, the default
!    value will be used instead automatically.
!
! IBUDGET contains the integer budget for performing flips while
!    iterating toward the simplex containing each interpolation point in Q.
!    This prevents DelaunayFan from falling into an infinite loop when
!    supplied with degenerate or near degenerate data.  By default,
!    IBUDGET=50000. However, for extremely high-dimensional problems and
!    pathological data sets, the default value may be insufficient.
!
! PMODE is a logical value specifying whether to compute the Delaunay graph
!    serially (using DELAUNAYSPARSES) or in parallel (using DELAUNAYSPARSEP).
!
USE DELSPARSE_MOD
IMPLICIT NONE

! Input arguments.
INTEGER, INTENT(IN) :: D, N
REAL(KIND=R8), INTENT(INOUT) :: PTS(:,:)
! Output arguments.
LOGICAL, INTENT(OUT) :: GRAPH(:,:)
INTEGER, INTENT(OUT) :: IERR
! Optional arguments.
REAL(KIND=R8), OPTIONAL, INTENT(IN) :: EPS
INTEGER, OPTIONAL, INTENT(IN) :: IBUDGET
LOGICAL, OPTIONAL, INTENT(IN) :: PMODE

! Local variables.
INTEGER :: IBUDGETL ! Local copy of IBUDGET.
INTEGER :: I, J, K ! Loop iteration variables.
INTEGER :: SIMPS(D+1,N*(N-1)/2) ! Matrix of simplices.
INTEGER :: IERR_LIST(N*(N-1)/2) ! Array of error codes for DELAUNAYSPARSE.
LOGICAL :: PMODEL ! Local copy of PMODE.
REAL(KIND=R8) :: EPSL ! Local copy of EPS.
REAL(KIND=R8) :: WEIGHTS(D+1,N*(N-1)/2) ! Matrix of interpolation weights.
REAL(KIND=R8) :: Q(D,N*(N-1)/2) ! Matrix of interpolation points.

! Work arrays for DGESVD, only referenced if dimension reduction is required.
INTEGER :: LWORK ! Length of the work array.
REAL(KIND=R8), ALLOCATABLE :: LSV(:,:) ! Left singular vectors.
REAL(KIND=R8), ALLOCATABLE :: RED_PTS(:,:) ! Dimension reduced PTS.
REAL(KIND=R8), ALLOCATABLE :: RED_Q(:,:) ! Dimension reduced Q.
REAL(KIND=R8), ALLOCATABLE :: S(:) ! Singular values.
REAL(KIND=R8), ALLOCATABLE :: WORK(:) ! Work array.
REAL(KIND=R8) :: U(1), VT(1) ! Optional outputs, not referenced by DGESVD.

! Check whether GRAPH is a legal size.
IF (SIZE(GRAPH, 1) .NE. N .OR. SIZE(GRAPH, 2) .NE. N) THEN
   IERR = 12
   RETURN
END IF
! Compute the machine precision.
EPSL = SQRT(EPSILON(1.0_R8))
! Check for the optional value EPS, and ensure that EPS is large enough.
IF (PRESENT(EPS)) THEN
   IF(EPSL < EPS) EPSL = EPS
END IF
! Set the budget.
IBUDGETL = 50000
! Check for the optional input IBUDGET, and ensure that it is valid.
IF (PRESENT(IBUDGET)) THEN
   IF (IBUDGET < 1) THEN; IERR = 26; RETURN; END IF
   IBUDGETL = IBUDGET
END IF
! Get optional input PMODE.
PMODEL = .FALSE.
IF (PRESENT(PMODE)) PMODEL = PMODE

! Initialize the interpolation points.
K = 0
DO I = 1, N
   DO J = I+1, N
      ! Interpolate the midpoint between PTS(:,I) and PTS(:,J).
      Q(:,K+J-I) = (PTS(:,I) + PTS(:,J)) / 2.0_R8
   END DO
   ! Track the offset K.
   K = K + N - I
END DO

! Check whether iteration parallelism is turned on.
IF(PMODEL) THEN
   ! Compute the Delaunay simplices containing the midpoints in parallel.
   CALL DELAUNAYSPARSEP( D, N, PTS, N*(N-1)/2, Q, SIMPS, WEIGHTS, IERR_LIST, &
                         EPS=EPSL, IBUDGET=IBUDGETL, EXACT=.FALSE., PMODE=1 )
ELSE
   ! Compute the Delaunay simplices containing the midpoints serially.
   CALL DELAUNAYSPARSES( D, N, PTS, N*(N-1)/2, Q, SIMPS, WEIGHTS, IERR_LIST, &
                         EPS=EPSL, IBUDGET=IBUDGETL, EXACT=.FALSE. )
END IF

! Check for errors.
IERR = 0
DO I = 1, N*(N-1)/2
   IF(IERR_LIST(I) > 2) THEN
      IERR = IERR_LIST(I) ! Pass the error code on.
   ELSE IF(IERR_LIST(I) .EQ. 2) THEN
      IERR = 73; END IF ! Error code 2 -> 73.
END DO

! Handle relevant error codes for DELAUNAYGRAPH.
IF (IERR .EQ. 11) THEN
   ! N is too small to triangulate PTS, so all PTS are considered neighbors.
   GRAPH(:,:) = .TRUE.
   FORALL ( I = 1 : N ) GRAPH(I,I) = .FALSE.
   IERR = 1
ELSE IF (IERR .EQ. 31) THEN
   ! PTS lie in a lower dimensional linear manifold. Reduce the dimension
   ! and retry the triangulation.

   ! Allocate the left singular vectors and singular values.
   ALLOCATE(LSV(D,N), S(D), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 51; RETURN; END IF
   ! Query the optimal size for WORK and store in LWORK.
   LWORK = -1
   CALL DGESVD('O', 'N', D, N, LSV, D, S, VT, 1, VT, 1, U, LWORK, IERR)
   IF (IERR < 0) THEN
      IERR = 90; RETURN
   ELSE IF (IERR > 0) THEN
      IERR = 91; RETURN; END IF
   LWORK = INT(U(1))
   ! Allocate the input/output matrix.
   ALLOCATE(WORK(LWORK), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 51; RETURN; END IF
   ! Copy the input array.
   LSV(:,:) = PTS(:,:)
   ! Compute the SVD and overwrite LSV with the left singular vectors.
   ! The dummy arguments U and VT are not referenced for these settings.
   CALL DGESVD('O', 'N', D, N, LSV, D, S, U, 1, VT, 1, WORK, LWORK, IERR)
   IF (IERR < 0) THEN
      IERR = 90; RETURN
   ELSE IF (IERR > 0) THEN
      IERR = 91; RETURN; END IF
   ! Perform the dimension reduction by eliminating directions with small
   ! singular values.
   DO I = 1, D; IF (S(I) < EPSL) EXIT; END DO
   I = I - 1
   ! Free the memory that was used for the SVD.
   DEALLOCATE(S, WORK, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 52; RETURN; END IF
   ! Allocate and initialize the reduced data and interpolation point sets.
   ALLOCATE(RED_PTS(I,N), RED_Q(I,N*(N-1)/2), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 51; RETURN; END IF
   RED_PTS(:,:) = 0.0_R8
   RED_Q(:,:) = 0.0_R8
   ! Compute the projection RED_PTS(1:I,1:N) = LSV(1:D,1:I)^T PTS(1:D,1:N).
   CALL DGEMM('T', 'N', I, N, D, 1.0_R8, LSV, D, PTS, D, 0.0_R8, RED_PTS, I)
   ! Compute the projection RED_Q(1:I,1:N) = LSV(1:D,1:I)^T Q(1:D,:)
   CALL DGEMM('T', 'N', I, N*(N-1)/2, D, 1.0_R8, LSV, D, Q, D, 0.0_R8, RED_Q, I)
   ! Check whether iteration tasks are parallelized.
   IF (PMODEL) THEN
      ! Compute the reduced dimensional solution, using DELAUNAYSPARSEP.
      CALL DELAUNAYSPARSEP( I, N, RED_PTS, N*(N-1)/2, RED_Q, SIMPS(1:I+1,:), &
                            WEIGHTS(1:I+1,:), IERR_LIST, EPS=EPSL,           &
                            IBUDGET=IBUDGETL, EXACT=.FALSE., PMODE=1 )
   ELSE
      ! Compute the reduced dimensional solution, using DELAUNAYSPARSES.
      CALL DELAUNAYSPARSES( I, N, RED_PTS, N*(N-1)/2, RED_Q, SIMPS(1:I+1,:), &
                            WEIGHTS(1:I+1,:), IERR_LIST, EPS=EPSL,           &
                            IBUDGET=IBUDGETL, EXACT=.FALSE. )
   END IF
   SIMPS(I+2:D+1,:) = 0
   ! Check for errors.
   IERR = 2
   DO I = 1, N
      IF(IERR_LIST(I) > 2) THEN
         IERR = IERR_LIST(I) ! Pass the error code on.
      ELSE IF(IERR_LIST(I) .EQ. 2) THEN
         IERR = 73; END IF ! Error code 2 -> 73.
   END DO

   ! Free the temporary data matrices used for dimension reduction.
   DEALLOCATE(RED_PTS, RED_Q, LSV, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 52; RETURN; END IF
END IF

! If an error code persists, quit.
IF (IERR .GE. 10) RETURN

! Initialize the Delaunay graph.
GRAPH(:,:) = .FALSE.
! Construct the Delaunay graph from the resulting simplices.
K = 0
DO I = 1, N
   DO J = I+1, N
      ! Check SIMPS(:,K+J-I) for any edge between PTS(:,I) and PTS(:,J).
      IF (ANY(SIMPS(:,K+J-I) .EQ. I) .AND. ANY(SIMPS(:,K+J-I) .EQ. J)) THEN
         GRAPH(I,J) = .TRUE.; GRAPH(J,I) = .TRUE.;  END IF

      ! If SIMPS(:,K+J-I) does not contain the edge ( PTS(:,I), PTS(:,J) ),
      ! then SIMPS(:,K+J-I) serves as a certificate of separation in some
      ! Delaunay triangulation of PTS.
   END DO
   ! Track the offset K.
   K = K + N - I
END DO

RETURN
END SUBROUTINE DELAUNAYGRAPH

! The subroutine QSORTC_DVEC is an external procedure, as it may be of
! interest independently.

SUBROUTINE QSORTC_DVEC(A, IDX)
! This is a QuickSort routine adapted from QNSTOP adapted from Orderpack 2.0.
!
! Also, this implementation incorporates ideas from "A Practical Introduction
! to Data Structures and Algorithm Analysis", by Clifford Shaffer.
!
! It sorts real vectors into ascending numerical order by their sums
! and keeps an index of the value's original array position.
!
! Author: Will Thacker, Winthrop University, July 2013.
! Update: Tyler Chang, Argonne National Lab, Jan 2021 (sort by column sum).
!
! QSORTC_DVEC sorts the real 2D array A by its column sum and keeps the index
! of the value's original array position along with the value (integer array
! IDX).
!
! On input:
!
! A(:,:) is the array to be sorted by column sum.
!
! On output:
!
! A(:,:) is sorted by column sum.
!
! IDX(1:SIZEOF(A,2)) contains the original positions of the sorted values.
!    I.e., sorted(i) = orginal_unsorted(IDX(i)).
!
USE REAL_PRECISION, ONLY : R8
IMPLICIT NONE

! Input/output parameters.
REAL(KIND=R8), INTENT(INOUT) :: A(:,:)
INTEGER, INTENT(OUT) :: IDX(SIZE(A,2))

! Local variables
INTEGER :: I   ! Loop iteration variable.

! Initialize the array of original positions.
FORALL (I=1:SIZE(A,2)) IDX(I)=I

CALL QSORTC_DVEC_HELPER(A, IDX, 1, SIZE(A,2))
RETURN

CONTAINS

RECURSIVE SUBROUTINE QSORTC_DVEC_HELPER(A, IDX, ISTART, ISTOP)
! This internal recursive subroutine performs the recursive quicksort
! algorithm.  It is needed because the boundaries of the part of the
! array being sorted change and the initial call to the sort routine
! does not need to specify boundaries since, generally, the user will
! want to sort the entire array passed.
!
! On input:
!
! A(:,:) contains a subset of columns to be sorted.
!
! IDX(i) contains the initial position of the value A(:,i) before sorting.
!
! ISTART is the starting position of the subarray to be sorted.
!
! ISTOP is the ending position of the subarray to be sorted.
!
! On output:
!
! A(:,ISTART:ISTOP) will be sorted by column sum.
!
! IDX(i) contains the original position for the value at A(:,i).
!

! Input/output parameters
REAL(KIND=R8), INTENT(INOUT) :: A(:,:)
INTEGER, INTENT(INOUT) :: IDX(SIZE(A,2))
INTEGER, INTENT(IN) :: ISTART, ISTOP

!  Local variables
INTEGER :: ILEFT ! A position on the left to be swapped with value at IRIGHT.
INTEGER :: IMID ! The middle position used to select the pivot.
INTEGER :: IRIGHT ! A position on the right to be swapped with value at ILEFT.
INTEGER :: ITEMP  ! Used for swapping within IDX.
REAL(KIND=R8) :: ATEMP(SIZE(A,1)) ! Used for swapping.
REAL(KIND=R8) :: PIVOT(SIZE(A,1)) ! Holds the temporary pivot.

! INSMAX is used to stop recursively dividing the array and to instead
! use a sort that is more efficient for small arrays than quicksort.
!
! The best cutoff point is system dependent.
INTEGER, PARAMETER:: INSMAX=24

! Check to see if we have enough values to make quicksort useful.
! Otherwise let the insertion sort handle it.
IF ((ISTOP - ISTART) < INSMAX) THEN
  CALL INSERTION_DVEC(A, IDX, ISTART, ISTOP)
ELSE

   ! Use the median of the first, middle and last items for the pivot
   ! and place the median (pivot) at the end of the list.
   ! Putting it at the end of the list allows for a guard value to keep
   ! the loop from falling off the right end of the array (no need to
   ! check for at the end of the subarray EACH time through the loop).
   IMID = (ISTART + ISTOP)/2

   IF (SUM(A(:,ISTOP)) < SUM(A(:,ISTART))) THEN
      ATEMP(:) = A(:,ISTART)
      A(:,ISTART) = A(:,ISTOP)
      A(:,ISTOP) = ATEMP(:)

      ITEMP = IDX(ISTART)
      IDX(ISTART) = IDX(ISTOP)
      IDX(ISTOP) = ITEMP
   END IF

   IF (SUM(A(:,IMID)) < SUM(A(:,ISTOP))) THEN
      ATEMP(:) = A(:,ISTOP)
      A(:,ISTOP) = A(:,IMID)
      A(:,IMID) = ATEMP(:)

      ITEMP = IDX(ISTOP)
      IDX(ISTOP) = IDX(IMID)
      IDX(IMID) = ITEMP

      IF (SUM(A(:,ISTOP)) < SUM(A(:,ISTART))) THEN
         ATEMP(:) = A(:,ISTOP)
         A(:,ISTOP) = A(:,ISTART)
         A(:,ISTART) = ATEMP(:)

         ITEMP = IDX(ISTOP)
         IDX(ISTOP) = IDX(ISTART)
         IDX(ISTART) = ITEMP
      END IF
   END IF

   ! Now, the first position has a value that is less or equal to the
   ! partition. So, we know it belongs in the left side of the partition
   ! and we can skip it. Also, the pivot is at the end.  So, there is
   ! no need to compare the pivot with itself.
   PIVOT(:) = A(:,ISTOP)
   ILEFT = ISTART + 1
   IRIGHT = ISTOP - 1

   DO WHILE (ILEFT < IRIGHT)
      ! Find a value in the left side that is bigger than the pivot value.
      ! Pivot is at the right end so ILEFT will not fall off the end
      ! of the subarray.
      DO WHILE (SUM(A(:,ILEFT)) < SUM(PIVOT(:)))
         ILEFT = ILEFT + 1
      END DO

      DO WHILE (IRIGHT .NE. ILEFT)
         IF (SUM(A(:,IRIGHT)) .LT. SUM(PIVOT(:))) EXIT
            IRIGHT = IRIGHT - 1
      END DO

      ! Now we have a value bigger than pivot value on the left side that can
      ! be swapped with a value smaller than the pivot on the right side.
      !
      ! This gives us all values less than pivot on the left side of the
      ! array and all values greater than the pivot on the right side.
      ATEMP(:) = A(:,IRIGHT)
      A(:,IRIGHT) = A(:,ILEFT)
      A(:,ILEFT) = ATEMP(:)

      ITEMP = IDX(IRIGHT)
      IDX(IRIGHT) = IDX(ILEFT)
      IDX(ILEFT) = ITEMP

   END DO
   !
   ! The last swap was in error (since the while condition is not checked
   ! until after the swap is done) so we swap again to fix it.
   !
   ! This is done (once) rather than having an if (done many times) in the
   ! loop to prevent the swapping.
   ATEMP(:) = A(:,IRIGHT)
   A(:,IRIGHT) = A(:,ILEFT)
   A(:,ILEFT) = ATEMP(:)

   ITEMP = IDX(IRIGHT)
   IDX(IRIGHT) = IDX(ILEFT)
   IDX(ILEFT) = ITEMP

   ! Put the pivot value in its correct spot (between the 2 partitions)
   ! When the WHILE condition finishes, ILEFT is greater than IRIGHT.
   ! So, ILEFT has the position of the first value in the right side.
   ! This is where we can put the pivot (and where it will finally rest,
   ! so no need to look at it again).  Also, place the first value of
   ! the right side (being displaced by the pivot) at the end of the
   ! subarray (since it is bigger than the pivot).
   ATEMP(:) = A(:,ISTOP)
   A(:,ISTOP) = A(:,ILEFT)
   A(:,ILEFT) = ATEMP(:)

   ITEMP = IDX(ISTOP)
   IDX(ISTOP) = IDX(ILEFT)
   IDX(ILEFT) = ITEMP

   CALL QSORTC_DVEC_HELPER(A, IDX, ISTART, ILEFT-1)
   CALL QSORTC_DVEC_HELPER(A, IDX, ILEFT+1, ISTOP)
END IF
RETURN
END SUBROUTINE QSORTC_DVEC_HELPER

SUBROUTINE INSERTION_DVEC(A, IDX, ISTART, ISTOP)
! This subroutine performs an insertion sort used for sorting
! small subarrays efficiently.
!
! This subroutine sorts a subarray of A by column sum (between positions
! ISTART and ISTOP) keeping a record of the original position (array IDX).
!
! On input:
!
! A(:,:) contains a subset of columns to be sorted.
!
! IDX(i) contains the initial position of the value A(:,i) before sorting.
!
! ISTART is the starting position of the subarray to be sorted.
!
! ISTOP is the ending position of the subarray to be sorted.
!
! On output:
!
! A(:,ISTART:ISTOP) will be sorted by column sum.
!
! IDX(i) contains the original position for the value at A(:,i).
!

! Input/output parameters.
REAL(KIND=R8), INTENT(INOUT) :: A(:,:)
INTEGER, INTENT(INOUT) :: IDX(SIZE(A,2))
INTEGER, INTENT(IN) :: ISTART, ISTOP

! Local variables.
REAL(KIND=R8) :: AMIN(SIZE(A,1))  ! Temporary minimum.
REAL(KIND=R8) :: ATEMP(SIZE(A,1))  ! The value to be inserted.
INTEGER :: I    ! Index variable.
INTEGER :: IABOVE ! Index to find insertion point.
INTEGER :: IMIN ! Temporary minimum position.
INTEGER :: ITEMP ! Temporary for swapping.

IF (ISTOP .EQ. ISTART) THEN
   RETURN
END IF

! Find the smallest and put it at the top as a "guard" so there is
! no need for the DO WHILE to check if it is going past the top.
AMIN(:) = A(:,ISTART)
IMIN = ISTART

DO I=ISTOP,ISTART+1,-1
   IF (SUM(A(:,I)) < SUM(AMIN(:))) THEN
      AMIN(:) = A(:,I)
      IMIN = I
   END IF
END DO

A(:,IMIN) = A(:,ISTART)
A(:,ISTART) = AMIN(:)

ITEMP = IDX(ISTART)
IDX(ISTART) = IDX(IMIN)
IDX(IMIN) = ITEMP

! Insertion sort the rest of the array.
DO I=ISTART+2,ISTOP
   ATEMP(:) = A(:,I)
   ITEMP = IDX(I)
   IABOVE = I - 1
   IF (SUM(ATEMP(:)) < SUM(A(:,IABOVE))) THEN
      A(:,I) = A(:,IABOVE)
      IDX(I) = IDX(IABOVE)
      IABOVE = IABOVE - 1

      ! Stop moving items down when the position for "insertion" is found.
      !
      ! Do not have to check for "falling off" the beginning of the
      ! array since the smallest value is a guard value in the first position.

      DO WHILE (SUM(ATEMP(:)) < SUM(A(:,IABOVE)))
         A(:,IABOVE+1) = A(:,IABOVE)
         IDX(IABOVE+1) = IDX(IABOVE)
         IABOVE = IABOVE - 1
      END DO
   END IF
   A(:,IABOVE+1) = ATEMP(:)
   IDX(IABOVE+1) = ITEMP
END DO
RETURN
END SUBROUTINE INSERTION_DVEC

END SUBROUTINE QSORTC_DVEC

! This automatically generated Fortran wrapper file allows codes
! written in Fortran to be called directly from C and translates all
! C-style arguments into expected Fortran-style arguments (with
! assumed size, local type declarations, etc.).


MODULE C_VTMOP_LIBE_MOD
  IMPLICIT NONE


CONTAINS



  SUBROUTINE C_VTMOP_LIBE_INIT(D, P, LB_DIM_1, LB, UB_DIM_1, UB, IERR, LOPT_BUDGET, DECAY, DES_TOL, EPS, EPSW, OBJ_TOL, MIN_RADF, T&
&RUST_RADF, OBJ_BOUNDS_DIM_1, OBJ_BOUNDS_DIM_2, OBJ_BOUNDS, PMODE) BIND(C)
    USE VTMOP_MOD
    USE ISO_FORTRAN_ENV
    USE VTMOP_LIBE_MOD, ONLY: VTMOP_LIBE_INIT
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: D
    INTEGER, INTENT(IN) :: P
    INTEGER, INTENT(IN) :: LB_DIM_1
    REAL(KIND=R8), INTENT(IN), DIMENSION(LB_DIM_1) :: LB
    INTEGER, INTENT(IN) :: UB_DIM_1
    REAL(KIND=R8), INTENT(IN), DIMENSION(UB_DIM_1) :: UB
    INTEGER, INTENT(OUT) :: IERR
    INTEGER, INTENT(IN) :: LOPT_BUDGET
    REAL(KIND=R8), INTENT(IN) :: DECAY
    REAL(KIND=R8), INTENT(IN) :: DES_TOL
    REAL(KIND=R8), INTENT(IN) :: EPS
    REAL(KIND=R8), INTENT(IN) :: EPSW
    REAL(KIND=R8), INTENT(IN) :: OBJ_TOL
    REAL(KIND=R8), INTENT(IN) :: MIN_RADF
    REAL(KIND=R8), INTENT(IN) :: TRUST_RADF
    INTEGER, INTENT(IN) :: OBJ_BOUNDS_DIM_1
    INTEGER, INTENT(IN) :: OBJ_BOUNDS_DIM_2
    REAL(KIND=R8), INTENT(IN), DIMENSION(OBJ_BOUNDS_DIM_1,OBJ_BOUNDS_DIM_2) :: OBJ_BOUNDS
    LOGICAL, INTENT(IN) :: PMODE

    CALL VTMOP_LIBE_INIT(D, P, LB, UB, IERR, LOPT_BUDGET, DECAY, DES_TOL, EPS, EPSW, OBJ_TOL, MIN_RADF, TRUST_RADF, OBJ_BOUNDS, PMO&
&DE)
  END SUBROUTINE C_VTMOP_LIBE_INIT



  SUBROUTINE C_VTMOP_LIBE_GENERATE(D, P, LB_DIM_1, LB, UB_DIM_1, UB, DES_PTS_DIM_1, DES_PTS_DIM_2, DES_PTS, OBJ_PTS_DIM_1, OBJ_PTS_&
&DIM_2, OBJ_PTS, ISNB, SNB, ONB, OBJ_BOUNDS_DIM_1, OBJ_BOUNDS_DIM_2, OBJ_BOUNDS, LBATCH, BATCHX_DIM_1, BATCHX_DIM_2, BATCHX, IERR) &
&BIND(C)
    USE VTMOP_MOD
    USE ISO_FORTRAN_ENV
    USE ISO_FORTRAN_ENV, ONLY: INT64
    USE VTMOP_LIBE_MOD, ONLY: VTMOP_LIBE_GENERATE
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: D
    INTEGER, INTENT(IN) :: P
    INTEGER, INTENT(IN) :: LB_DIM_1
    REAL(KIND=R8), INTENT(IN), DIMENSION(LB_DIM_1) :: LB
    INTEGER, INTENT(IN) :: UB_DIM_1
    REAL(KIND=R8), INTENT(IN), DIMENSION(UB_DIM_1) :: UB
    INTEGER, INTENT(IN) :: DES_PTS_DIM_1
    INTEGER, INTENT(IN) :: DES_PTS_DIM_2
    REAL(KIND=R8), INTENT(IN), DIMENSION(DES_PTS_DIM_1,DES_PTS_DIM_2) :: DES_PTS
    INTEGER, INTENT(IN) :: OBJ_PTS_DIM_1
    INTEGER, INTENT(IN) :: OBJ_PTS_DIM_2
    REAL(KIND=R8), INTENT(IN), DIMENSION(OBJ_PTS_DIM_1,OBJ_PTS_DIM_2) :: OBJ_PTS
    INTEGER, INTENT(IN) :: ISNB
    INTEGER, INTENT(IN) :: SNB
    INTEGER, INTENT(IN) :: ONB
    INTEGER, INTENT(IN) :: OBJ_BOUNDS_DIM_1
    INTEGER, INTENT(IN) :: OBJ_BOUNDS_DIM_2
    REAL(KIND=R8), INTENT(IN), DIMENSION(OBJ_BOUNDS_DIM_1,OBJ_BOUNDS_DIM_2) :: OBJ_BOUNDS
    INTEGER, INTENT(OUT) :: LBATCH
    INTEGER, INTENT(OUT) :: BATCHX_DIM_1
    INTEGER, INTENT(OUT) :: BATCHX_DIM_2
    REAL(KIND=R8), ALLOCATABLE, SAVE, DIMENSION(:,:) :: BATCHX_LOCAL
    INTEGER(KIND=INT64), INTENT(OUT) :: BATCHX
    INTEGER, INTENT(OUT) :: IERR

    CALL VTMOP_LIBE_GENERATE(D, P, LB, UB, DES_PTS, OBJ_PTS, ISNB, SNB, ONB, OBJ_BOUNDS, LBATCH, BATCHX_LOCAL, IERR)

    BATCHX_DIM_1 = SIZE(BATCHX_LOCAL,1)
    BATCHX_DIM_2 = SIZE(BATCHX_LOCAL,2)
    BATCHX = LOC(BATCHX_LOCAL(1,1))
  END SUBROUTINE C_VTMOP_LIBE_GENERATE

END MODULE C_VTMOP_LIBE_MOD

! This file (shared_modules.f95) contains modules REAL_PRECISION.

MODULE REAL_PRECISION  ! From HOMPACK90.
  ! This is for 64-bit arithmetic.
  INTEGER, PARAMETER:: R8=SELECTED_REAL_KIND(13)
END MODULE REAL_PRECISION

MODULE VTMOP_LIBE_MOD

CONTAINS

SUBROUTINE VTMOP_LIBE_INIT( D, P, LB, UB, IERR, LOPT_BUDGET, DECAY, &
                            DES_TOL, EPS, EPSW, OBJ_TOL, MIN_RADF,  &
                            TRUST_RADF, OBJ_BOUNDS, PMODE )
! This subroutine initializes a VTMOP object for tracking the adaptive
! weighting scheme described in
!
! Deshpande, Shubhangi, Layne T. Watson, and Robert A. Canfield.
! "Multiobjective optimization using an adaptive weighting scheme."
! Optimization Methods and Software 31.1 (2016): 110-133.
!
! This is a wrapper for the subroutine VTMOP_INIT in VTMOP_MOD.
!
!
! On input:
!
! D is the dimension of the design space.
!
! P is the dimension of the objective space.
!
! LB(1:D) is the real vector of lower bound constraints for the
!    D design variables.
!
! UB(1:D) is the real vector of upper bound constraints for the
!    D design variables.
!
!
! On output:
!
! IERR is an integer error flag.
!
! Hundreds digit:
!  000 : Normal output. Successful initialization of VTMOP object.
!
!  1xx : Errors detected.
!   Tens digit:
!     11x : The input parameters contained illegal dimensions or values.
!       Ones digit:
!         110 : D (design dimension) must be a positive integer.
!         111 : P (objective dimension) must be at least two.
!         112 : The lead dimension of LB(:) must match D.
!         113 : The lead dimension of UB(:) must match D.
!         114 : LB(:) must be elementwise strictly less than UB(:) - DES_TOL.
!     12x : The optional dummy arguments contained illegal values.
!       Ones digit:
!         123 : LOPT_BUDGET must be positive.
!         124 : DECAY must be in the range (EPS, 1-EPS).
!         125 : TRUST_RADF must be larger than or equal to MIN_RADF.
!         129 : If OBJ_BOUNDS is given, then it must have dimensions P by 2
!               and all OBJ_BOUNDS(:,1) < OBJ_BOUNDS(:,2).
!     13x : A memory allocation error has occurred.
!       Ones digit:
!         130 : A memory allocation error occurred.
!         131 : A memory deallocation error occurred.
!
!  9xx : A checkpointing error has occurred.
!    901 : WARNING: the VTMOP object was successfully recovered from the
!          checkpoint but does not match the input data.
!
!  The following error codes are returned by VTMOP_CHKPT_NEW. Further details
!  can be found in the header for VTMOP_CHKPT_NEW.
!    91x : The VTMOP passed to the checkpoint was invalid.
!    92x : Error creating the checkpoint file.
!
!  The following error codes are returned by VTMOP_CHKPT_RECOVER, when
!  VTMOP_INIT is called in recovery mode. Further details can be found in
!  the header for VTMOP_CHKPT_RECOVER.
!    95x : Error reading data from the checkpoint file.
!    96x : A memory management error occurred during recovery.
!
!
! Optional input arguments.
!
! LOPT_BUDGET is an integer input, which specifies the budget for the
!    local optimization subroutine. The default value for LOPT_BUDGET is
!    2500 surrogate evaluations. Note that this value is not saved during
!    checkpointing, and must be reset by the user when recovery mode is
!    active, whenever a non-default value is desired.
!
! DECAY is a real input specifying the decay rate for the local
!    trust region (LTR) radius. This value affects how many times an
!    isolated point can be the center of a LTR before it is discarded.
!    By default, DECAY = 0.5.
!
! DES_TOL is the tolerance for the design space. A design point that
!    is within DES_TOL of an evaluated design point will not be reevaluated.
!    The default value for DES_TOL is the square-root of the working precision
!    EPS. Note that any value that is smaller than the working precsion EPS
!    will be ignored and EPS will be used.
!
! EPS is a real input, which specifies the working precision of the
!    machine. The default value for EPS is SQRT(EPSILON), where EPSILON
!    is the unit roundoff. Note that if the value supplied is smaller than
!    the default value then the default value will be used.
!
! EPSW is a small positive number, which is used as the fudge factor for
!    zero-valued weights. A zero-valued weight does not guarantee Pareto
!    optimality. Therefore, all zero weights are set to EPSW. The appropriate
!    value of EPSW is problem dependent. By default, EPSW is the fourth root
!    of EPSILON (the unit roundoff). Note that any value that is smaller
!    than SQRT(EPSILON) is ignored and SQRT(EPSILON) will be used.
!
! OBJ_TOL is the tolerance for the objective space. An objective point
!    that is within OBJ_TOL of being dominated by another objective point
!    will be treated as such. The default value of OBJ_TOL is the
!    square-root of EPS. This value should be strictly greater than the
!    value of EPS. Note that any value that is smaller than the
!    working precsion EPS will be ignored and EPS will be used.
!
! OBJ_BOUNDS(1:P,1:2) is an optional real P by 2 array, whose first column
!    is a list of lower bounds and whose second column is a list of upper
!    bounds on the range of interesting objective values. When present,
!    this value is used to prune the list of potential LTR centers, so
!    that only objective values in the specified range are used when
!    looking for gaps in the Pareto. In particular, an objective value
!    F(x) will be considered for a LTR center if and only if
!    OBJ_BOUNDS(I,1) .LE. F_I(x) .LE. OBJ_BOUNDS(I,2) for all I = 1, ..., P.
!    By default, there are no bounds on the interesting range. Note that
!    this value is intentionally not saved during checkpointing, and must
!    be reset by the user when recovery mode is active, whenever a
!    non-default value is desired. This is the only input, for which
!    changing the value after loading from a previous checkpoint is not
!    ill-advised.
!
! MIN_RADF is the smallest value for the fraction r defining the trust region
!    box dimensions r * (UB - LB), before an isolated point is abandoned.
!    By default, MIN_RADF = 0.1 * TRUST_RADF, and is also set to this default
!    value if it is less than DES_TOL. After MIN_RADF and TRUST_RADF are set,
!    MIN_RADF < TRUST_RADF must hold.
!
! TRUST_RADF defines the initial trust region centered at an isolated
!    point X as [X - TRUST_RADF * (UB - LB), X + TRUST_RADF * (UB - LB)]
!    intersected with [LB, UB].  By default, TRUST_RADF = 0.2, and is also set
!    to this value if the value given is outside the interval
!    (DES_TOL, 1 - DES_TOL).
!
! PMODE is a logical input that specifies whether or not iteration tasks
!    should be performed in parallel. By default, PMODE = .FALSE. Note
!    that this value is not saved during checkpointing, and must be reset
!    by the user when recovery mode is active, whenever a non-default value
!    is desired.
!
! In recovery mode the inputs D, P, LB, and UB are still referenced
!    (for sanity checks). Also, the procedure arguments are still
!    needed to recover the procedure settings. No other optional
!    arguments are referenced.
!
USE VTMOP_MOD
USE ISO_FORTRAN_ENV
IMPLICIT NONE
! Input parameters.
INTEGER, INTENT(IN) :: D
INTEGER, INTENT(IN) :: P
REAL(KIND=R8), INTENT(IN) :: LB(:)
REAL(KIND=R8), INTENT(IN) :: UB(:)
! Output parameters.
INTEGER, INTENT(OUT) :: IERR
! Optional parameters from VTMOP (mandatory for this interface).
INTEGER, INTENT (IN) :: LOPT_BUDGET
LOGICAL, INTENT (IN) :: PMODE
REAL(KIND=R8), INTENT(IN) :: DECAY
REAL(KIND=R8), INTENT(IN) :: DES_TOL
REAL(KIND=R8), INTENT(IN) :: EPS
REAL(KIND=R8), INTENT(IN) :: EPSW
REAL(KIND=R8), INTENT(IN) :: OBJ_TOL
REAL(KIND=R8), INTENT(IN) :: MIN_RADF
REAL(KIND=R8), INTENT(IN) :: TRUST_RADF
REAL(KIND=R8), INTENT(IN) :: OBJ_BOUNDS(:,:)

! Local variables.
TYPE(VTMOP_TYPE) :: VTMOP

! Initialize the VTMOP status object.
CALL VTMOP_INIT( VTMOP, D, P, LB, UB, IERR, LOPT_BUDGET=LOPT_BUDGET,        &
                 DECAY=DECAY, DES_TOL=DES_TOL, EPS=EPS, EPSW=EPSW,          &
                 OBJ_TOL=OBJ_TOL, MIN_RADF=MIN_RADF, TRUST_RADF=TRUST_RADF, &
                 OBJ_BOUNDS=OBJ_BOUNDS, PMODE=PMODE, ICHKPT=1 )
IF (IERR .NE. 0) THEN
   WRITE(ERROR_UNIT, "(A,I4)") &
        "An error occurred while initializing. Error code: ", IERR
   RETURN
END IF

RETURN
END SUBROUTINE VTMOP_LIBE_INIT

SUBROUTINE VTMOP_LIBE_GENERATE ( D, P, LB, UB, DES_PTS, OBJ_PTS, &
                                 ISNB, SNB, ONB, OBJ_BOUNDS,     &
                                 LBATCH, BATCHX, IERR )
! The VTMOP_LIBE_GENERATE subroutine produces static batches of candidate
! points using VTMOP_MOD. Each call to VTMOP_LIBE_GENERATE performs a half
! iteration of the VTMOP_SOLVE algorithm (from VTMOP_LIB), using a Latin
! hypercube design of size SNB.
!
! VTMOP_INITIALIZE must still be used to initialize the VTMOP object, and
! VTMOP_FINALIZE must be used to terminate and post process the results.
!
!
! On input:
!
! D is the dimension of the design space.
!
! P is the dimension of the objective space.
!
! LB(1:D) is the real vector of lower bound constraints for the
!    D design variables.
!
! UB(1:D) is the real vector of upper bound constraints for the
!    D design variables.
!
! DES_PTS(D,N) is the current list of design points.
!
! OBJ_PTS(P,N) is the current list of objective points.
!
! ISNB is the preferred initial search batch size and is used as the
!    size of the Latin hypercube design in the zeroeth iteration
!    (initial search). ISNB should be much greater than SNB.
!
! SNB is the preferred search batch size and is used as the
!    size of the Latin hypercube design in the search phase.
!
! ONB is the preferred optimization batch size and is used to
!    pad out the batch of candidate designs in the optimization phase.
!
!
! On output:
!
! LBATCH returns the size of the next batch.
!
! BATCHX(D,LBATCH) is the next batch of design points to evaluate.
!
! IERR is an integer error flag. Error codes carried from worker
!    subroutines. In general:
!
!  000 : successful iteration.
!  003 : stopping criterion 3 achieved.
!
!  1xx : illegal input error.
!   Tens digit:
!    11x : The VTMOP object contained illegal dimensions or values, and
!          may not have been properly initialized.
!       Ones digit:
!         110 : The problem dimensions D and P are not legal.
!         111 : The internal arrays have not been allocated.
!         112 : The internal arrays have been initialized, but to invalid
!               dimensions.
!         113 : The lower and upper bound constraints contain illegal values,
!               subject to the design space tolerance.
!    12x : Illegal values in other inputs.
!         120 : The lead dimension of DES_PTS does not match the data in VTMOP.
!         121 : The lead dimension of OBJ_PTS does not match the data in VTMOP.
!         122 : The second dimensions of DES_PTS and OBJ_PTS do not match.
!         123 : The preferred batch sizes ISNB, SNB, ONB must be nonnegative.
!
!    2xx, 3xx : Error in VTMOP_LTR or VTMOP_OPT, respectively.
!
!    5xx, 6xx, 7xx, 8xx : Error in DELAUNAYGRAPH, FIT_SURROGATES, LOCAL_OPT,
!                         or LH_DESIGN, respectively. See documentation for
!                         those procedures for more details.
!
!    9xx : Checkpointing error. See checkpointing subroutine documentation.
!
USE VTMOP_MOD
USE ISO_FORTRAN_ENV
IMPLICIT NONE
! Input parameters.
INTEGER, INTENT(IN) :: D
INTEGER, INTENT(IN) :: P
REAL(KIND=R8), INTENT(IN) :: LB(:)
REAL(KIND=R8), INTENT(IN) :: UB(:)
REAL(KIND=R8), INTENT(IN) :: DES_PTS(:,:)
REAL(KIND=R8), INTENT(IN) :: OBJ_PTS(:,:)
INTEGER, INTENT(IN) :: ISNB
INTEGER, INTENT(IN) :: SNB
INTEGER, INTENT(IN) :: ONB
REAL(KIND=R8), INTENT(IN) :: OBJ_BOUNDS(:,:)
! Output parameters.
INTEGER, INTENT(OUT) :: LBATCH
REAL(KIND=R8 ), ALLOCATABLE, INTENT(OUT) :: BATCHX (:,:)
INTEGER, INTENT(OUT) :: IERR
! Local variables.
TYPE(VTMOP_TYPE) :: VTMOP
INTEGER :: I, J, K
INTEGER :: NW
REAL(KIND=R8) :: LTR_LB (D)
REAL(KIND=R8) :: LTR_UB (D)
REAL(KIND=R8), ALLOCATABLE :: TMP (:,:)
REAL(KIND=R8), ALLOCATABLE :: WEIGHTS (:,:)
! BLAS function for computing Euclidean distance.
REAL(KIND=R8), EXTERNAL :: DNRM2

! Recover the VTMOP status object.
CALL VTMOP_INIT( VTMOP, D, P, LB, UB, IERR, ICHKPT=-1 )
IF (IERR .NE. 0) THEN
   WRITE(ERROR_UNIT, "(A,I4)") &
        "An error occurred while recovering VTMOP object. Error code: ", IERR
   RETURN
END IF

! Check for illegal input parameter values.
IF ( D < 1 .OR. P < 2 ) THEN
   IERR = 110; RETURN; END IF
IF ( .NOT. ( ALLOCATED(VTMOP%LB) .AND. ALLOCATED(VTMOP%UB) .AND. &
             ALLOCATED(VTMOP%CLIST) ) ) THEN
   IERR = 111; RETURN; END IF
IF ( SIZE(VTMOP%LB,1) .NE. D .OR. SIZE(VTMOP%UB,1) .NE. D .OR. &
     SIZE(VTMOP%CLIST,1) .NE. D+1)  THEN
   IERR = 112; RETURN; END IF
IF ( ANY(VTMOP%LB(:) .GE. VTMOP%UB(:) - VTMOP%DES_TOL) ) THEN
   IERR = 113; RETURN; END IF
! Check for illegal dimensions to DES_PTS and OBJ_PTS.
IF ( D .NE. SIZE(DES_PTS,1) ) THEN
   IERR = 120; RETURN; END IF
IF (  P .NE. SIZE(OBJ_PTS,1) ) THEN
   IERR = 121; RETURN; END IF
IF ( SIZE(DES_PTS,2) .NE. SIZE(OBJ_PTS,2) ) THEN
   IERR = 122; RETURN; END IF
IF ( ISNB < 0 .OR. SNB < 0 .OR. ONB < 0) THEN
   IERR = 123; RETURN; END IF

! Perform a half-iteration and request the next batch, based on the state of
! the VTMOP object.

! There are two cases.
IF (.NOT. ALLOCATED(VTMOP%WEIGHTS)) THEN
   ! Execute the search phase.

   ! Choose the most isolated point(s), and construct the LTR(s).
   CALL VTMOP_LTR( VTMOP, DES_PTS, OBJ_PTS, LTR_LB, LTR_UB, IERR )
   IF (IERR .NE. 0) RETURN

   ! Get the batch size, using a special rule for the first iteration
   ! and respecting the preferred batch size SNB.
   IF (VTMOP%ITERATE .EQ. 0) THEN
      ! In first iteration, generate a much larger LH_DESIGN.
      LBATCH = ISNB
   ELSE
      ! In later iterations, generate a smaller LH_DESIGN.
      LBATCH = SNB
   END IF
   ! Request a static exploration of the LTR.
   CALL LH_DESIGN(D, LTR_LB, LTR_UB, LBATCH, TMP, IERR, VTMOP%DES_TOL)
   IF (IERR .NE. 0) THEN
      IERR = IERR + 800; RETURN; END IF
   ! Allocate the output array.
   ALLOCATE(BATCHX(D,LBATCH), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 820; RETURN; END IF
   ! Filter out any redundant points.
   K = 0
   OUTER : DO I = 1, LBATCH
      INNER : DO J = 1, SIZE(DES_PTS,2)
         ! Check for any repeated design points.
         IF (DNRM2(D, TMP(:,I) - DES_PTS(:,J), 1) < VTMOP%DES_TOL) CYCLE OUTER
      END DO INNER
      ! If the point is not repeated, add it to the output array.
      K = K + 1
      BATCHX(:,K) = TMP(:,I)
   END DO OUTER
   ! Check the size of the output array.
   IF (K .EQ. LBATCH) THEN
      ! No resizing is required, free the temporary array (typical case).
      DEALLOCATE(TMP, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 821; RETURN; END IF
   ELSE
      ! Resize the output array (rare case).
      TMP(:,1:K) = BATCHX(:,1:K)
      DEALLOCATE(BATCHX, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 821; RETURN; END IF
      ALLOCATE(BATCHX(D,K), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 820; RETURN; END IF
      BATCHX(:,:) = TMP(:,1:K)
      ! Free the temporary array.
      DEALLOCATE(TMP, STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 821; RETURN; END IF
   END IF
ELSE
   ! Execute the optimization phase.

   ! Recover the last LTR.
   IF (VTMOP%ITERATE .EQ. 0) THEN
      LTR_LB(:) = VTMOP%LB(:)
      LTR_UB(:) = VTMOP%UB(:)
   ELSE
      DO I = 1, D
         LTR_UB(I) = MIN( VTMOP%CLIST(I,VTMOP%ITERATE) +   &
                          VTMOP%CLIST(D+1,VTMOP%ITERATE) * &
                          (VTMOP%UB(I) - VTMOP%LB(I)),     &
                          VTMOP%UB(I) )
         LTR_LB(I) = MAX( VTMOP%CLIST(I,VTMOP%ITERATE) -   &
                          VTMOP%CLIST(D+1,VTMOP%ITERATE) * &
                          (VTMOP%UB(I) - VTMOP%LB(I)),     &
                          VTMOP%LB(I) )
      END DO
   END IF

   ! Add additional weights at random in order to match ONB.
   NW = SIZE(VTMOP%WEIGHTS,2)
   ! Generate twice as many points as needed, in case several points
   ! produce redundant solutions.
   ALLOCATE(TMP(P,FLOOR(ONB*1.5)), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 820; RETURN; END IF
   CALL RANDOM_NUMBER(TMP)
   DO I = 1, SIZE(TMP, 2)
      TMP(:,I) = -LOG(1.0_R8 - TMP(:,I))
      TMP(:,I) = TMP(:,I) / SUM(TMP(:,I))
   END DO
   ! Make a copy of VTMOP%WEIGHTS.
   ALLOCATE(WEIGHTS(P,NW), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 820; RETURN; END IF
   WEIGHTS(:,:) = VTMOP%WEIGHTS(:,:)
   ! Reallocate the VTMOP%WEIGHTS array.
   DEALLOCATE(VTMOP%WEIGHTS, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 821; RETURN; END IF
   ALLOCATE(VTMOP%WEIGHTS(P,NW+SIZE(TMP,2)), STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 820; RETURN; END IF
   ! Copy in the full list of weights.
   VTMOP%WEIGHTS(:,1:NW) = WEIGHTS(:,:)
   VTMOP%WEIGHTS(:,NW+1:NW+SIZE(TMP,2)) = TMP(:,:)
   ! Free the temporary arrays.
   DEALLOCATE(WEIGHTS, TMP, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 821; RETURN; END IF

   ! Optimize the surrogates in the LTR.
   CALL VTMOP_OPT( VTMOP, LTR_LB, LTR_UB, DES_PTS, OBJ_PTS, TMP, IERR )
   IF (IERR .NE. 0) RETURN

   ! If less than NW + ONB - (NW mod ONB) points were returned, return all the
   ! candidates.
   IF (SIZE(TMP,2) .LE. NW+ONB-MOD(NW,ONB)) THEN
      ALLOCATE(BATCHX(D, SIZE(TMP,2)), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 820; RETURN; END IF
      BATCHX(:,:) = TMP(:,:)
   ! Otherwise, return the first NW + ONB - (NW mod ONB) candidates.
   ELSE
      ALLOCATE(BATCHX(D, NW+ONB-MOD(NW,ONB)), STAT=IERR)
      IF (IERR .NE. 0) THEN
         IERR = 820; RETURN; END IF
      BATCHX(:,:) = TMP(:,1:NW+ONB-MOD(NW,ONB))
   END IF

   ! Free the temporary array.
   DEALLOCATE(TMP, STAT=IERR)
   IF (IERR .NE. 0) THEN
      IERR = 821; RETURN; END IF
   ! Get the size of BATCHX.
   LBATCH = SIZE(BATCHX, 2)
END IF

RETURN
END SUBROUTINE VTMOP_LIBE_GENERATE

END MODULE VTMOP_LIBE_MOD

#!/bin/bash -x
#COBALT -t 00:30:00
#COBALT -O libE_forces_MPI_balsam
#COBALT -n 129
#COBALT -q default
#COBALT -A <projectID>

# Script to launch libEnsemble using Balsam.
#   Assumes Conda environment is set up.
#   Requires Balsam is installed and a database initialized.

# To be run with central job management
# - Manager and workers run on one node (or a dedicated set of nodes).
# - Workers submit tasks to the rest of the nodes in the pool.

# Name of calling script
export EXE=run_libe_forces.py

# Number of workers.
export NUM_WORKERS=127

# Number of nodes to run libE
export LIBE_NODES=2

# Wallclock for libE job in minutes (supplied to Balsam - make at least several mins smaller than wallclock for this submission to ensure job is launched)
export LIBE_WALLCLOCK=25

# Name of working directory where Balsam places running jobs/output (inside the database directory)
export WORKFLOW_NAME=libe_workflow

# If user script takes ``elapsed_wallclock_time`` argument.
# export SCRIPT_ARGS=$(($LIBE_WALLCLOCK-3))
export SCRIPT_ARGS=""

# Name of Conda environment
export CONDA_ENV_NAME=<conda_env_name>

# Name of database
export BALSAM_DB_NAME=<dbase_name>

export LIBE_PLOTS=true   # Require plot scripts (see at end)
export BALSAM_PLOTS=true # Require plot scripts (see at end)
export PLOT_DIR=..

# Required for killing tasks from workers on Theta
export PMI_NO_FORK=1

# Unload Theta modules that may interfere with task monitoring/kills
module unload trackdeps
module unload darshan
module unload xalt

# Obtain Conda PATH from miniconda-3/latest module
CONDA_DIR=/soft/datascience/conda/miniconda3/latest/bin

# Ensure environment isolated
export PYTHONNOUSERSITE=1

# Activate conda environment
source $CONDA_DIR/activate $CONDA_ENV_NAME

# Activate Balsam database
source balsamactivate $BALSAM_DB_NAME

# Make sure no existing apps/jobs
balsam rm apps --all --force
balsam rm jobs --all --force
wait
sleep 3

# Add calling script to Balsam database as app and job.
export THIS_DIR=$PWD
export SCRIPT_BASENAME=${EXE%.*}

# Multiple nodes
export LIBE_PROCS=$((NUM_WORKERS+1))  # Manager and workers
export PROCS_PER_NODE=$((LIBE_PROCS/LIBE_NODES))  # Must divide evenly

balsam app --name $SCRIPT_BASENAME.app --exec $EXE --desc "Run $SCRIPT_BASENAME"

balsam job --name job_$SCRIPT_BASENAME --workflow $WORKFLOW_NAME \
           --application $SCRIPT_BASENAME.app --args $SCRIPT_ARGS \
           --wall-time-minutes $LIBE_WALLCLOCK \
           --num-nodes $LIBE_NODES --ranks-per-node $PROCS_PER_NODE \
           --url-out="local:/$THIS_DIR" --stage-out-files="*.out *.txt *.log" \
           --url-in="local:/$THIS_DIR/*" --yes

# Hyper-thread libE (note this will not affect HT status of user calcs - only libE itself)
# E.g. Running 255 workers and one manager on one libE node.
# balsam job --name job_$SCRIPT_BASENAME --workflow $WORKFLOW_NAME \
#            --application $SCRIPT_BASENAME.app --args $SCRIPT_ARGS \
#            --wall-time-minutes $LIBE_WALLCLOCK \
#            --num-nodes 1 --ranks-per-node 256 --threads-per-core 4 \
#            --url-out="local:/$THIS_DIR" --stage-out-files="*.out *.txt *.log" \
#            --url-in="local:/$THIS_DIR/*" --yes

#Run job
balsam launcher --consume-all --job-mode=mpi --num-transition-threads=1

if [[ $LIBE_PLOTS = "true" ]]; then
  python $PLOT_DIR/plot_libe_calcs_util_v_time.py
  python $PLOT_DIR/plot_libe_runs_util_v_time.py
  python $PLOT_DIR/plot_libe_histogram.py

if [[ $BALSAM_PLOTS = "true" ]]; then
  python $PLOT_DIR/plot_util_v_time.py
  python $PLOT_DIR/plot_jobs_v_time.py
  python $PLOT_DIR/plot_waiting_v_time.py
fi

wait
source balsamdeactivate

#!/usr/bin/env bash

# Libensemble Test Runner

# If hooks/set-hooks.sh is run - this runs as a pre-push git script

# Options for test types (only matters if "true" or anything else)
export RUN_UNIT_TESTS=true    #Recommended for pre-push / CI tests
export RUN_COV_TESTS=true     #Provide coverage report
export RUN_REG_TESTS=true     #Recommended for pre-push / CI tests
export RUN_PEP_TESTS=false    #Code style conventions
export PYTHON_FLAGS=''        #Flags for PYTHON_RUN

# Regression test options
#export REG_TEST_LIST='test_number1.py test_number2.py' #selected/ordered
export REG_TEST_LIST=test_*.py #unordered # override with -y
# export REG_TEST_PROCESS_COUNT_LIST='2 4'
export REG_USE_PYTEST=false
export REG_TEST_OUTPUT_EXT=std.out #/dev/null
export REG_STOP_ON_FAILURE=false
export REG_RUN_LARGEST_TEST_ONLY=true
export RUN_EXTRA=false
#-----------------------------------------------------------------------------------------

# Test Directories - all relative to project root dir
export CODE_DIR=libensemble
export LIBE_SRC_DIR=$CODE_DIR
export TESTING_DIR=$CODE_DIR/tests
export UNIT_TEST_SUBDIR=$TESTING_DIR/unit_tests
export UNIT_TEST_NOMPI_SUBDIR=$TESTING_DIR/unit_tests_nompi
export UNIT_TEST_LOGGER_SUBDIR=$TESTING_DIR/unit_tests_logger
export REG_TEST_SUBDIR=$TESTING_DIR/regression_tests

#Coverage merge and report dir - will need the relevant .coveragerc file present
#export COV_MERGE_DIR='' #root dir
export COV_MERGE_DIR=$TESTING_DIR

#PEP code standards test options
export PYTHON_PEP_STANDARD=pep8

#export PEP_SCOPE=$CODE_DIR
export PEP_SCOPE=$LIBE_SRC_DIR

#-----------------------------------------------------------------------------------------
#Functions

#Does file exist in given dir
#In:  Directory path, filename
#Out: true if found, else false
find_file_in_dir () {
  local xdir=$1
  local filename=$2
  file_found_in_tree=false
  fout=$(find "$xdir" -maxdepth 1 -name $filename)
  if [[ ${fout##*/} == "$filename" ]]; then
    file_found_in_tree=true
  fi;
  echo "$file_found_in_tree"
}

#Print summary line like pytest
#In:  String to print
#Out: Prints line (nothing returned)
print_summary_line() {
  local phrase
  phrase=$@
  #Add two for the spaces
  textsize=$((${#phrase}+2))
  #echo $textsize
  tsize=$(tput cols)
  lsize=$((($tsize-$textsize)/2))

  #Deal with result of integer division
  tot_len=$((${lsize}+${lsize}+${textsize}))
  shortfall=$(($tsize-$tot_len))

  symbol_count=$lsize
  while [ $symbol_count -gt 0 ]
  do
    printf "="
    symbol_count=$((symbol_count-1))
  done
  printf " $phrase "
  #printf '%*s' "$phrase"
  #echo '$phrase'
  symbol_count=$(($lsize+$shortfall))
  while [ $symbol_count -gt 0 ]
  do
    printf "="
    symbol_count=$((symbol_count-1))
  done
}

#Get current time in seconds
#In:  Nothing
#Out: Returns time in seconds (seconds since 1970-01-01 00:00:00 UTC) as a string
#     Or if bc not available uses SECONDS (whole seconds that script has been running)
current_time() {
  local time
  #Is bc present
  USE_BC=f
  bc --version >> /dev/null && USE_BC=t
  if [ $USE_BC = 't' ]; then
    #time=$(date +%s.%N)
    time=$(python -c 'import time; print(time.time())')
  else
    time=$SECONDS
  fi;
  echo "$time"
}

#Return a time difference
#In:  Start and End times as strings
#Out: Time difference as a string
total_time() {
  #Is bc present
  USE_BC=f
  bc --version >> /dev/null && USE_BC=t
  if [ $USE_BC = 't' ]; then
    diff=$(echo "scale=2;($2 - $1)*100/100" | bc)
  else
    diff=$(( $2 - $1 ))
  fi;
  echo "$diff"
}

#Cleanup - esp regression test run directory
#Changes dirs
cleanup() {
  THISDIR=${PWD}
  cd $ROOT_DIR/$TESTING_DIR
    filelist=(.cov_merge_out*);        [ -e ${filelist[0]} ] && rm .cov_merge_out*
    filelist=(ensemble_*);             [ -e ${filelist[0]} ] && rm -r ensemble_*
  for DIR in $UNIT_TEST_SUBDIR $UNIT_TEST_NOMPI_SUBDIR $UNIT_TEST_LOGGER_SUBDIR ; do
  cd $ROOT_DIR/$DIR
    filelist=(libE_history_at_abort_*.npy); [ -e ${filelist[0]} ] && rm libE_history_at_abort_*.npy
    filelist=(*.out);                   [ -e ${filelist[0]} ] && rm *.out
    filelist=(*.err);                   [ -e ${filelist[0]} ] && rm *.err
    filelist=(*.pickle);                [ -e ${filelist[0]} ] && rm *.pickle
    filelist=(.cov_unit_out*);          [ -e ${filelist[0]} ] && rm .cov_unit_out*
    filelist=(simdir/*.x);              [ -e ${filelist[0]} ] && rm simdir/*.x
    filelist=(libe_task_*.out);         [ -e ${filelist[0]} ] && rm libe_task_*.out
    filelist=(*libE_stats.txt*);        [ -e ${filelist[0]} ] && rm *libE_stats.txt*
    filelist=(my_machinefile);          [ -e ${filelist[0]} ] && rm my_machinefile
    filelist=(libe_stat_files);         [ -e ${filelist[0]} ] && rm -r libe_stat_files
    filelist=(ensemble.log);            [ -e ${filelist[0]} ] && rm ensemble.log
    filelist=(H_test.npy);              [ -e ${filelist[0]} ] && rm H_test.npy
  done
  cd $ROOT_DIR/$REG_TEST_SUBDIR
    filelist=(*.$REG_TEST_OUTPUT_EXT);  [ -e ${filelist[0]} ] && rm *.$REG_TEST_OUTPUT_EXT
    filelist=(*.npy);                   [ -e ${filelist[0]} ] && rm *.npy
    filelist=(*.pickle);                [ -e ${filelist[0]} ] && rm *.pickle
    filelist=(.cov_reg_out*);           [ -e ${filelist[0]} ] && rm .cov_reg_out*
    filelist=(*active_runs.txt);        [ -e ${filelist[0]} ] && rm *active_runs.txt
    filelist=(*.err);                   [ -e ${filelist[0]} ] && rm *.err
    filelist=(outfile*.txt);            [ -e ${filelist[0]} ] && rm outfile*.txt
    filelist=(machinefile*);            [ -e ${filelist[0]} ] && rm machinefile*
    filelist=(libe_task_*.out);         [ -e ${filelist[0]} ] && rm libe_task_*.out
    filelist=(*libE_stats.txt*);        [ -e ${filelist[0]} ] && rm *libE_stats.txt*
    filelist=(my_simtask.x);            [ -e ${filelist[0]} ] && rm my_simtask.x
    filelist=(libe_stat_files);         [ -e ${filelist[0]} ] && rm -r libe_stat_files
    filelist=(ensemble.log);            [ -e ${filelist[0]} ] && rm ensemble.log
    filelist=(ensemble_*);              [ -e ${filelist[0]} ] && rm -r ensemble_*
    filelist=(sim_*);                   [ -e ${filelist[0]} ] && rm -r sim_*
    filelist=(gen_*);                   [ -e ${filelist[0]} ] && rm -r gen_*
    filelist=(nodelist_*);              [ -e ${filelist[0]} ] && rm nodelist_*
    filelist=(x_*.txt y_*.txt);         [ -e ${filelist[0]} ] && rm x_*.txt y_*.txt
    filelist=(opt_*.txt_flag);          [ -e ${filelist[0]} ] && rm opt_*.txt_flag
  cd $THISDIR
}

#-----------------------------------------------------------------------------------------

#Parse Options
#set -x

unset PYTHON_VER
unset RUN_PREFIX

#Default to script name for run-prefix (name of tests)
script_name=`basename "$0"`
RUN_PREFIX=$script_name
CLEAN_ONLY=false
unset MPIEXEC_FLAGS
PYTEST_SHOW_OUT_ERR=false
RTEST_SHOW_OUT_ERR=false

export RUN_MPI=false
export RUN_LOCAL=false
export RUN_TCP=false

usage() {
  echo -e "\nUsage:"
  echo "  $0 [-hcszurmlte] [-p <2|3>] [-A <string>] [-n <string>] [-a <string>] [-y <string>]" 1>&2;
  echo ""
  echo "Options:"
  echo "  -h              Show this help message and exit"
  echo "  -c              Clean up test directories and exit"
  echo "  -s              Print stdout and stderr to screen when running pytest (unit tests)"
  echo "  -z              Print stdout and stderr to screen when running regression tests (run without pytest)"
  echo "  -u              Run only the unit tests"
  echo "  -r              Run only the regression tests"
  echo "  -m              Run the regression tests using MPI comms"
  echo "  -l              Run the regression tests using Local comms"
  echo "  -t              Run the regression tests using TCP comms"
  echo "  -e              Run extra regression tests that require additional dependencies"
  echo "  -p {version}    Select a version of python. E.g. -p 2 will run with the python2 exe"
  echo "                  Note: This will literally run the python2/python3 exe. Default runs python"
  echo "  -A {-flag arg}  Supply arguments to python"
  echo "  -n {name}       Supply a name to this test run"
  echo "  -a {args}       Supply a string of args to add to mpiexec line"
  echo "  -y {args}       Supply a list of regression tests as a reg. expression  e.g. '-y test_persistent_aposmm*'"
  echo ""
  echo "Note: If none of [-mlt] are given, the default is to run tests for all comms"
  echo ""
  exit 1
}

while getopts ":p:n:a:y:A:hcszurmlte" opt; do
  case $opt in
    p)
      echo "Parameter supplied for Python version: $OPTARG" >&2
      PYTHON_VER=$OPTARG
      ;;
    n)
      echo "Parameter supplied for Test Name: $OPTARG" >&2
      RUN_PREFIX=$OPTARG
      ;;
    a)
      echo "Parameter supplied for mpiexec args: $OPTARG" >&2
      MPIEXEC_FLAGS=$OPTARG
      ;;
    c)
      #echo "Cleaning test output: $OPTARG" >&2
      echo "Cleaning test output"
      CLEAN_ONLY=true
      ;;
    s)
      echo "Will show stdout and stderr during pytest"
      PYTEST_SHOW_OUT_ERR=true
      ;;
    z)
      echo "Will show stdout and stderr during regression tests"
      RTEST_SHOW_OUT_ERR=true
      ;;    u)
      echo "Running only the unit tests"
      export RUN_REG_TESTS=false
      ;;
    r)
      echo "Running only the regression tests"
      export RUN_UNIT_TESTS=false
      ;;
    l)
      echo "Running only the local regression tests"
      export RUN_LOCAL=true
      ;;
    t)
      echo "Running only the TCP regression tests"
      export RUN_TCP=true
      ;;
    e)
      echo "Running extra regression tests with additional dependencies"
      export RUN_EXTRA=true
      ;;
    m)
      echo "Running only the MPI regression tests"
      export RUN_MPI=true
      ;;
    y)
      echo "Running with user supplied test list"
      export REG_TEST_LIST="$OPTARG"
      ;;
    A)
      echo "Python arguments passed: $OPTARG" >&2
      PYTHON_FLAGS="$PYTHON_FLAGS $OPTARG"
      ;;
    h)
      usage
      ;;
    \?)
      echo "Invalid option supplied: -$OPTARG" >&2
      usage
      exit 1
      ;;
    :)
      echo "Option -$OPTARG requires an argument." >&2
      exit 1
      ;;
  esac
done
# shift $((OPTIND-1))
# if [ -z "${s}" ] || [ -z "${p}" ]; then
#     usage
# fi

# If none selected default to running all tests
if [ "$RUN_MPI" = false ] && [ "$RUN_LOCAL" = false ] && [ "$RUN_TCP" = false ];then
    RUN_MPI=true && RUN_LOCAL=true && RUN_TCP=false
fi

#-----------------------------------------------------------------------------------------

# Get project root dir

# Try using git root dir
root_found=false
ROOT_DIR=$(git rev-parse --show-toplevel) && root_found=true

#If not found using git - try search up tree for setup.py
if [[ $root_found == "false" ]]; then
  search_dir=`pwd`
  search_for="setup.py"
  while [ "$search_dir" != "/" ]
  do
    file_found=$(find_file_in_dir $search_dir $search_for)
    #[[ $file_found = "true" ]] && break
    if [[ $file_found = "true" ]]; then
      ROOT_DIR=$search_dir
      root_found=true
      break;
    fi;
    search_dir=`dirname "$search_dir"`
  done
fi;

if [ $CLEAN_ONLY = "true" ]; then
  if [ "$root_found" = true ]; then
    cleanup
  else
    echo -e "Clean up aborted - no project root directory found"
  fi;
  exit
fi;

#If not supplied will go to just python (no number) - eg. with tox/virtual envs
PYTHON_RUN="python$PYTHON_VER $PYTHON_FLAGS"
echo -e "Python run: $PYTHON_RUN"

textreset=$(tput sgr0)
fail_color=$(tput bold;tput setaf 1) #red
pass_color=$(tput bold;tput setaf 2) #green
titl_color=$(tput bold;tput setaf 6) #cyan
hint_color=$(tput bold;tput setaf 4) #blue

# Note - pytest exit codes
# Exit code 0:  All tests were collected and passed successfully
# Exit code 1:  Tests were collected and run but some of the tests failed
# Exit code 2:  Test execution was interrupted by the user
# Exit code 3:  Internal error happened while executing tests
# Exit code 4:  pytest command line usage error
# Exit code 5:  No tests were collected

tput bold
#echo -e "\nRunning $RUN_PREFIX libEnsemble Test-suite .......\n"
echo -e "\n************** Running: libEnsemble Test-Suite **************\n"
tput sgr 0
echo -e "Selected:"
[ $RUN_UNIT_TESTS = "true" ] && echo -e "Unit Tests"
[ $RUN_REG_TESTS = "true" ]  && echo -e "Regression Tests"
[ $RUN_REG_TESTS = "true" ]  && [ $RUN_MPI = "true" ]   && echo -e " - Run tests with MPI Comms"
[ $RUN_REG_TESTS = "true" ]  && [ $RUN_LOCAL = "true" ] && echo -e " - Run tests with Local Comms"
[ $RUN_REG_TESTS = "true" ]  && [ $RUN_TCP = "true" ]   && echo -e " - Run tests with TCP Comms"
[ $RUN_COV_TESTS = "true" ]  && echo -e "Including coverage analysis"
[ $RUN_PEP_TESTS = "true" ]  && echo -e "PEP Code Standard Tests (static code test)"

COV_LINE_SERIAL=''
COV_LINE_PARALLEL=''
if [ $RUN_COV_TESTS = "true" ]; then
   COV_LINE_SERIAL='--cov --cov-report html:cov_unit'
   #COV_LINE_PARALLEL='-m coverage run --parallel-mode --rcfile=../.coveragerc' #running in sub-dirs
   COV_LINE_PARALLEL='-m coverage run --parallel-mode --concurrency=multiprocessing' #running in regression dir itself

   #include branch coverage? eg. flags if never jumped a statement block... [see .coveragerc file]
   #COV_LINE_PARALLEL='-m coverage run --branch --parallel-mode'
fi;

if [ "$root_found" = true ]; then

  #Running without subdirs - delete any leftover output and coverage data files
  cleanup

  cd $ROOT_DIR/

  # Run Unit Tests -----------------------------------------------------------------------

  if [ "$RUN_UNIT_TESTS" = true ]; then
    tput bold;tput setaf 6
    echo -e "\n$RUN_PREFIX --$PYTHON_RUN: Running unit tests"
    tput sgr 0

    for DIR in $UNIT_TEST_SUBDIR $UNIT_TEST_NOMPI_SUBDIR $UNIT_TEST_LOGGER_SUBDIR ; do
    cd $ROOT_DIR/$DIR
#     $PYTHON_RUN -m pytest --fulltrace $COV_LINE_SERIAL
    if [ "$PYTEST_SHOW_OUT_ERR" = true ]; then
      $PYTHON_RUN -m pytest --capture=no --timeout=100 $COV_LINE_SERIAL #To see std out/err while running
    else
      $PYTHON_RUN -m pytest --timeout=100 $COV_LINE_SERIAL
    fi;

    code=$?
    if [ "$code" -eq "0" ]; then
      echo
      tput bold;tput setaf 2; echo "Unit tests passed. Continuing...";tput sgr 0
      echo
    else
      echo
      tput bold;tput setaf 1;echo -e "Abort $RUN_PREFIX: Unit tests failed: $code";tput sgr 0
      exit $code #return pytest exit code
    fi;
    done
  fi;
  cd $ROOT_DIR/

  # Run Regression Tests -----------------------------------------------------------------

  if [ "$RUN_REG_TESTS" = true ]; then
    tput bold;tput setaf 6
    echo -e "\n$RUN_PREFIX --$PYTHON_RUN: Running regression tests"
    tput sgr 0

    cd $ROOT_DIR/$REG_TEST_SUBDIR

    #Check output dir exists.
    if [ ! -d output ]; then
      mkdir output/
    fi;

    TIMEOUT=""
    if [ -x "$(command -v timeout)" ] ; then
        # TIMEOUT="timeout 60s"
        TIMEOUT=""
    fi
    #Build any sim/gen source code dependencies here .....

    cd $ROOT_DIR/$REG_TEST_SUBDIR

    #Run regression tests using MPI
    #Before first test set error code to zero
    code=0

    if [ "$REG_USE_PYTEST" = true ]; then
      echo -e "Regression testing using pytest"
      [ $RUN_COV_TESTS = "true" ]  && echo -e "WARNING: Coverage NOT being run for regression tests - not working with pytest\n"
    else
      echo -e "Regression testing is NOT using pytest"
    fi

    echo -e ""

    # ********* Loop over regression tests ************

    reg_start=$(current_time)
    reg_count_tests=0
    reg_count_runs=0
    reg_pass=0
    reg_fail=0
    test_num=0

    for TEST_SCRIPT in $REG_TEST_LIST
    do
      COMMS_LIST=$(sed -n '/# TESTSUITE_COMMS/s/# TESTSUITE_COMMS: //p' $TEST_SCRIPT)
      IS_EXTRA=$(sed -n '/# TESTSUITE_EXTRA/s/# TESTSUITE_EXTRA: //p' $TEST_SCRIPT)

      if [[ "$IS_EXTRA" = "true" ]] && [[ "$RUN_EXTRA" = false ]]; then
        continue
      fi

      for LAUNCHER in $COMMS_LIST
      do
        #Need proc count here for now - still stop on failure etc.
        NPROCS_LIST=$(sed -n '/# TESTSUITE_NPROCS/s/# TESTSUITE_NPROCS: //p' $TEST_SCRIPT)
        OS_SKIP_LIST=$(sed -n '/# TESTSUITE_OS_SKIP/s/# TESTSUITE_OS_SKIP: //p' $TEST_SCRIPT)
        if [ "$REG_RUN_LARGEST_TEST_ONLY" = true ]; then  NPROCS_LIST=${NPROCS_LIST##*' '}; fi
        for NPROCS in ${NPROCS_LIST}
        do
          NWORKERS=$((NPROCS-1))

          RUN_TEST=false
          if [ "$RUN_MPI" = true ]   && [ "$LAUNCHER" = mpi ];   then RUN_TEST=true; fi
          if [ "$RUN_LOCAL" = true ] && [ "$LAUNCHER" = local ]; then RUN_TEST=true; fi
          if [ "$RUN_TCP" = true ]   && [ "$LAUNCHER" = tcp ];   then RUN_TEST=true; fi

          if [[ "$OSTYPE" = *"darwin"* ]] && [[ "$OS_SKIP_LIST" = "OSX" ]]; then
            echo "Skipping test number for OSX: " $test_num
            continue
          fi

          if [ $REG_STOP_ON_FAILURE = "true" ]; then
            #Before Each Test check code is 0 (passed so far) - or skip to test summary
            if [ "$code" -ne "0" ]; then
              RUN_TEST=false
              break
            fi
          fi

          if [ "$RUN_TEST" = "true" ]; then
             test_num=$((test_num+1))
             test_start=$(current_time)

             echo -e "\n ${titl_color}---Test $test_num: $TEST_SCRIPT starting with $LAUNCHER on $NPROCS processes ${textreset}"

             if [ "$REG_USE_PYTEST" = true ]; then
               if [ "$LAUNCHER" = mpi ]; then
                 mpiexec -np $NPROCS $MPIEXEC_FLAGS $PYTHON_RUN -m pytest $TEST_SCRIPT >> $TEST_SCRIPT.$NPROCS'procs'.$REG_TEST_OUTPUT_EXT 2>test.err
                 test_code=$?
               else
                 $TIMEOUT $PYTHON_RUN -m pytest $TEST_SCRIPT --comms $LAUNCHER --nworkers $NWORKERS >> $TEST_SCRIPT.$NPROCS'procs'-$LAUNCHER.$REG_TEST_OUTPUT_EXT 2>test.err
               fi
             else
               if [ "$LAUNCHER" = mpi ]; then
                 if [ "$RTEST_SHOW_OUT_ERR" = "true" ]; then
                   mpiexec -np $NPROCS $MPIEXEC_FLAGS $PYTHON_RUN $COV_LINE_PARALLEL $TEST_SCRIPT
                   test_code=$?
                 else
                   mpiexec -np $NPROCS $MPIEXEC_FLAGS $PYTHON_RUN $COV_LINE_PARALLEL $TEST_SCRIPT >> $TEST_SCRIPT.$NPROCS'procs'.$REG_TEST_OUTPUT_EXT 2>test.err
                   test_code=$?
                 fi
               else
                 if [ "$RTEST_SHOW_OUT_ERR" = "true" ]; then
                   $TIMEOUT $PYTHON_RUN $COV_LINE_PARALLEL $TEST_SCRIPT --comms $LAUNCHER --nworkers $NWORKERS
                   test_code=$?
                 else
                   $TIMEOUT $PYTHON_RUN $COV_LINE_PARALLEL $TEST_SCRIPT --comms $LAUNCHER --nworkers $NWORKERS >> $TEST_SCRIPT.$NPROCS'procs'-$LAUNCHER.$REG_TEST_OUTPUT_EXT 2>test.err
                   test_code=$?
                 fi
               fi
             fi
             reg_count_runs=$((reg_count_runs+1))
             test_end=$(current_time)
             test_time=$(total_time $test_start $test_end)

             if [ "$test_code" -eq "0" ]; then
               echo -e " ---Test $test_num: $TEST_SCRIPT using $LAUNCHER on $NPROCS processes ${pass_color} ...passed after ${test_time} seconds ${textreset}"
               reg_pass=$((reg_pass+1))
               #continue testing
             else
               echo -e " ---Test $test_num: $TEST_SCRIPT using $LAUNCHER on $NPROCS processes ${fail_color}  ...failed after ${test_time} seconds ${textreset}"
               code=$test_code #sh - currently stop on failure
               if [ $REG_STOP_ON_FAILURE != "true" ]; then
                 #Dump error to log file
                 echo -e "\nTest $test_num: $TEST_SCRIPT using $LAUNCHER on $NPROCS processes:\n" >>log.err
                 [ -e test.err ] && cat test.err >>log.err
               fi;
               reg_fail=$((reg_fail+1))
             fi;

             #If use sub-dirs - move this test's coverage files to regression dir where they can be merged with other tests
             #[ "$RUN_COV_TESTS" = "true" ] && mv .cov_reg_out.* ../

          fi; #if [ "$RUN_TEST" = "true" ];

        done #nprocs
      done #launcher

      [ $REG_STOP_ON_FAILURE = "true" ] && [ "$code" -ne "0" ] && cat test.err && break
      reg_count_tests=$((reg_count_tests+1))

    done #tests
    reg_end=$(current_time)
    reg_time=$(total_time $reg_start $reg_end)

    # ********* End Loop over regression tests *********

    cd $ROOT_DIR/$REG_TEST_SUBDIR

    #Create Coverage Reports ----------------------------------------------

    #Only if passed
    if [ "$code" -eq "0" ]; then

      echo -e "\n..Moving output files to output dir"
      if [ "$(ls -A output)" ]; then
        rm output/* #Avoid mixing test run results
      fi;

      #sh - shld active_runs be prefixed for each job
      filelist=(*.$REG_TEST_OUTPUT_EXT);   [ -e ${filelist[0]} ] && mv *.$REG_TEST_OUTPUT_EXT output/
      filelist=(*.npy);                    [ -e ${filelist[0]} ] && mv *.npy output/
      filelist=(*active_runs.txt);         [ -e ${filelist[0]} ] && mv *active_runs.txt output/

      if [ "$RUN_COV_TESTS" = true ]; then

        # Merge MPI coverage data for all ranks from regression tests and create html report in sub-dir

        # Must combine all if in sep sub-dirs will copy to dir above
        coverage combine .cov_reg_out.* #Name of coverage data file must match that in .coveragerc in reg test dir.
        coverage html
        echo -e "..Coverage HTML written to dir $REG_TEST_SUBDIR/cov_reg/"

        if [ "$RUN_UNIT_TESTS" = true ]; then

          #Combine with unit test coverage at top-level
          cd $ROOT_DIR/$COV_MERGE_DIR
          cp $ROOT_DIR/$UNIT_TEST_SUBDIR/.cov_unit_out .
          cp $ROOT_DIR/$UNIT_TEST_NOMPI_SUBDIR/.cov_unit_out2 .
          cp $ROOT_DIR/$UNIT_TEST_LOGGER_SUBDIR/.cov_unit_out3 .
          cp $ROOT_DIR/$REG_TEST_SUBDIR/.cov_reg_out .

          #coverage combine --rcfile=.coverage_merge.rc .cov_unit_out .cov_reg_out
          coverage combine .cov_unit_out .cov_unit_out2 .cov_unit_out3 .cov_reg_out #Should create .cov_merge_out - see .coveragerc
          coverage html #Should create cov_merge/ dir
          echo -e "..Combined Unit Test/Regression Test Coverage HTML written to dir $COV_MERGE_DIR/cov_merge/"

        else

          # Still need to move reg cov results to COV_MERGE_DIR
          cd $ROOT_DIR/$COV_MERGE_DIR
          cp $ROOT_DIR/$REG_TEST_SUBDIR/.cov_reg_out .

          coverage combine .cov_reg_out
          coverage html
          echo -e "..Combined Regression Test Coverage HTML written to dir $COV_MERGE_DIR/cov_merge/"
        fi;
      fi;
    fi;

    #All reg tests - summary ----------------------------------------------
    if [ "$code" -eq "0" ]; then
      echo
      #tput bold;tput setaf 2

      if [ "$REG_USE_PYTEST" != true ]; then
        #sh - temp formatting similar(ish) to pytest - update in python (as with timing)
        #tput bold;tput setaf 4; echo -e "***Note***: temporary formatting/timing ......"

        summ_line="$reg_pass passed in $reg_time seconds"
        tput bold;tput setaf 2;
        print_summary_line $summ_line
        tput sgr 0
      fi;

      tput bold;tput setaf 2;echo -e "\nRegression tests passed ..."
      tput sgr 0
      echo
    else
      if [ $REG_STOP_ON_FAILURE != "true" ]; then
        echo -e ""
        if [ "$RTEST_SHOW_OUT_ERR" != "true" ]; then
          echo -e "\n..see error log at $REG_TEST_SUBDIR/log.err"
        fi
        summ_line="$reg_fail failed, $reg_pass passed in $reg_time seconds"
        tput bold;tput setaf 1;
        print_summary_line $summ_line
        tput sgr 0
      fi;
      echo
      tput bold;tput setaf 1;echo -e "\nAbort $RUN_PREFIX: Regression tests failed (exit code $code)";tput sgr 0
      echo
      exit $code
    fi;

  fi; #$RUN_REG_TESTS

  # Run Code standards Tests -----------------------------------------
  cd $ROOT_DIR
  if [ "$RUN_PEP_TESTS" = true ]; then
    tput bold;tput setaf 6
    echo -e "\n$RUN_PREFIX --$PYTHON_RUN: Running PEP tests - All python src below $PEP_SCOPE"
    tput sgr 0
    pytest --$PYTHON_PEP_STANDARD $ROOT_DIR/$PEP_SCOPE

    code=$?
    if [ "$code" -eq "0" ]; then
      echo
      tput bold;tput setaf 2; echo "PEP tests passed. Continuing...";tput sgr 0
      echo
    else
      echo
      tput bold;tput setaf 1;echo -e "Abort $RUN_PREFIX: PEP tests failed: $code";tput sgr 0
       exit $code #return pytest exit code
    fi;
  fi;

  # ------------------------------------------------------------------
  tput bold;tput setaf 2; echo -e "\n$RUN_PREFIX --$PYTHON_RUN: All tests passed\n"; tput sgr 0
  exit 0
else
  tput bold;tput setaf 1; echo -e "Abort $RUN_PREFIX:  Project root dir not found"; tput sgr 0
  exit 1
fi

#!/bin/bash
#SBATCH -J libE_test
#SBATCH -N 4
#SBATCH -p knlall
#SBATCH -A <my_project>
#SBATCH -o tlib.%j.%N.out
#SBATCH -e tlib.%j.%N.error
#SBATCH -t 01:00:00

# Launch script that runs in distributed mode with mpi4py.
#   Workers are evenly spread over nodes and manager added to the first node.
#   Requires even distribution - either multiple workers per node or nodes per worker
#   Option for manager to have a dedicated node.
#   Use of MPI Executor will ensure workers co-locate tasks with workers
#   If node_list file is kept, this informs libe of resources. Else, libe auto-detects.

# User to edit these variables
export EXE=libE_calling_script.py
export NUM_WORKERS=4
export MANAGER_NODE=false # true = Manager has a dedicated node (assign one extra)
export USE_NODE_LIST=true # If false, allow libE to determine node_list from environment.

# As libE shares nodes with user applications allow fallback if contexts overrun.
unset I_MPI_FABRICS
export I_MPI_FABRICS_LIST=tmi,tcp
export I_MPI_FALLBACK=1

# If using in calling script (After N mins manager kills workers and exits cleanly)
export LIBE_WALLCLOCK=55

#-----------------------------------------------------------------------------
# Work out distribution
if [[ $MANAGER_NODE = "true" ]]; then
  WORKER_NODES=$(($SLURM_NNODES-1))
else
  WORKER_NODES=$SLURM_NNODES
fi

if [[ $NUM_WORKERS -ge $WORKER_NODES ]]; then
  SUB_NODE_WORKERS=true
  WORKERS_PER_NODE=$(($NUM_WORKERS/$WORKER_NODES))
else
  SUB_NODE_WORKERS=false
  NODES_PER_WORKER=$(($WORKER_NODES/$NUM_WORKERS))
fi;
#-----------------------------------------------------------------------------

# A little useful information
echo -e "Manager process running on: $HOSTNAME"
echo -e "Directory is:  $PWD"

# Generate a node list with 1 node per line:
srun hostname | sort -u > node_list

# Add manager node to machinefile
head -n 1 node_list > machinefile.$SLURM_JOBID

# Add worker nodes to machinefile
if [[ $SUB_NODE_WORKERS = "true" ]]; then
  awk -v repeat=$WORKERS_PER_NODE '{for(i=0;i<repeat;i++)print}' node_list \
  >>machinefile.$SLURM_JOBID
else
  awk -v patt="$NODES_PER_WORKER" 'NR % patt == 1' node_list \
  >> machinefile.$SLURM_JOBID
fi;

if [[ $USE_NODE_LIST = "false" ]]; then
  rm node_list
  wait
fi;

# Put in a timestamp
echo Starting execution at: `date`

# To use srun
export SLURM_HOSTFILE=machinefile.$SLURM_JOBID

# The "arbitrary" flag should ensure SLURM_HOSTFILE is picked up
# cmd="srun --ntasks $(($NUM_WORKERS+1)) -m arbitrary python $EXE"
cmd="srun --ntasks $(($NUM_WORKERS+1)) -m arbitrary python $EXE $LIBE_WALLCLOCK"

echo The command is: $cmd
echo End PBS script information.
echo All further output is from the process being run and not the script.\n\n $cmd

$cmd

# Print the date again -- when finished
echo Finished at: `date`

#!/bin/bash -x
#COBALT -t 00:30:00
#COBALT -n 128
#COBALT -q default
#COBALT -A <project code>

# Script to run libEnsemble using multiprocessing on launch nodes.
# Assumes Conda environment is set up.

# To be run with central job management
# - Manager and workers run on launch node.
# - Workers submit tasks to the nodes in the job available.

# Name of calling script
export EXE=run_libe_forces.py

# Communication Method
export COMMS="--comms local"

# Number of workers.
export NWORKERS="--nworkers 128"

# Wallclock for libE (allow clean shutdown)
#export LIBE_WALLCLOCK=25 # Optional if pass to script

# Name of Conda environment
export CONDA_ENV_NAME=<conda_env_name>

# Conda location - theta specific
# export PATH=/opt/intel/python/2017.0.035/intelpython35/bin:$PATH
# export LD_LIBRARY_PATH=~/.conda/envs/<conda_env_name>/lib:$LD_LIBRARY_PATH
export PMI_NO_FORK=1 # Required for python kills on Theta

export LIBE_PLOTS=true # Require plot scripts in $PLOT_DIR (see at end)
export PLOT_DIR=..

# Unload Theta modules that may interfere with job monitoring/kills
module unload trackdeps
module unload darshan
module unload xalt

# Activate conda environment
export PYTHONNOUSERSITE=1
. activate $CONDA_ENV_NAME

# Launch libE
#python $EXE $NUM_WORKERS $LIBE_WALLCLOCK > out.txt 2>&1
#python $EXE $NUM_WORKERS > out.txt 2>&1
python $EXE $COMMS $NWORKERS > out.txt 2>&1

if [[ $LIBE_PLOTS = "true" ]]; then
  python $PLOT_DIR/plot_libe_calcs_util_v_time.py
  python $PLOT_DIR/plot_libe_runs_util_v_time.py
  python $PLOT_DIR/plot_libe_histogram.py
fi

# Script for running with Balsam on a local system.

# You need to have followed the instructions to install balsam and set-up/activate a database.
# https://github.com/balsam-alcf/balsam

# The running jobs can be seen inside the setup database dir <DIR>/data/libe_workflow/

# Name of calling script
export EXE=run_libe_forces.py

# Number of workers.
export NUM_WORKERS=2

# Name of working directory where Balsam places running jobs/output (inside the database directory)
export WORKFLOW_NAME=libe_workflow

export SCRIPT_ARGS=$NUM_WORKERS

export LIBE_WALLCLOCK=5 # Balsam timeout in mins

# Add calling script to Balsam database as app and job.
export THIS_DIR=$PWD
export SCRIPT_BASENAME=${EXE%.*}

# Delete any apps/jobs in Balsam
balsam rm apps --all --force
balsam rm jobs --all --force

# Register your libEnsemble calling script as an app.
balsam app --name $SCRIPT_BASENAME.app --exec $EXE --desc "Run $SCRIPT_BASENAME"

# Register as a job
balsam job --name job_$SCRIPT_BASENAME --workflow $WORKFLOW_NAME --application $SCRIPT_BASENAME.app --args $SCRIPT_ARGS --wall-time-minutes $LIBE_WALLCLOCK --num-nodes 1 --ranks-per-node $((NUM_WORKERS+1)) --url-out="local:/$THIS_DIR" --stage-out-files="*.out *.txt *.log" --url-in="local:/$THIS_DIR/*" --yes

#Run job
balsam launcher --consume-all --job-mode=mpi --num-transition-threads=1

#!/bin/bash -x
#SBATCH --job-name=libE-test
#SBATCH --account=STARTUP-USERNAME
#SBATCH --nodes=3
#SBATCH --gres=gpu:1
#SBATCH --time=00:45:00

# Make sure conda and environment are loaded and activated before sbatch

module load gcc
module load cuda/11.0.2-4szlv2t

export EXE=run_libe_ddmd.py
export NUM_WORKERS=3

export PYTHONNOUSERSITE=1

python $EXE --comms local --nworkers $NUM_WORKERS

echo The command is: $cmd
echo End PBS script information.
echo All further output is from the process being run and not the script.\n\n

$cmd

# Print the date again -- when finished
echo Finished at: `date`

#!/bin/bash
#SBATCH -J libE_test_central
#SBATCH -N 5
#SBATCH -q debug
#SBATCH -A <my_project>
#SBATCH -o tlib.%j.%N.out
#SBATCH -e tlib.%j.%N.error
#SBATCH -t 01:00:00
#SBATCH -C knl

# Launch script for running in central mode with mpi4py.
#   libEnsemble will run on a dedicated node (or nodes).
#   The remaining nodes in the allocation will be dedicated to worker launched apps.
#   Use executor with auto-resources=True and central_mode=True.

# User to edit these variables
export EXE=libE_calling_script.py
export NUM_WORKERS=4
export I_MPI_FABRICS=shm:ofi  # Recommend OFI

# Ensure anaconda Python module is loaded
module load python/3.7-anaconda-2019.07

# If libensemble is installed under common (set to your install location and python version)
export PYTHONPATH=/global/common/software/<my_project>/<user_name>/packages/lib/python3.7/site-packages:$PYTHONPATH

# Overcommit will allow ntasks up to the no. of contexts on one node (eg. 320 on Bebop)
srun --overcommit --ntasks=$(($NUM_WORKERS+1)) --nodes=1 python $EXE

# To use local mode instead of mpi4py (with parse_args())
# python calling_script.py --comms local --nworkers $NUM_WORKERS

#!/bin/bash

export EXE=script_test_balsam_hworld.py
export NUM_WORKERS=2
export WORKFLOW_NAME=libe_test-balsam
export LIBE_WALLCLOCK=3
export SCRIPT_BASENAME=script_test_balsam_hworld
export BALSAM_DB_PATH=$HOME/test-balsam
source balsamactivate test-balsam

# Refresh DB
balsam rm apps --all --force
balsam rm jobs --all --force

# Submit script_test_balsam_hworld as app
balsam app --name $SCRIPT_BASENAME.app --exec $EXE --desc "Run $SCRIPT_BASENAME"

# Submit job based on script_test_balsam_hworld app
balsam job --name job_$SCRIPT_BASENAME --workflow $WORKFLOW_NAME --application $SCRIPT_BASENAME.app --wall-time-minutes $LIBE_WALLCLOCK --num-nodes 1 --ranks-per-node $((NUM_WORKERS+1)) --url-out="local:/$PWD" --stage-out-files="*.out *.txt *.log" --url-in="local:/$PWD/*" --yes

#!/bin/bash -x
#BSUB -P <yourProjectID>
#BSUB -J libe_mproc
#BSUB -W 00:30
#BSUB -nnodes 4
#BSUB -alloc_flags "smt1"

# Script to run libEnsemble using multiprocessing on launch nodes.
# Assumes Conda environment is set up.

# To be run with central job management
# - Manager and workers run on launch node.
# - Workers submit tasks to the nodes in the job available.

# Name of calling script-
export EXE=run_libensemble_on_warpx.py

# Communication Method
export COMMS="--comms local"

# Number of workers.
export NWORKERS="--nworkers 24"

# Wallclock for libE. Slightly smaller than job wallclock
#export LIBE_WALLCLOCK=15 # Optional if pass to script

# Name of Conda environment
export CONDA_ENV_NAME=libensemble

export LIBE_PLOTS=true # Require plot scripts in $PLOT_DIR (see at end)
export PLOT_DIR=..

# Need these if not already loaded

# module load python
# module load gcc
# module load cuda

module unload xalt

# Activate conda environment
export PYTHONNOUSERSITE=1
. activate $CONDA_ENV_NAME

# hash -d python # Check pick up python in conda env
hash -r # Check no commands hashed (pip/python...)

# Launch libE.
#python $EXE $NUM_WORKERS $LIBE_WALLCLOCK > out.txt 2>&1
python $EXE $COMMS $NWORKERS > out.txt 2>&1

if [[ $LIBE_PLOTS = "true" ]]; then
  python $PLOT_DIR/plot_libe_calcs_util_v_time.py
  python $PLOT_DIR/plot_libe_runs_util_v_time.py
  python $PLOT_DIR/plot_libe_histogram.py
fi

# Source this once in env you will run in (e.g. On MOM node on Theta)

#Where you want your Balam database to be
export BALSAM_DB_PATH=~/database_sqlite

#Create a new database is not setup.
if [[ ! -d $BALSAM_DB_PATH ]]; then
# if [[ ! -f $BALSAM_DB_PATH/dbwriter_address ]]; #Ensures a database - may only be sql though
  echo -e '\nCreating database at $BALSAM_DB_PATH'
  balsam init $BALSAM_DB_PATH --db-type sqlite3
fi;

#Ensure no existing database server running - and refresh
balsam dbserver --stop
balsam dbserver --reset $BALSAM_DB_PATH
balsam dbserver --start

echo -e '\nHint: Use <balsam which> to get info on current database'

#!/bin/bash -x
#COBALT -t 30
#COBALT -O libE_MPI_balsam
#COBALT -n 5
#COBALT -q debug-flat-quad # Up to 8 nodes only # Use default for >=128 nodes
#COBALT -A <project code>

# Script to launch libEnsemble using Balsam.
#   Assumes Conda environment is set up.
#   Requires Balsam is installed and a database initialized.

# To be run with central job management
# - Manager and workers run on one node (or a dedicated set of nodes).
# - Workers submit tasks to the rest of the nodes in the pool.

# Name of calling script
export EXE=libE_calling_script.py

# Number of workers.
export NUM_WORKERS=4

# Number of nodes to run libE
export LIBE_NODES=1

# Balsam wall-clock in minutes - make few mins smaller than batch wallclock
export BALSAM_WALLCLOCK=25

# Name of working directory within database where Balsam places running jobs/output
export WORKFLOW_NAME=libe_workflow

# Wall-clock in mins for libE (allow clean shutdown).
# Script must be set up to receive as argument.
export LIBE_WALLCLOCK=$(($BALSAM_WALLCLOCK-3))

# libEnsemble calling script arguments (some alternatives shown)

# No args. All defined in calling script
export SCRIPT_ARGS=''

# If calling script takes wall-clock as positional argument.
# export SCRIPT_ARGS="$LIBE_WALLCLOCK"

# Name of Conda environment
export CONDA_ENV_NAME=<conda_env_name>

# Name of database
export BALSAM_DB_NAME=<dbase_name>  # default - to use default database.

# Required for killing tasks from workers on Theta
export PMI_NO_FORK=1

# Unload Theta modules that may interfere with job monitoring/kills
module unload trackdeps
module unload darshan
module unload xalt

# Obtain Conda PATH from miniconda-3/latest module
CONDA_DIR=/soft/datascience/conda/miniconda3/latest/bin

# Ensure environment isolated
export PYTHONNOUSERSITE=1

# Activate conda environment
source $CONDA_DIR/activate $CONDA_ENV_NAME

# Activate Balsam database
source balsamactivate $BALSAM_DB_NAME

# Currently need at least one DB connection per worker (for postgres).
if [[ $NUM_WORKERS -gt 100 ]]
then
   #Add a margin
   echo -e "max_connections=$(($NUM_WORKERS+20)) #Appended by submission script" \
   >> $BALSAM_DB_PATH/balsamdb/postgresql.conf
fi
wait

# Make sure no existing apps/tasks registered to database
balsam rm apps --all --force
balsam rm jobs --all --force
wait
sleep 3

# Add calling script to Balsam database as app and job.
export THIS_DIR=$PWD
export SCRIPT_BASENAME=${EXE%.*}

# Multiple nodes
export LIBE_PROCS=$((NUM_WORKERS+1))  # Manager and workers
export PROCS_PER_NODE=$((LIBE_PROCS/LIBE_NODES))  # Must divide evenly

balsam app --name $SCRIPT_BASENAME.app --exec $EXE --desc "Run $SCRIPT_BASENAME"

balsam job --name job_$SCRIPT_BASENAME --workflow $WORKFLOW_NAME \
           --application $SCRIPT_BASENAME.app --args $SCRIPT_ARGS \
           --wall-time-minutes $LIBE_WALLCLOCK \
           --num-nodes $LIBE_NODES --ranks-per-node $PROCS_PER_NODE \
           --url-out="local:/$THIS_DIR" --stage-out-files="*.out *.txt *.log" \
           --url-in="local:/$THIS_DIR/*" --yes

# Hyper-thread libE (note this will not affect HT status of user calcs - only libE itself)
# E.g. Running 255 workers and one manager on one libE node.
# balsam job --name job_$SCRIPT_BASENAME --workflow $WORKFLOW_NAME \
#            --application $SCRIPT_BASENAME.app --args $SCRIPT_ARGS \
#            --wall-time-minutes $LIBE_WALLCLOCK \
#            --num-nodes 1 --ranks-per-node 256 --threads-per-core 4 \
#            --url-out="local:/$THIS_DIR" --stage-out-files="*.out *.txt *.log" \
#            --url-in="local:/$THIS_DIR/*" --yes

# Run job
balsam launcher --consume-all --job-mode=mpi --num-transition-threads=1

wait
source balsamdeactivate

#!/bin/bash
#SBATCH -J libE_small_test
#SBATCH -A <myproject_g>
#SBATCH -C gpu
#SBATCH --time 10
#SBATCH --nodes 2

export MPICH_GPU_SUPPORT_ENABLED=1
export SLURM_EXACT=1
export SLURM_MEM_PER_NODE=0

python run_libe_forces.py --comms local --nworkers 8

#!/bin/bash
#SBATCH -J libE_test_central
#SBATCH -N 5
#SBATCH -p RM
#SBATCH -A <my_project>
#SBATCH -o tlib.%j.%N.out
#SBATCH -e tlib.%j.%N.error
#SBATCH -t 00:30:00

# Launch script for running in central mode with mpi4py.
#   libEnsemble will run on a dedicated node (or nodes).
#   The remaining nodes in the allocation will be dedicated to worker launched apps.
#   Initialize Executor with auto-resources=True and central_mode=True.

# User to edit these variables
export EXE=libE_calling_script.py
export NUM_WORKERS=4

mpirun -np $(($NUM_WORKERS+1)) -ppn $(($NUM_WORKERS+1)) python $EXE

# To use local mode instead of mpi4py (with parse_args())
# python $EXE --comms local --nworkers $NUM_WORKERS

#!/bin/bash

# Building with OpenMP for CPU

# GCC for current host (generally not as good at vectorization as intel).
gcc -O3 -fopenmp -march=native -o mini_forces.x mini_forces.c -lm

# Intel (fat binary covering vectorization for hswell/bdwell/skylake/knl)
# icc -O3 -qopenmp -axAVX,CORE-AVX2,CORE-AVX512,MIC-AVX512 -o mini_forces.x mini_forces.c

# Intel with vectorization for current host (no cross-compilation).
# icc -O3 -qopenmp -xhost -o mini_forces.x mini_forces.c

# xl
# xlc_r -O3 -qsimd=auto -qsmp=omp -o mini_forces.x mini_forces.c

# ----------------------------------------------

# Building with OpenMP for target device (e.g. GPU)
# Need to toggle to OpenMP target directive in mini_forces.c.

# xl
# xlc_r -O3 -qsmp=omp -qoffload -o mini_forces.x mini_forces.c

# IRIS node (Intel Gen9 GPU)
# icx -g -fiopenmp -fopenmp-targets=spir64 -o mini_forces.x mini_forces.c

#!/bin/bash -x
#BSUB -P <project code>
#BSUB -J libe_mproc
#BSUB -W 30
#BSUB -nnodes 4
#BSUB -alloc_flags "smt1"

# Script to run libEnsemble using multiprocessing on launch nodes.
# Assumes Conda environment is set up.

# To be run with central job management
# - Manager and workers run on launch node.
# - Workers submit tasks to the compute nodes in the allocation.

# Name of calling script-
export EXE=libE_calling_script.py

# Communication Method
export COMMS="--comms local"

# Number of workers.
export NWORKERS="--nworkers 4"

# Wallclock for libE.  (allow clean shutdown)
export LIBE_WALLCLOCK=25 # Optional if pass to script

# Name of Conda environment
export CONDA_ENV_NAME=<conda_env_name>

# Need these if not already loaded
# module load python
# module load gcc/4.8.5

# Activate conda environment
export PYTHONNOUSERSITE=1
. activate $CONDA_ENV_NAME

# hash -d python # Check pick up python in conda env
hash -r # Check no commands hashed (pip/python...)

# Launch libE
# python $EXE $NUM_WORKERS > out.txt 2>&1  # No args. All defined in calling script
# python $EXE $COMMS $NWORKERS > out.txt 2>&1  # If calling script is using parse_args()
python $EXE $LIBE_WALLCLOCK $COMMS $NWORKERS > out.txt 2>&1 # If calling script takes wall-clock as positional arg.

##!/bin/bash

# If a prosgres process is running, ssh to node and kill process
export uname=$USER
export appname='postgres \-D'

# Check 6 login nodes
for i in {1..6}
do
  hname=thetalogin$i
  if [[ "$HOSTNAME" = $hname  ]]
  then
    hostname; ps aux|grep $uname|grep "$appname"
  else
    ssh $hname "hostname; ps aux|grep $uname|grep '$appname'"
  fi
done

# Check 3 MOM nodes
for i in {1..3}
do
  hname=thetamom$i
  if [[ "$HOSTNAME" = $hname  ]]
  then
    hostname; ps aux|grep $uname|grep '$appname'
  else
    ssh $hname "hostname; ps aux|grep $uname|grep '$appname'"
  fi
done

#theta
export PATH=/opt/intel/python/2017.0.035/intelpython35/bin:$PATH

export LD_LIBRARY_PATH=~/.conda/envs/balsam/lib:$LD_LIBRARY_PATH

#My addition - takes non-conda local dirs out of sys path - to help isolate conda
export PYTHONNOUSERSITE=1

. activate balsam #Should be a check here.

#!/bin/bash
#SBATCH -J libE_simple
#SBATCH -A <myproject>
#SBATCH -p <partition_name>
#SBATCH -C <constraint_name>
#SBATCH --time 10
#SBATCH --nodes 2

# Usually either -p or -C above is used.

# On some SLURM configurations, these ensure runs can share nodes
export SLURM_EXACT=1
export SLURM_MEM_PER_NODE=0

python run_libe_forces.py --comms local --nworkers 8

#!/bin/bash

# Building flat MPI

# GCC
mpicc -O3 -o forces.x forces.c -lm

# Intel
# mpiicc -O3 -o forces.x forces.c

# Cray
# cc -O3 -o forces.x forces.c

# ----------------------------------------------

# Building with OpenMP for CPU

# GCC
# mpicc -O3 -fopenmp -o forces.x forces.c -lm

# Intel
# mpiicc -O3 -qopenmp -o forces.x forces.c

# Cray / Intel (for CCE OpenMP is recognized by default)
# cc -O3 -qopenmp -o forces.x forces.c

# xl
# xlc_r -O3 -qsmp=omp -o forces.x forces.c

# ----------------------------------------------

# Building with OpenMP for target device (e.g. GPU)
# Need to toggle to OpenMP target directive in forces.c.

# xl
# xlc_r -O3 -qsmp=omp -qoffload -o forces.x forces.c

# Nvidia (nvc) compiler with mpicc and on Cray system with target (Perlmutter)
# mpicc -O3 -fopenmp -mp=gpu -o forces_gpu.x forces_gpu.c
# cc -O3 -fopenmp -mp=gpu -target-accel=nvidia80 -o forces.x forces.c

# Spock/Crusher (AMD ROCm compiler)
# cc -I${ROCM_PATH}/include -L${ROCM_PATH}/lib -lamdhip64 -fopenmp -O3 -o forces.x forces.c

# Intel oneAPI (Clang based) Compiler (JIT compiled for device)
# mpiicx -O3 -fiopenmp -fopenmp-targets=spir64 -o forces.x forces.c

#!/bin/bash -x
#SBATCH --job-name=libE-test
#SBATCH --account=STARTUP-USERNAME
#SBATCH --nodes=2
#SBATCH --gres=gpu:2
#SBATCH --time=00:30:00

# Make sure conda and your environment are loaded and activated before sbatch

module load gcc
module load cuda/11.0.2-4szlv2t

unset I_MPI_FABRICS
export I_MPI_FABRICS_LIST=tmi,tcp
export I_MPI_FALLBACK=1

export EXE=run_libe_ddmd.py
export NUM_WORKERS=2
export MANAGER_NODE=false # true = Manager has a dedicated node (assign one extra)
export USE_NODE_LIST=true # If false, allow libE to determine node_list from environment.

# Activate conda environment
export PYTHONNOUSERSITE=1

#-----------------------------------------------------------------------------
# Work out distribution
if [[ $MANAGER_NODE = "true" ]]; then
  WORKER_NODES=$(($SLURM_NNODES-1))
else
  WORKER_NODES=$SLURM_NNODES
fi

if [[ $NUM_WORKERS -ge $WORKER_NODES ]]; then
  SUB_NODE_WORKERS=true
  WORKERS_PER_NODE=$(($NUM_WORKERS/$WORKER_NODES))
else
  SUB_NODE_WORKERS=false
  NODES_PER_WORKER=$(($WORKER_NODES/$NUM_WORKERS))
fi;
#-----------------------------------------------------------------------------

# A little useful information
echo -e "Manager process running on: $HOSTNAME"
echo -e "Directory is:  $PWD"

# Generate a node list with 1 node per line:
srun hostname | sort -u > node_list

# Add manager node to machinefile
head -n 1 node_list > machinefile.$SLURM_JOBID

# Add worker nodes to machinefile
if [[ $SUB_NODE_WORKERS = "true" ]]; then
  awk -v repeat=$WORKERS_PER_NODE '{for(i=0;i<repeat;i++)print}' node_list \
  >>machinefile.$SLURM_JOBID
else
  awk -v patt="$NODES_PER_WORKER" 'NR % patt == 1' node_list \
  >> machinefile.$SLURM_JOBID
fi;

if [[ $USE_NODE_LIST = "false" ]]; then
  rm node_list
  wait
fi;

# Put in a timestamp
echo Starting execution at: `date`

# To use srun
export SLURM_HOSTFILE=machinefile.$SLURM_JOBID

# The "arbitrary" flag should ensure SLURM_HOSTFILE is picked up
# cmd="srun --ntasks $(($NUM_WORKERS+1)) -m arbitrary python $EXE"
cmd="srun --ntasks $(($NUM_WORKERS+1)) -m arbitrary python $EXE $LIBE_WALLCLOCK"

echo The command is: $cmd
echo End PBS script information.
echo All further output is from the process being run and not the script.\n\n $cmd

$cmd

# Print the date again -- when finished
echo Finished at: `date`

if [[ -z $1 ]]
then
  echo -e "Need output dir name: ./clone NEW_DIR"
else
  NEWDIR=$1

  INPUTS="sim/ forces.c forces_simf.py \
          run_libe_forces.py forces.x \
          *.sh"
  # Take you there if source script.
  mkdir ../$NEWDIR && cp -rp $INPUTS ../$NEWDIR && cd ../$NEWDIR
fi

#!/bin/bash

# Building flat MPI

# GCC
mpicc -O3 -o forces.x forces.c -lm

# Intel
# mpiicc -O3 -o forces.x forces.c

# Cray
# cc -O3 -o forces.x forces.c

# ----------------------------------------------

# Building with OpenMP for CPU

# GCC
# mpicc -O3 -fopenmp -o forces.x forces.c -lm

# Intel
# mpiicc -O3 -qopenmp -o forces.x forces.c

# Cray / Intel (for CCE OpenMP is recognized by default)
# cc -O3 -qopenmp -o forces.x forces.c

# xl
# xlc_r -O3 -qsmp=omp -o forces.x forces.c

# ----------------------------------------------

# Building with OpenMP for target device (e.g. GPU)
# Need to toggle to OpenMP target directive in forces.c.

# xl
# xlc_r -O3 -qsmp=omp -qoffload -o forces.x forces.c

# IRIS node (Intel Gen9 GPU)
# env MPICH_CC=icx mpigcc -g -fiopenmp -fopenmp-targets=spir64 -o forces.x forces.c

#!/usr/bin/env bash

set -e #Exit on error

# User inputs =================================================================================================

export LIBE_DIR=/home/shudson/balsam-libe-test/libensemble
#export BALSAM_DIR=/home/shudson/balsam-libe-test/hpc-edge-service

#Location of main calling scripts
export WORK_DIR=$LIBE_DIR/code/tests/balsam_tests

export SIM_DIR=$LIBE_DIR/code/examples/sim_funcs
export SIM_APP=helloworld.py

#For host code
export NUM_NODES=1
export RANKS_PER_NODE=4

export JOB_LIST="test_balsam_1__runjobs.py \
                 test_balsam_2__workerkill.py \
                 test_balsam_3__managerkill.py"

# Set up job ==================================================================================================

#NOTE: This does not have to be done in the interactive session - as long as balsam conda env is loaded

#Check clean
balsam rm apps --all
balsam rm jobs --all

#Add user apps - eg helloworld.py
SIM_APP_NAME=${SIM_APP%.*}
balsam app --name $SIM_APP_NAME --exec $SIM_DIR/$SIM_APP --desc "Run $SIM_APP_NAME"

#Add apps and jobs for tests
for LIBE_APP in $JOB_LIST
do
  LIBE_APP_NAME=${LIBE_APP%.*}
  balsam app --name $LIBE_APP_NAME --exec $WORK_DIR/$LIBE_APP --desc "Run $LIBE_APP_NAME"

  #Add jobs
  balsam job --name job_$LIBE_APP_NAME --workflow libe_workflow --application $LIBE_APP_NAME \
             --wall-min 1 --num-nodes $NUM_NODES --ranks-per-node $RANKS_PER_NODE \
             --url-out="local:$WORK_DIR" \
             --stage-out-files="${JOB_NAME}*" \
             --yes

  #Add dependency so jobs run one at a time ....
  # *** Currently all jobs added will run simultaneously - kills may be an issue there

done

echo -e "\nListing apps:"
balsam ls apps

echo -e "\nListing jobs:"
balsam ls jobs

#Run launcher in either interactive session or via script
echo -e "\nTo launch jobs run: balsam launcher --consume-all"

#!/bin/bash -x
#COBALT -t 00:30:00
#COBALT -O libE_mproc_MOM
#COBALT -n 4
#COBALT -q debug-flat-quad # Up to 8 nodes only
##COBALT -q default # For large jobs >=128 nodes
##COBALT -A <project code>

# Script to run libEnsemble using multiprocessing on launch nodes.
# Assumes Conda environment is set up.

# To be run with central job management
# - Manager and workers run on launch node.
# - Workers submit tasks to the compute nodes in the allocation.

# Name of calling script
export EXE=libE_calling_script.py

# Communication Method
export COMMS="--comms local"

# Number of workers.
export NWORKERS="--nworkers 4"

# Wallclock for libE (allow clean shutdown)
export LIBE_WALLCLOCK=25 # Optional if pass to script

# Name of Conda environment
export CONDA_ENV_NAME=<conda_env_name>

# Conda location - theta specific
export PATH=/opt/intel/python/2017.0.035/intelpython35/bin:$PATH
export LD_LIBRARY_PATH=~/.conda/envs/$CONDA_ENV_NAME/lib:$LD_LIBRARY_PATH
export PMI_NO_FORK=1 # Required for python kills on Theta

# Unload Theta modules that may interfere with job monitoring/kills
module unload trackdeps
module unload darshan
module unload xalt

# Activate conda environment
export PYTHONNOUSERSITE=1
. activate $CONDA_ENV_NAME

# Launch libE
# python $EXE $NUM_WORKERS > out.txt 2>&1  # No args. All defined in calling script
# python $EXE $COMMS $NWORKERS > out.txt 2>&1  # If calling script is using parse_args()
python $EXE $LIBE_WALLCLOCK $COMMS $NWORKERS > out.txt 2>&1 # If calling script takes wall-clock as positional arg.

# xSDK Community Policy Compatibility for libEnsemble

This document summarizes the efforts of libEnsemble
to achieve compatibility with the xSDK community policies.

**Website:** https://github.com/Libensemble/libensemble

### Mandatory Policies

[General libEnsemble Note](#liben-note)

| Policy                 |Support| Notes                   |
|------------------------|-------|-------------------------|
|**M1.** Support xSDK community GNU Autoconf or CMake options. |N/A| libEnsemble is a Python package and provides a `setup.py` file for installation. This is compatible with Python's built-in installation feature (`python setup.py install`) and with the ubiquitous `pip` installer. libEnsemble is also in the Spack repository and can be installed with `spack install py-libensemble`. GNU Autoconf or CMake are unsuitable for a Python package.
|**M2.** Provide a comprehensive test suite for correctness of installation verification. |Full| libEnsemble has a test suite that includes both unit tests and regression tests that are run on every push to GitHub via [Travis CI](https://travis-ci.org/Libensemble/libensemble). In addition to this test suite, further scaling tests are manually run on HPC platforms including Cori, Theta, and Summit.
|**M3.** Employ user-provided MPI communicator (no MPI_COMM_WORLD). |Full|libEnsemble takes an MPI communicator as an option; if libEnsemble is configured for MPI mode, this provided communicator will be employed. If no communicator is given, a duplicate of MPI_COMM_WORLD is taken as a default. |
|**M4.** Give best effort at portability to key architectures (standard Linux distributions, GNU, Clang, vendor compilers, and target machines at ALCF, NERSC, OLCF). |Full| libEnsemble is tested regularly, including prior to every release, on ALCF (Theta), OLCF (Summit) and NERSC (Cori) platforms. [M4 details](#m4-details)|
|**M5.** Provide a documented, reliable way to contact the development team. |Full| The libEnsemble team can be contacted through: 1) The public [issues page on GitHub](https://github.com/Libensemble/libensemble/issues). 2) [Slack](https://libensemble.slack.com). 3) The public email list libensemble@mcs.anl.gov. |
|**M6.** Respect system resources and settings made by other previously called packages (e.g., signal handling). |Full| libEnsemble does not modify system resources or settings. |
|**M7.** Come with an open source (BSD style) license. |Full| libEnsemble uses a 3-clause BSD license stated in the `LICENSE` file in the top level of the GitHub repository. |
|**M8.** Provide a runtime API to return the current version number of the software. |Full| The version can be returned within Python via: `libensemble.__version__`|
|**M9.** Use a limited and well-defined symbol, macro, library, and include file name space. |Full| All libEnsemble symbols (e.g., functions, variables, modules, packages) begin with the prefix `libensemble.`. This prevents any namespace conflicts.|
|**M10.** Provide an xSDK team accessible repository (not necessarily publicly available). |Full| The libEnsemble repository is public and can be found at https://github.com/Libensemble/libensemble. Gitflow is used, along with pull requests, whereby only those with administrator privileges can accept pull requests into the master or develop branches. The workflow guidelines are provided in a `CONTRIBUTING.rst` file at the top level of the repository and a release process is given in the documentation. |
|**M11.** Have no hardwired print or IO statements that cannot be turned off. |Full| All output from the libEnsemble core package, except for the raising of exceptions, is routed through a libEnsemble logger, which is isolated from the Python root logger. Log messages of type `MANAGER_WARNING` or above are duplicated to standard error by default to ensure they are not missed. This can be turned off through the API. The API also allows the user to change the logging verbosity level and the name of the log file. This would allow a user, for example, to append logging to an existing log file, or to keep it separate. libEnsemble contains no interactive input. libEnsemble creates the files `ensemble.log` and `libE_stats.txt`, but the creation of these files can be preempted. [M11 details](#m11-details)|
|**M12.** For external dependencies, allow installing, building, and linking against an outside copy of external software. |Full| libEnsemble does not contain any other package's source code within. Note that Python packages are imported using the conventional `sys.path` system. Alternative instances of a package can be used by, for example, including in the `PYTHONPATH` environment variable.|
|**M13.** Install headers and libraries under \<prefix\>/include and \<prefix\>/lib. |Full| The standard Python installation is used for Python dependencies. This installs external Python packages under `<install-prefix>/lib/python<X.Y>/site-packages/` When installed through Spack, the `<install-prefix>` is specific to each Python package. This is added to `PYTHONPATH` when the Spack module for that library is loaded.|
|**M14.** Be buildable using 64 bit pointers. 32 bit is optional. |Full| There is no explicit use of pointers in libEnsemble, as Python handles pointers internally and depends on the install of Python (e.g., CPython), which will generally be 64-bit on supported systems. |
|**M15.** All xSDK compatibility changes should be sustainable. |Full| The xSDK-compatible package is in the standard release path. All the changes here should be sustainable. |
|**M16.** The package must support production-quality installation compatible with the xSDK install tool and xSDK metapackage. |Full|libEnsemble configure and install has full support from Spack. |

M4 details <a id="m4-details"></a>: libEnsemble is a Python code and so does
not directly use compilers. It does, however, use NumPy, SciPy and mpi4py which
use compiled extensions. The current CI tests of libEnsemble use the standard
CPython compatible builds of these extensions (which are built using the GNU
compilers). libEnsemble is also regularly tested using the Intel distribution
for Python.

libEnsemble is supported on Linux platforms and macOS. Windows platforms are
currently not supported.

M11 details <a id="m11-details"></a>: Note: The sub-packages in the libensemble
directory structure such as `sim_specs` and `gen_specs` may contain print
statements. These are considered examples for users, rather than core
libEnsemble packages.

A special exception exists in the `node_resources.py` module; part of
libEnsemble's resource detection infrastructure. The routine
`_print_local_cpu_resources()` can be launched by libEnsemble to probe
resources on a target node, and the output of this independent program is
captured by libEnsemble.

### Recommended Policies

| Policy                 |Support| Notes                   |
|------------------------|-------|-------------------------|
|**R1.** Have a public repository. |Full| Yes (see M10 above). |
|**R2.** Possible to run test suite under valgrind in order to test for memory corruption issues. |Full| It is possible to run the test suite under Valgrind. While libEnsemble is Python code, this may be useful for compiled extensions that are imported. PYTHONMALLOC=malloc must be set on the run line. CPython also provides a suppression file.|
|**R3.** Adopt and document consistent system for error conditions/exceptions. |Full| libEnsemble defines and raises exceptions according to module. All exceptions on workers are passed to the manager for processing.  Warnings are handled by the logger. [R3 details](#r3-details)||
|**R4.** Free all system resources acquired as soon as they are no longer needed. |Full| Python has built-in garbage collection that frees memory when it becomes unreferenced. When opening files, wherever possible, `with` expressions or `try/finally` blocks are used to ensure file handles are closed, even in the case of an error.|
|**R5.** Provide a mechanism to export ordered list of library dependencies. |Full| The dependencies for libEnsemble are given in `setup.py` and when pip install or pip setup.py egg_info are run, a file is created `libensemble.egg-info/requires.txt` containing the list of required and optional dependencies. If installing through pip, these will automatically be installed if they do not exist (`pip install libensemble` installs req. dependencies, while `pip install libensemble[extras]` installs both required and optional dependencies.|
|**R6.** Document versions of packages that it works with or depends upon, preferably in machine-readable form.  |Full| Dependencies are given in the documentation. In some cases, this includes a lower bound on the version number. These dependencies are also specified in the Spack package, and automatically resolved during installation.|
|**R7.** Have README, SUPPORT, LICENSE, and CHANGELOG files in top directory.  |Full| These files are present in the top directory.|

R3 details <a id="r3-details"></a>: libEnsemble catches all exceptions
(explicitly raised and unexpected) from the manager and worker processes at the
libEnsemble level, resulting in libEnsemble dumping the key ensemble state to
files. In `mpi4py` mode, the default is to then call MPI_ABORT to prevent a
hang. However, this can be turned off (via the `libE_specs` argument). In the
case it is turned off, or if other communication modes are used, the exception
is then raised. The user can in turn catch these exceptions from their calling
script.

libEnsemble Note <a id="liben-note"></a>: The nature of libEnsemble's
interoperability with other libraries is different from typical xSDK libraries.
libEnsemble is a Python code and interaction with other libraries may take
several forms. These include: libEnsemble calling other libraries through
Python bindings, libEnsemble launching applications (possibly providing a
sub-communicator), libEnsemble being called from a Python level infrastructure,
libEnsemble being launched as part of a campaign level workflow, or libEnsemble
potentially being activated via a system call or embedded interpreter; a more
unconventional approach. This is, therefore, a good opportunity to consider
interoperability from a Python and broader workflow perspective.
